/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
</DEPENDENCIES>
*/
DragWidget.prototype             = new DomletCtr();
DragWidget.prototype.constructor = DragWidget;
DragWidget.superclass            = DomletCtr.prototype;
function DragWidget(sId, sDragWidgetDomId, sDragWidgetLugDomId)
{
  if (sId) { this.init(sId, sDragWidgetDomId, sDragWidgetLugDomId); }
}
DragWidget.prototype.init = function(sId, sDragWidgetDomId, sDragWidgetLugDomId)
{
  ;   
  this.sId = sId;
  DragWidget.superclass.init.call(this, sDragWidgetDomId, sId, null);
  this.oDragWidget = document.getElementById(sDragWidgetDomId);
  this.sDragWidgetDomId = sDragWidgetDomId;
  if (this.oDragWidget == null)
  {
    ;
  }
  this.oDragWidgetLug = document.getElementById(sDragWidgetLugDomId);
  this.sDragWidgetLugDomId = sDragWidgetLugDomId;
  if (this.oDragWidgetLug == null)
  {
    ;
    this.sDragWidgetLugDomId = this.sDragWidgetDomId;
    this.oDragWidgetLug = this.oDragWidget;
  }
  this.addDomlet(new Domlet(
    this.sDragWidgetLugDomId,     
    this.name,      
    this.parent,    
    new Array('mousedown', 'mouseover', 'mouseout')) 
  )
  this.beginDragAction = null;
  this.endDragAction = null;
  this.showOverAction = null;
  this.showOutAction = null;
  this.homeDragPosition = this.getPos();
  var me=this;
  this.mouseUpHandler = function(event)
  {
    ;
    if(me.endDragAction) me.endDragAction.invoke();
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEMOVE, me.mouseMoveHandler);
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEUP, me.mouseUpHandler);
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEOUT, me.mouseOutHandler);
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEOVER, me.mouseOverHandler);
    var point = me.getPos();
    var width = me.oDragWidget.offsetWidth;
    var height = me.oDragWidget.offsetHeight;
    var x = point.x;
    var y = point.y;
    if (x > 984)
        x = 984;
    else if ((x + width) < 105)
        x = 105 - width;
    if ((y + height) > 711)
        y = 711 - height;
    else if ((y + height) < 16)
        y = 16 - height;
    var newPoint = new Point(x,y);
    me.moveTo(newPoint);
  }
  this.mouseMoveHandler = function(event)
  {
    //;
    //;
    if (!me.inMouseMove)
    {
      if (Math.abs(event.clientX - me.mouseDownX) > 2 || Math.abs(event.clientY - me.mouseDownY) > 2 )
      {
        me.inMouseMove = true;
        me.beginDrag(event);
        me.lostDeltaX = event.clientX - me.mouseDownX;
        me.lostDeltaY = event.clientY - me.mouseDownY;
      }
    }
    if (me.inMouseMove)
    {
      var nX = event.clientX - me.deltaX + me.lostDeltaX;
      var nY = event.clientY - me.deltaY + me.lostDeltaY;
      me.moveTo(new Point(nX, nY));
    }
  }
  this.mouseOutHandler = function(event)
  {
    ;
    if (Browser.getId() == 'moz')
    {
        if ( event.explicitOriginalTarget.nodeName == 'HTML')
        {
          me.mouseUpHandler(event);
        }
    }
    else
    {
        if ( event.srcElement.tagName == 'BODY' )
        {
          me.mouseUpHandler(event);
        }
    }
  }
  this.mouseOverHandler = function(event)
  {
    if (Browser.getId() == 'ie')
    {
      if ( event.srcElement.tagName == 'BODY' )
      {
        me.mouseUpHandler(event);
      }
    }
  }
}
DragWidget.prototype.getId = function()
{
  //;
  return this.sId;
}
DragWidget.prototype.setBeginDragAction = function(action)
{
  ;
  this.beginDragAction = action;
}
DragWidget.prototype.setEndDragAction = function(action)
{
  ;
  this.endDragAction = action;
}
DragWidget.prototype.setShowOverAction = function(action)
{
  ;
  this.showOverAction = action;
}
DragWidget.prototype.setShowOutAction = function(action)
{
  ;
  this.showOutAction = action;
}
DragWidget.prototype.setVisibility = function(bVisibility)
{
  ;
  if( bVisibility )
  {
    this.oDragWidget.visibility = 'visible';
  }
  else
  {
    this.oDragWidget.visibility = 'hidden';
  }
}
DragWidget.prototype.getVisibleAction = function()
{
  ;
  return new ObjectMethodAction(this, "setVisibility", true);
}
DragWidget.prototype.getHomePositionAction = function()
{
  ;
  return new ObjectMethodAction(this, "moveToHomePosition", true);
}
DragWidget.prototype.getHiddenAction = function()
{
  ;
  return new ObjectMethodAction(this, "setVisibility", false);
}
DragWidget.prototype.eventFromChild = function(childName, eventType, event)
{
  ;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "mousedown" :
      ;
      this.mouseDownHandler(domlet, event);
      break;
    case "mouseover" :
      ;
      if(this.showOverAction) this.showOverAction.invoke();
      break;
    case "mouseout" :
      ;
      if(this.showOutAction) this.showOutAction.invoke();
      break;
  }
}
DragWidget.prototype.mouseDownHandler = function(domlet, event)
{
  ;
  this.mouseDownX = event.clientX;
  this.mouseDownY = event.clientY;
  this.inMouseMove = false;
  if (this.hotSpotToMousePositionOnClick)
  {
      var point = this.getPos();
      this.nHotSpotX = event.clientX - point.x;
      this.nHotSpotY = event.clientY - point.y;
  }
  Browser.setToplevel(this.oDragWidget);
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEMOVE, this.mouseMoveHandler);
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEUP, this.mouseUpHandler);
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEOUT, this.mouseOutHandler);
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEOVER, this.mouseOverHandler);
}
DragWidget.prototype.moveTo = function(pPoint)
{
  ;
  Browser.moveTo(this.oDragWidget, pPoint);
}
DragWidget.prototype.getPos = function()
{
  ;
  var point = new Point(0,0);
  Browser.getAbsPos(this.oDragWidget, point);
  return(point);
}
DragWidget.prototype.beginDrag = function(event)
{
  ;
  var point = this.getPos();
  this.deltaX = event.clientX - point.x;
  this.deltaY = event.clientY - point.y;
  if(this.beginDragAction) this.beginDragAction.invoke();
}
DragWidget.prototype.moveToHomePosition = function(event)
{
  ;
  var point = this.homeDragPosition;
  this.moveTo(point);
}
DragWidget.prototype.getSetVisibility = function(bVisible)
{
  ;
  return new ObjectMethodAction(this, "setVisibility", bVisible);
}
