/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
ImageToggleButton.prototype             = new DomletCtr();
ImageToggleButton.prototype.constructor = ImageToggleButton;
ImageToggleButton.superclass            = DomletCtr.prototype;
function ImageToggleButton(domId, imgNorm, imgNormMo, imgNormDisabled, imgPress, imgPressMo, imgPressDisabled, enabled, initPressed, name, parent)
{
    ;
    if (domId) 
    {
        this.init(domId, imgNorm, imgNormMo, imgNormDisabled, imgPress, imgPressMo, imgPressDisabled, enabled, initPressed, name, parent);
    }
} 
ImageToggleButton.prototype.init = function(domId, imgNorm, imgNormMo, imgNormDisabled, imgPress, imgPressMo, imgPressDisabled, enabled, initPressed, name, parent)
{
    ImageToggleButton.superclass.init.call(this, domId, name, parent);
    ;
    this.state = {
        down : false,          
        highlighted : false,   
        images : {             
            normal           : imgNorm,
            normalMouseover  : imgNormMo,
            normalDisabled   : imgNormDisabled,
            pressed          : imgPress,
            pressedMouseover : imgPressMo,
            pressedDisabled  : imgPressDisabled
        }
    };
    if (!this.state.images.normalMouseover)
        this.state.images.normalMouseover = this.state.images.normal;
    if (!this.state.images.normalDisabled)
        this.state.images.normalDisabled = this.state.images.normal;
    if (!this.state.images.pressedMouseover)
        this.state.images.pressedMouseover = this.state.images.pressed;
    if (!this.state.images.pressedDisabled)
        this.state.images.pressedDisabled = this.state.images.pressed;
    this.state.pressed = ((initPressed == undefined) ? false : initPressed);
    this.state.enabled = ((enabled == undefined) ? true : enabled);
    ;
    this.addDomlet(new Domlet(
        this.domId,     
        this.name,      
        this.parent,    
        new Array(      
            'mouseout',
            'mouseover',
            'mousedown',
            'mouseup',
            'click'
        )
    ));
    this.activeCursor = this.domlets[this.name].getStyle('cursor');
    this.inactiveCursor = this.activeCursor;
    this.displayState(this.name);
    ;
    if (initPressed) this.displayState(this.name); 
} 
ImageToggleButton.prototype.eventFromChild = function(childName, eventType)
{
    ;
    switch(eventType)
    {
        case "mouseover" :
            this.state.highlighted = true;
            this.displayState(childName);
        break;
        case "mouseout" :
            this.state.highlighted = false;
            this.state.down = false;
            this.displayState(childName);
        break;
        case "mousedown" :
            this.state.down = true;
            this.displayState(childName);
        break;
        case "mouseup" :
            this.state.down = false;
            this.displayState(childName);
        break;
        case "click" :
            if (this.state.enabled)
            {
                if (this.state.pressed)
                {            
                    this.state.pressed = false;
                    if (this.buttonGroupManager)
                        this.buttonGroupManager.buttonUnpressed(this);
                    if (this.unpressedAction)
                    {
                        ;
                        this.unpressedAction.invoke();
                    }
                }
                else
                {
                    this.state.pressed = true;
                    if (this.buttonGroupManager)
                        this.buttonGroupManager.buttonPressed(this);
                    if (this.pressedAction)
                    {
                        ;
                        this.pressedAction.invoke();
                    }
                }
            }
            this.displayState(childName);
        break;
    }
} 
ImageToggleButton.prototype.setPressedAction = function(action)
{
    this.pressedAction = action;
}
ImageToggleButton.prototype.setUnpressedAction = function(action)
{
    this.unpressedAction = action;
}
ImageToggleButton.prototype.getDisableAction = function()
{
    return new ObjectMethodAction(this, "setEnabled", false);
}
ImageToggleButton.prototype.getEnableAction = function()
{
    return new ObjectMethodAction(this, "setEnabled", true);
}
ImageToggleButton.prototype.setEnabled = function(enabled)
{
    this.state.enabled = enabled;
    if(!enabled)
    {
        this.state.highlighted = false;
        this.state.down = false;
    }
    this.displayState(this.name);
}
ImageToggleButton.prototype.getSetSilentPressedAction = function()
{
    return new ObjectMethodAction(this, "setPressed", true, false, true);
}
ImageToggleButton.prototype.getSetSilentUnpressedAction = function()
{
    return new ObjectMethodAction(this, "setPressed", false, false, true);
}
ImageToggleButton.prototype.getSetPressedAction = function()
{
    return new ObjectMethodAction(this, "setPressed", true);
}
ImageToggleButton.prototype.getSetUnpressedAction = function()
{
    return new ObjectMethodAction(this, "setPressed", false);
}
ImageToggleButton.prototype.setPressed= function(pressed, fromManager, silent)
{
    if (this.state.enabled || silent)
    {
        ;
        if (fromManager)
        {
            if (this.state.pressed)
            {
                if (this.pressedAction)
                {
                    this.pressedAction.invoke();
                }
            }
            else
            {
                if (this.unpressedAction)
                {
                    this.unpressedAction.invoke();
                }    
            }
        }    
        this.state.pressed = pressed;
        this.displayState(this.name);
    }
}
ImageToggleButton.prototype.displayState = function(domletName)
{
  var imgSrc;
  if (this.state.highlighted)
  {
      imgSrc = (this.state.pressed ? this.state.images.pressedMouseover : this.state.images.normalMouseover);
  }
  else
  {
      imgSrc = (this.state.pressed ? this.state.images.pressed : this.state.images.normal);
  }
  if (!this.state.enabled) 
  {
      imgSrc = (this.state.pressed ? this.state.images.pressedDisabled : this.state.images.normalDisabled); 
      this.domlets[domletName].setStyle('cursor', this.inactiveCursor);
  }
  else
  {
      this.domlets[domletName].setStyle('cursor', this.activeCursor);
  }
  if (imgSrc != null) 
  {
    ;
    this.domlets[domletName].setImageSource(imgSrc);
  }
  else
  {
    ;
  }
} 
ImageToggleButton.prototype.setActiveCursor = function(activeCursor)
{
  this.activeCursor = activeCursor;
  this.displayState(this.name);
}
ImageToggleButton.prototype.setInactiveCursor = function(inactiveCursor)
{
  this.inactiveCursor = inactiveCursor;
  this.displayState(this.name);
}
ImageToggleButton.prototype.setButtonGroupManager = function(buttonGroupManager)
{
    this.buttonGroupManager = buttonGroupManager;
}
