/*
<DEPENDENCIES>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>ScrollBroker</DEPENDS>
    <DEPENDS>ModelViewBroker</DEPENDS>
</DEPENDENCIES>
*/
ItemScrollerWidget.prototype = new DomletCtr();
ItemScrollerWidget.prototype.constructor = ItemScrollerWidget;
ItemScrollerWidget.superclass = DomletCtr.prototype;
function ItemScrollerWidget( sId, sScrollBodyDomId, iItemWidth, iItemHeight, iMaxItemsPerRow )
{
  if( sId )
  {
    this.init(sId, sScrollBodyDomId, iItemWidth, iItemHeight, iMaxItemsPerRow);
  }
}
ItemScrollerWidget.prototype.init = function( sId, sScrollBodyDomId, iItemWidth, iItemHeight, iMaxItemsPerRow )
{
  //  ;
  this.sId = sId;
  if( !sScrollBodyDomId )
  {
    ;
    return;
  }
  this.sScrollBodyDomId = sScrollBodyDomId;
  this.nScrollBody = document.getElementById(sScrollBodyDomId);
  if( this.nScrollBody == null )
  {
    ;
    return;
  }
  if( !iItemWidth )
  {
    ;
    return;
  }
  else
  {
    this.itemWidth = iItemWidth;
  }
  if( !iItemHeight )
  {
    ;
    return;
  }
  else
  {
    this.itemHeight = iItemHeight;
  }
  if( iMaxItemsPerRow && iMaxItemsPerRow > 0 )
  {
    this.maxItemsPerRow = iMaxItemsPerRow;
  }
  else
  {
    this.maxItemsPerRow = this.calculateItemsPerRow();
  }
  this.totalItems = 0;
  this.startIndex = 0;
  this.stopIndex = 0;
  this.rowHeight = this.itemHeight;
  this.itemsPerRow = null;
  this.visibleRows = 0;
  this.scrollBufferRows = 0;
  this.minBufferRows = 1;
  this.filledRows = 0;
  this.initialScrollStep = 10;
  this.scrollStep = this.initialScrollStep;
  this.scrollTimerInterval = 20;
  this.scrollDirection = '';
  this.isScrolling = false;
  this.scrollBroker = null;
  this.modelViewBroker = null;
  this.aScrollableItems = new Array();
  this.aAreaOverflownHandles = new Array();
  this.aPositionChangeHandles = new Array();
  this.aSizeChangeHandles = new Array();
  var me = this;
  if( Browser.getId() == 'ie' )
  {
    var callback = function( event )
    {
      me.mouseWheelRollingDetectedIE(event)
    };
    Browser.addEventListenerToDomNode(this.nScrollBody, Browser.eventNames.MOUSEWHEEL, callback);
  }
  else
  {
    var callback = function( event )
    {
      me.mouseWheelRollingDetected(event)
    };
    Browser.addEventListenerToDomNode(this.nScrollBody, Browser.eventNames.MOUSEWHEEL, callback);
  }
}
ItemScrollerWidget.prototype.mouseWheelRollingDetected = function( event )
{
  var wheelDelta = event.detail * 4;
  if( wheelDelta > 0 )
  {
    this.scrollDirection = 'down';
    this.scrollStep = wheelDelta;
    if( !this.isScrolling )
      this.beginScroll();
  }
  else
  {
    this.scrollDirection = 'up';
    this.scrollStep = -1 * wheelDelta;
    if( !this.isScrolling )
      this.beginScroll();
  }
  this.doScroll();
  this.endScroll();
}
ItemScrollerWidget.prototype.mouseWheelRollingDetectedIE = function( event )
{
  var wheelDelta = event.wheelDelta / 4;
  if( wheelDelta > 0 )
  {
    this.scrollDirection = 'up';
    this.scrollStep = wheelDelta;
    if( !this.isScrolling )
      this.beginScroll();
  }
  else
  {
    this.scrollDirection = 'down';
    this.scrollStep = -1 * wheelDelta;
    if( !this.isScrolling )
      this.beginScroll();
  }
  this.doScroll();
  this.endScroll();
}
ItemScrollerWidget.prototype.getId = function()
{
  return this.sId;
}
ItemScrollerWidget.prototype.start = function()
{
  //  ;
  this.nScrollBody.scrollTop = 0;
  this.notifyPositionChange(0.0);
  this.recalculateParameters();
  if( this.calculateMaxVisibleScrollTop(this.visibleRows, this.filledRows, this.rowHeight) > 0 )
    this.notifyAreaOverflow();
  var virtualScrollHeight = this.calculateVirtualScrollHeight(this.itemsPerRow, this.rowHeight);
  var size = virtualScrollHeight > this.nScrollBody.offsetHeight
          ? this.nScrollBody.offsetHeight / virtualScrollHeight
          : 1.0;
  //  ;
  this.notifySizeChange(size);
  //  ;
}
ItemScrollerWidget.prototype.registerItemWidget = function( sDomId )
{
  var nElement = document.getElementById(sDomId);
  if( nElement == null )
  {
    ;
    return;
  }
  else
  {
    this.aScrollableItems.push(nElement);
  }
}
ItemScrollerWidget.prototype.calculateRowHeight = function()
{
  return this.itemHeight;
}
ItemScrollerWidget.prototype.calculateItemsPerRow = function()
{
  return Math.max(1, Math.floor(this.nScrollBody.scrollWidth / this.itemWidth));
}
ItemScrollerWidget.prototype.calculateMinBufferRows = function( itemsPerRow )
{
  if( itemsPerRow < this.maxItemsPerRow )
    return Math.ceil(this.maxItemsPerRow / itemsPerRow);
  else
    return 1;
}
ItemScrollerWidget.prototype.calculateVisibleRows = function( rowHeight )
{
  return this.nScrollBody.clientHeight / rowHeight;
}
ItemScrollerWidget.prototype.calculateFilledRows = function( itemsPerRow )
{
  if( this.startIndex >= this.totalItems )
    return 0;
  var realStartIndex = Math.max(this.startIndex, 0);
  var realStopIndex = Math.min(this.stopIndex, this.totalItems - 1);
  return Math.ceil((1 + realStopIndex - realStartIndex) / itemsPerRow);
}
ItemScrollerWidget.prototype.calculateVisibleFilledRows = function( itemsPerRow, firstVisibleIndex )
{
  var visibleStartIndex = Math.max(this.startIndex, 0) + firstVisibleIndex;
  var realStopIndex = Math.min(this.stopIndex, this.totalItems - 1);
  return Math.ceil((1 + realStopIndex - visibleStartIndex) / itemsPerRow);
}
ItemScrollerWidget.prototype.calculateFirstVisibleIndex = function( itemsPerRow, scrollTop, rowHeight )
{
  //  ;
  return Math.floor(scrollTop / rowHeight) * itemsPerRow;
}
ItemScrollerWidget.prototype.calculateMaxFirstIndexInBox = function()
{
  var minTotalRows = Math.ceil(this.totalItems / this.maxItemsPerRow);
  var minRowsInBox = Math.floor(this.aScrollableItems.length / this.maxItemsPerRow);
  var maxFirstRowInBox = Math.max(0, minTotalRows - minRowsInBox);
  var maxFirstIndexInBox = this.maxItemsPerRow * maxFirstRowInBox;
  //  ;
  return maxFirstIndexInBox;
}
ItemScrollerWidget.prototype.calculateMaxVisibleScrollTop = function( visibleRows, filledRows, rowHeight )
{
  //  ;
  var rows = Math.max(0, (filledRows - visibleRows));
  return rows * rowHeight;
}
ItemScrollerWidget.prototype.calculateVirtualScrollHeight = function( itemsPerRow, rowHeight )
{
  //  ;
  return Math.ceil(this.totalItems / itemsPerRow) * rowHeight;
}
ItemScrollerWidget.prototype.calculateVirtualScrollTop = function( itemsPerRow, rowHeight )
{
  if( this.startIndex >= this.totalItems )
  {
    //    ;
    return 0;
  }
  var realStartIndex = Math.max(this.startIndex, 0);
  var virtualRows = realStartIndex > 0 ? Math.ceil(realStartIndex / itemsPerRow) : 0;
  //  ;
  return virtualRows * rowHeight + this.nScrollBody.scrollTop;
}
ItemScrollerWidget.prototype.recalculateParameters = function()
{
  this.rowHeight = this.calculateRowHeight();
  this.itemsPerRow = this.calculateItemsPerRow();
  this.minBufferRows = this.calculateMinBufferRows(this.itemsPerRow);
  this.visibleRows = this.calculateVisibleRows(this.rowHeight);
  var availableRows = Math.floor(this.aScrollableItems.length / this.itemsPerRow);
  this.scrollBufferRows = Math.max(Math.floor(availableRows - this.visibleRows - 2 * this.minBufferRows), 0);
  this.filledRows = this.calculateFilledRows(this.itemsPerRow);
}
ItemScrollerWidget.prototype.getElementPosition = function( nElement )
{
  if( !nElement )
    return undefined;
  var pos = new Point(0, 0);
  Browser.getLocation(this.nElement, pos);
  return pos;
}
ItemScrollerWidget.prototype.getElementWidth = function( nElement )
{
  if( !nElement )
    return undefined;
  var height = Browser.getPixelComputedStyle(this.nElement, 'width');
  if( isNaN(height) && this.nElement.offsetHeight )
    height = this.nElement.offsetHeight;
  if( isNaN(height) )
    return undefined;
  else
    return height;
}
ItemScrollerWidget.prototype.getElementHeight = function( nElement )
{
  if( !nElement )
    return undefined;
  var height = Browser.getPixelComputedStyle(this.nElement, 'height');
  if( isNaN(height) && this.nElement.offsetHeight )
    height = this.nElement.offsetHeight;
  if( isNaN(height) )
    return undefined;
  else
    return height;
}
ItemScrollerWidget.prototype.notifyAreaOverflow = function()
{
  if( this.scrollBroker )
    this.scrollBroker.areaOverflow();
  ItemScrollerWidget.notifyListeners(this.aAreaOverflownHandles);
}
ItemScrollerWidget.prototype.addAreaOverflownHandle = function( action )
{
  if( action )
    this.aAreaOverflownHandles.push(action);
}
ItemScrollerWidget.prototype.notifyPositionChange = function( position )
{
  //  ;
  if( this.scrollBroker )
    this.scrollBroker.positionChanged(position);
  ItemScrollerWidget.notifyListeners(this.aPositionChangeHandles, position);
}
ItemScrollerWidget.prototype.addPositionChangedHandle = function( action )
{
  if( action )
    this.aPositionChangeHandles.push(action);
}
ItemScrollerWidget.prototype.notifySizeChange = function( size )
{
  //  ;
  if( this.scrollBroker )
    this.scrollBroker.sizeChanged(size);
  ItemScrollerWidget.notifyListeners(this.aSizeChangeHandles, size);
}
ItemScrollerWidget.prototype.addSizeChangedHandle = function( action )
{
  if( action )
    this.aSizeChangeHandles.push(action);
}
ItemScrollerWidget.notifyListeners = function( handles, param )
{
  for( var i = 0; i < handles.length; i++ )
  {
    handles[i].invoke(param);
  }
}
ItemScrollerWidget.prototype.scrollToRelativePosition = function( position )
{
  //  ;
  if( position <= 0.0 )
  {
    this.jumpToTop();
  }
  else if( position >= 1.0 )
  {
    this.jumpToBottom()
  }
  else
  {
    this.recalculateParameters();
    var maxVisibleScrollTop = this.calculateMaxVisibleScrollTop(this.visibleRows, this.filledRows, this.rowHeight);
    if( maxVisibleScrollTop > 0 )
    {
      var virtualScrollHeight = this.calculateVirtualScrollHeight(this.itemsPerRow, this.rowHeight);
      var virtualScrollTop = this.calculateVirtualScrollTop(this.itemsPerRow, this.rowHeight);
      var requestedScrollTop = virtualScrollHeight * position;
      //      ;
      if( requestedScrollTop + this.nScrollBody.offsetHeight > virtualScrollHeight )
      {
        requestedScrollTop = virtualScrollHeight - this.nScrollBody.offsetHeight;
        //        ;
      }
      var rowsInScrollTop = Math.ceil(requestedScrollTop / this.rowHeight);
      //      ;
      var firstVisibleIndex = this.itemsPerRow * Math.max(0, rowsInScrollTop - 1);
      //      ;
      var indexOffset = firstVisibleIndex % this.maxItemsPerRow;
      //      ;
      var maxFirstIndexInBox = this.calculateMaxFirstIndexInBox();
      var shiftIndex;
      if( firstVisibleIndex < (this.maxItemsPerRow * this.minBufferRows) )
      {
        shiftIndex = 0;
        //        ;
      }
      else if( firstVisibleIndex >= maxFirstIndexInBox )
      {
        shiftIndex = maxFirstIndexInBox;
        //        ;
      }
      else
      {
        var shiftRows = Math.floor(firstVisibleIndex / this.maxItemsPerRow) - this.minBufferRows;
        shiftIndex = shiftRows * this.maxItemsPerRow - 1;
        //        ;
      }
      this.shiftToIndex(shiftIndex);
      var boxRowOffset = ((firstVisibleIndex - this.startIndex) / this.itemsPerRow) * this.rowHeight;
      //      ;
      var visibleRowOffset = requestedScrollTop % this.rowHeight;
      //      ;
      //      ;
      this.nScrollBody.scrollTop = boxRowOffset + visibleRowOffset;
    }
  }
  //  ;
}
ItemScrollerWidget.prototype.doScroll = function()
{
  //  ;
  //  ;
  if( this.scrollDirection == 'up' )
  {
    this.doScrollUp();
    var virtualScrollHeight = this.calculateVirtualScrollHeight(this.itemsPerRow, this.rowHeight);
    var virtualScrollTop = this.calculateVirtualScrollTop(this.itemsPerRow, this.rowHeight);
    var size = virtualScrollHeight > this.nScrollBody.offsetHeight
            ? this.nScrollBody.offsetHeight / virtualScrollHeight
            : 1.0;
    //  ;
    this.notifySizeChange(size);
    this.notifyPositionChange(virtualScrollTop / virtualScrollHeight);
  }
  else if( this.scrollDirection == 'down' )
  {
    this.doScrollDown();
    var virtualScrollHeight = this.calculateVirtualScrollHeight(this.itemsPerRow, this.rowHeight);
    var virtualScrollTop = this.calculateVirtualScrollTop(this.itemsPerRow, this.rowHeight);
    var size = virtualScrollHeight > this.nScrollBody.offsetHeight
            ? this.nScrollBody.offsetHeight / virtualScrollHeight
            : 1.0;
    //  ;
    this.notifySizeChange(size);
    this.notifyPositionChange(virtualScrollTop / virtualScrollHeight);
  }
  //  ;
}
ItemScrollerWidget.prototype.doScrollUp = function()
{
  if( this.nScrollBody.scrollTop - this.scrollStep < 0 )
  {
    this.nScrollBody.scrollTop = 0;
    this.endScrollUp();
  }
  else
  {
    if( Math.abs(this.nScrollBody.scrollTop - this.scrollStep) <= this.minBufferRows * this.rowHeight )
    {
      this.requestShiftUp();
    }
    else
    {
      this.nScrollBody.scrollTop -= this.scrollStep;
    }
  }
}
ItemScrollerWidget.prototype.doScrollDown = function()
{
  var nextScrollTop = this.nScrollBody.scrollTop + this.scrollStep;
  var maxVisibleScrollTop = this.calculateMaxVisibleScrollTop(this.visibleRows, this.filledRows, this.rowHeight);
  if( nextScrollTop > maxVisibleScrollTop )
  {
    this.nScrollBody.scrollTop = maxVisibleScrollTop;
    this.endScrollDown();
  }
  else
  {
    if( nextScrollTop >= (this.scrollBufferRows + this.minBufferRows) * this.rowHeight )
    {
      this.requestShiftDown();
    }
    else
      this.nScrollBody.scrollTop = nextScrollTop;
  }
}
ItemScrollerWidget.prototype.requestShiftUp = function()
{
  if( this.startIndex >= this.itemsPerRow )
  {
    var shiftInterval = Math.min(this.itemsPerRow * this.scrollBufferRows, this.startIndex);
    this.executeShiftUp(shiftInterval);
    this.nScrollBody.scrollTop += ((shiftInterval / this.itemsPerRow) * this.rowHeight - this.scrollStep);
  }
  else
  {
    this.nScrollBody.scrollTop -= this.scrollStep;
  }
}
ItemScrollerWidget.prototype.requestShiftDown = function()
{
  if( this.stopIndex < this.totalItems - 1 )
  {
    var remaining = Math.ceil((this.totalItems - this.stopIndex) / this.itemsPerRow) * this.itemsPerRow;
    var shiftInterval = Math.min(this.itemsPerRow * this.scrollBufferRows, remaining);
    this.executeShiftDown(shiftInterval);
    this.nScrollBody.scrollTop -= ((shiftInterval / this.itemsPerRow) * this.rowHeight - this.scrollStep);
  }
  else
  {
    this.nScrollBody.scrollTop += this.scrollStep;
  }
}
ItemScrollerWidget.prototype.shiftToIndex = function( index )
{
  if( index < this.startIndex )
  {
    this.executeShiftUp(this.startIndex - index);
  }
  else if( index > this.startIndex )
  {
    this.executeShiftDown(index - this.startIndex);
  }
}
ItemScrollerWidget.prototype.executeShiftUp = function( interval )
{
  this.modelViewBroker.shiftUp(interval);
  this.startIndex -= interval;
  this.stopIndex -= interval;
  this.filledRows = this.calculateFilledRows(this.itemsPerRow);
}
ItemScrollerWidget.prototype.executeShiftDown = function( interval )
{
  this.modelViewBroker.shiftDown(interval);
  this.startIndex += interval;
  this.stopIndex += interval;
  this.filledRows = this.calculateFilledRows(this.itemsPerRow);
}
ItemScrollerWidget.prototype.jumpToTop = function()
{
  //  ;
  this.shiftToIndex(0);
  this.nScrollBody.scrollTop = 0;
  var itemsPerRow = this.calculateItemsPerRow();
  var rowHeight = this.calculateRowHeight();
  var virtualScrollHeight = this.calculateVirtualScrollHeight(itemsPerRow, rowHeight);
  var size = virtualScrollHeight > this.nScrollBody.offsetHeight
          ? this.nScrollBody.offsetHeight / virtualScrollHeight
          : 1.0;
  //  ;
  this.notifySizeChange(size);
  this.notifyPositionChange(0.0);
}
ItemScrollerWidget.prototype.jumpToBottom = function()
{
  //  ;
  var minTotalRows = Math.ceil(this.totalItems / this.maxItemsPerRow);
  //  ;
  var minRowsInBox = Math.floor(this.aScrollableItems.length / this.maxItemsPerRow);
  //  ;
  var maxFirstIndexInBox = this.calculateMaxFirstIndexInBox();
  if( minRowsInBox > minTotalRows )
    this.shiftToIndex(0);
  else
    this.shiftToIndex(maxFirstIndexInBox);
  var itemsPerRow = this.calculateItemsPerRow();
  var filledRows = this.calculateFilledRows(itemsPerRow);
  var rowHeight = this.calculateRowHeight();
  var visibleRows = this.calculateVisibleRows(rowHeight);
  this.nScrollBody.scrollTop = this.calculateMaxVisibleScrollTop(visibleRows, filledRows, rowHeight);
  var virtualScrollHeight = this.calculateVirtualScrollHeight(itemsPerRow, rowHeight);
  var virtualScrollTop = this.calculateVirtualScrollTop(itemsPerRow, rowHeight);
  var size = virtualScrollHeight > this.nScrollBody.offsetHeight
          ? this.nScrollBody.offsetHeight / virtualScrollHeight
          : 1.0;
  //  ;
  this.notifySizeChange(size);
  this.notifyPositionChange(virtualScrollTop / virtualScrollHeight);
  //  ;
}
ItemScrollerWidget.prototype.scrollToDomId = function( domId )
{
  var targetElem = document.getElementById(domId);
  if( targetElem != null )
  {
    this.scrollTo(domId);
  }
  else
  {
    ;
  }
}
ItemScrollerWidget.prototype.scrollToDomletCtr = function( oDomletCtr )
{
  if( oDomletCtr.domId != null )
  {
    this.scrollTo(oDomletCtr.domId);
  }
  else
  {
    ;
  }
}
ItemScrollerWidget.prototype.scrollTo = function( domId )
{
  var targetElem = document.getElementById(domId);
  if( targetElem != null )
  {
    ;
  }
}
ItemScrollerWidget.prototype.beginScroll = function()
{
  this.isScrolling = true;
  this.recalculateParameters();
  if( this.scrollTimer != null )
    window.clearInterval(this.scrollTimer);
  var scrollArea = this;
  var callback = function()
  {
    scrollArea.doScroll();
  };
  this.scrollTimer = window.setInterval(callback, this.scrollTimerInterval);
}
ItemScrollerWidget.prototype.endScroll = function()
{
  this.isScrolling = false;
  this.scrollStep = this.initialScrollStep;
  if( this.scrollTimer != null )
    window.clearInterval(this.scrollTimer);
}
ItemScrollerWidget.prototype.beginScrollUp = function()
{
  this.scrollDirection = 'up';
  this.beginScroll();
}
ItemScrollerWidget.prototype.endScrollUp = function()
{
  this.endScroll();
}
ItemScrollerWidget.prototype.beginScrollDown = function()
{
  this.scrollDirection = 'down';
  this.beginScroll();
}
ItemScrollerWidget.prototype.endScrollDown = function()
{
  this.endScroll();
}
ItemScrollerWidget.prototype.getBeginScrollUpAction = function()
{
  return new ObjectMethodAction(this, "beginScrollUp");
}
ItemScrollerWidget.prototype.getEndScrollUpAction = function()
{
  return new ObjectMethodAction(this, "endScrollUp");
}
ItemScrollerWidget.prototype.getBeginScrollDownAction = function()
{
  return new ObjectMethodAction(this, "beginScrollDown");
}
ItemScrollerWidget.prototype.getEndScrollDownAction = function()
{
  return new ObjectMethodAction(this, "endScrollDown");
}
ItemScrollerWidget.prototype.getJumpToTopAction = function()
{
  return new ObjectMethodAction(this, "jumpToTop");
}
ItemScrollerWidget.prototype.getJumpToBottomAction = function()
{
  return new ObjectMethodAction(this, "jumpToBottom");
}
ItemScrollerWidget.prototype.getScrollToRelativePositionAction = function( position )
{
  return new ObjectMethodAction(this, "scrollToRelativePosition", position);
}
ItemScrollerWidget.prototype.setScrollBroker = function( scrollBroker )
{
  this.scrollBroker = scrollBroker;
  this.scrollBroker.addBeginScrollUpHandle(this.getBeginScrollUpAction());
  this.scrollBroker.addEndScrollUpHandle(this.getEndScrollUpAction());
  this.scrollBroker.addBeginScrollDownHandle(this.getBeginScrollDownAction());
  this.scrollBroker.addEndScrollDownHandle(this.getEndScrollDownAction());
  this.scrollBroker.addScrollToRelativePositionHandle(this.getScrollToRelativePositionAction());
  this.scrollBroker.addJumpToTopHandle(this.getJumpToTopAction());
  this.scrollBroker.addJumpToBottomHandle(this.getJumpToBottomAction());
}
ItemScrollerWidget.prototype.modelChanged = function( totalItems, startIndex, stopIndex )
{
  //  ;
  this.totalItems = totalItems;
  this.startIndex = startIndex;
  this.stopIndex = stopIndex;
  if( startIndex <= 0 )
    this.jumpToTop();
  this.rowHeight = this.calculateRowHeight();
  this.itemsPerRow = this.calculateItemsPerRow();
  this.filledRows = this.calculateFilledRows(this.itemsPerRow);
  var virtualScrollHeight = this.calculateVirtualScrollHeight(this.itemsPerRow, this.rowHeight);
  var size = virtualScrollHeight > this.nScrollBody.offsetHeight
          ? this.nScrollBody.offsetHeight / virtualScrollHeight
          : 1.0;
  //  ;
  this.notifySizeChange(size);
  //  ;
}
ItemScrollerWidget.prototype.setModelViewBroker = function( modelViewBroker )
{
  this.modelViewBroker = modelViewBroker;
  this.modelViewBroker.addModelChangedHandle(new ObjectMethodAction(this, "modelChanged"));
}
ItemScrollerWidget.prototype.handleSizeChange = function( extensible )
{
  ;
  if( this.itemsPerRow )
  {
    var pos = 1 + this.calculateFirstVisibleIndex(this.itemsPerRow, this.nScrollBody.scrollTop, this.rowHeight);
    var prevItemsPerRow = this.itemsPerRow;
    var prevRowNumber = Math.ceil(pos / prevItemsPerRow);
    this.recalculateParameters();
    var nextItemsPerRow = this.itemsPerRow;
    var nextRowNumber = Math.ceil(pos / nextItemsPerRow);
    var nextScrollTop = this.nScrollBody.scrollTop + (nextRowNumber - prevRowNumber) * this.rowHeight;
    var maxVisibleScrollTop = this.calculateMaxVisibleScrollTop(this.visibleRows, this.filledRows, this.rowHeight);
    if( nextScrollTop > maxVisibleScrollTop )
      this.nScrollBody.scrollTop = maxVisibleScrollTop;
    else
      this.nScrollBody.scrollTop = nextScrollTop;
  }
}
