/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function ModalWidget( sId, sWidgetDomId, absolute )
{
  this.init(sId, sWidgetDomId, absolute);
}
ModalWidget.prototype.init = function( sId, sWidgetDomId, absolute )
{
  this.sId = sId;
  this.absolute = absolute;
  this.sWidgetDomId = sWidgetDomId;
  this.oOrigParent = null;
  this.oCoverElem = null;
  this.oCoverParent = null;
  this.width = document.body.scrollWidth;
  this.height = document.body.scrollHeight;
  var scolaOuterDiv = document.getElementById("scolaouterdiv");
  if( scolaOuterDiv )
  {
    this.width = scolaOuterDiv.offsetWidth;
    this.height = scolaOuterDiv.offsetHeight;
  }
  this.oWidget = document.getElementById(sWidgetDomId);
  if( this.oWidget == null )
  {
    ;
  }
  this.oOrigParent = this.oWidget.parentNode;
  this.sOrigPosition = this.oWidget.style.position;
  this.sOrigLeft = this.oWidget.offsetLeft;
  this.sOrigTop = this.oWidget.offsetTop;
  this.sOrigVisibility = this.oWidget.style.visibility;
  this.sOrigZIndex = this.oWidget.style.zIndex;
  this.coverClickAction = null;
  var me = this;
  this.handleCoverClick = function( event )
  {
    if( Browser.getEventSourceElement(event) == me.oCoverElem )
    {
      if( me.coverClickAction )
      {
        me.coverClickAction.invoke();
      }
      return false;
    }
  }
}
ModalWidget.prototype.cover = function( bCover )
{
  if( bCover )
  {
    if( this.oCoverElem == null )
    {
      this.oCoverParent = document.createElement("div");
      this.oCoverParent.id = 'sCoverParentWidgetDomId_' + this.sId;
      this.oCoverElem = Browser.getCoverElement();
      this.oCoverElem.style.position = 'absolute';
      this.oCoverElem.style.left = '0px';
      this.oCoverElem.style.top = '0px';
      document.body.appendChild(this.oCoverParent);
      this.oCoverParent.appendChild(this.oCoverElem);
    }
    if( this.width )
      Browser.changePixelStyle(this.oCoverElem, 'width', this.width);
    if( this.height )
      Browser.changePixelStyle(this.oCoverElem, 'height', this.height);
    Browser.setToplevel(this.oCoverElem);
    this.oCoverParent.appendChild(this.oWidget);
    Browser.setToplevel(this.oWidget);
    this.oWidget.style.visibility = 'visible';
    this.oCoverElem.style.visibility = 'visible';
  }
  else
  {
    if( this.oCoverElem != null )
    {
      this.oCoverElem.style.visibility = 'hidden';
      this.oWidget.style.visibility = 'hidden';
      this.oWidget.style.position = this.sOrigPosition;
      Browser.changePixelStyle(this.oWidget, 'top', this.sOrigTop);
      Browser.changePixelStyle(this.oWidget, 'left', this.sOrigLeft);
      this.oWidget.style.zIndex = this.sOrigZIndex;
      this.oWidget.style.visibility = this.sOrigVisibility;
    }
  }
}
ModalWidget.prototype.positionScreenAbsolute = function()
{
  Browser.removeNodeFromParent(this.oWidget);
  this.oWidget.style.visibility = 'hidden';
  this.oWidget.style.position = 'absolute';
  if( !this.absolute )
  {
    var pAbsPos = new Point(0, 0);
    Browser.getAbsPos(this.oWidget, pAbsPos);
    Browser.changePixelStyle(this.oWidget, 'top', pAbsPos.y);
    Browser.changePixelStyle(this.oWidget, 'left', pAbsPos.x);
  }
}
ModalWidget.prototype.addEventHandlerToCoverDivision = function( eventType, handler )
{
  if( this.oCoverElem == null )
  {
    this.oCoverParent = document.createElement("div");
    this.oCoverParent.id = 'sCoverParentWidgetDomId_' + this.sId;
    this.oCoverElem = Browser.getCoverElement();
    this.oCoverElem.style.position = 'absolute';
    this.oCoverElem.style.left = '0px';
    this.oCoverElem.style.top = '0px';
    document.body.appendChild(this.oCoverParent);
    this.oCoverParent.appendChild(this.oCoverElem);
  }
  Browser.addEventListener(this.oCoverElem.id, eventType, handler);
}
ModalWidget.prototype.setCoverClickHandle = function( handle )
{
  this.coverClickAction = handle;
  this.addEventHandlerToCoverDivision(Browser.eventNames.CLICK, this.handleCoverClick);
}
ModalWidget.prototype.getCoverAction = function( bCover )
{
  return new ObjectMethodAction(this, "cover", (bCover == undefined) ? true : bCover);
}
ModalWidget.prototype.getUncoverAction = function()
{
  return new ObjectMethodAction(this, "cover", false);
}
ModalWidget.prototype.start = function()
{
  this.positionScreenAbsolute();
}
