/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
</DEPENDENCIES>
*/
SliderWidget.prototype             = new DomletCtr();
SliderWidget.prototype.constructor = SliderWidget;
SliderWidget.superclass            = DomletCtr.prototype;
function SliderWidget(sId, sSliderContainerDomId, sSliderDomId)
{
  if (sId) { this.init(sId, sSliderContainerDomId, sSliderDomId); }
}
SliderWidget.prototype.init = function(sId, sSliderContainerDomId, sSliderDomId)
{
  ;
  var me = this;
  this.sId = sId;
  this.nMaxWidth = null;
  this.nMin = 0.8;
  this.nMax = 1.2;
  this.nValue = 1;
  this.aValueChangeActions = new Array();
  SliderWidget.superclass.init.call(this, sSliderDomId, sId, null);
  this.oSliderContainer = document.getElementById(sSliderContainerDomId);
  this.sSliderContainerDomId = sSliderContainerDomId;
  if (this.oSliderContainer == null)
  {
      ;
  }
  this.oSlider = document.getElementById(sSliderDomId);
  this.sSliderDomId = sSliderDomId;
  if (this.oSlider == null)
  {
      ;
  }
  if (Browser.getId() == 'moz')
  {
      this.oCoverElem = Browser.getCoverElement();
      this.oCoverElem.style.position = 'absolute';
      var pAbsPos = new Point(0,0);
      Browser.getAbsPos(this.oSlider, pAbsPos);
      Browser.changePixelStyle(this.oCoverElem, 'width', this.oSlider.scrollWidth);
      Browser.changePixelStyle(this.oCoverElem, 'height', this.oSlider.scrollHeight);
      this.oSlider.appendChild(this.oCoverElem);
      Browser.moveTo(this.oCoverElem,pAbsPos);
  }
  else
  {
      this.oCoverElem = this.oSlider;
  }
  this.addDomlet(new Domlet(
    this.oCoverElem.id,     
    this.name,      
    this.parent,    
    new Array('mousedown')) 
  )
  this.mouseDownY = this.getPos().y
  this.pSliderContainerAbsPos = new Point(0,0);
  Browser.getAbsPos(this.oSliderContainer, this.pSliderContainerAbsPos);
  this.nMaxWidth = parseInt(this.getWidthByDomID(sSliderContainerDomId)) - parseInt(this.getWidthByDomID(sSliderDomId));
  this.mouseUpHandler = function(e)
  {
    ;
    if ( e ) { var event = e; }
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEMOVE, me.mouseMoveHandler);
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEUP, me.mouseUpHandler);
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEOUT, me.mouseOutHandler);
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEDOWN, me.mouseUpHandler);
    me.getValueFromView();
  }
  this.mouseMoveHandler = function(e)
  {
    //;
    //;
    if ( e ) { var event = e; }
    if (!me.inMouseMove)
    {
      if (Math.abs(event.clientX - me.mouseDownX) > 2 )
      {
        me.inMouseMove = true;
        me.beginDrag(event);
        me.lostDeltaX = event.clientX - me.mouseDownX;
      }
    }
    if (me.inMouseMove)
    {
      var nX = event.clientX - me.deltaX + me.lostDeltaX;
      if (nX < me.pSliderContainerAbsPos.x)
      {
        nX = me.pSliderContainerAbsPos.x;
      }
      else
      {
        if ( nX > me.pSliderContainerAbsPos.x + me.nMaxWidth)
        {
          nX = me.pSliderContainerAbsPos.x + me.nMaxWidth;
        }
      }
      me.moveTo(new Point(nX, me.mouseDownY));
    }
  }
  this.mouseOutHandler = function(event)
  {
    if (Browser.getId() == 'moz')
    {
        if ( event.explicitOriginalTarget.nodeName == 'HTML')
        {
          me.mouseUpHandler(event);
        }
    }
    else
    {
        if ( event.srcElement.tagName == 'BODY' )
        {
          me.mouseUpHandler(event);
        }
    }
  }
}
SliderWidget.prototype.start = function()
{
	this.refreshView();
}
SliderWidget.prototype.getWidthByDomID = function(sDomId)
{
  var actualwdith = 0;
  var node = Browser.getElementById(sDomId);
  if (! actualwdith)
  {
    actualwdith = parseInt(Browser.getComputedStyleById(sDomId, 'width'));
  }
  if (! actualwdith)
  {
    if(node.width)
    {
      actualwdith =  parseInt(node.width);  
    }
  }
  if (! actualwdith)
  {
    if(node.style.width)
    {
      actualwdith =  parseInt(node.style.width);  
    }
  }
  return actualwdith;
}
SliderWidget.prototype.getId = function()
{
  //;
  return this.sId;
}
SliderWidget.prototype.addValueChangeAction = function(oValueChangeAction)
{
  //;
  this.aValueChangeActions.push(oValueChangeAction);
}
SliderWidget.prototype.setMin = function(nMin)
{
  //;
  var bSet = false;
  if ( nMin && parseFloat(nMin) && parseFloat(nMin) < this.nMax)
  {
    this.nMin = parseFloat(nMin);
    var bSet = true;
  }
  else
  {
    ;
  }
  return bSet;
}
SliderWidget.prototype.setMax = function(nMax)
{
  //;
  var bSet = false;
  if ( nMax && parseFloat(nMax) && parseFloat(nMax) > this.nMin)
  {
    this.nMax = parseFloat(nMax);
    var bSet = true;
  }
  else
  {
    this.nMax = this.nValue;
    ;
  }
  return bSet;
}
SliderWidget.prototype.setMinAndMax = function(nMin, nMax)
{
  //;
  var bSet = false;
  if ( nMin && parseFloat(nMin) )
  {
    this.nMin = nMin;
  }
  if ( nMax && parseFloat(nMax) && parseFloat(nMax) > this.nMin )
  {
    this.nMax = parseFloat(nMax);
    var bSet = true;
  }
  else
  {
    ;
  }
  return bSet;
}
SliderWidget.prototype.setValue = function(nValue)
{
  //;
  var bSet = false;
  if ( nValue && parseFloat(nValue))
  {
    if ( this.nMin <= parseFloat(nValue) && parseFloat(nValue) <= this.nMax )
    {
      this.nValue = parseFloat(nValue);
    }
    else
    {
      if ( this.nMax < parseFloat(nValue) )
      {
        this.nValue = this.nMax;
      }
      if ( this.nMin > parseFloat(nValue) )
      {
        this.nValue = this.nMin;
      }
    }
  }
  var bSet = true;
}
SliderWidget.prototype.eventFromChild = function(childName, eventType, event)
{
  ;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "mousedown" :
      ;
      this.mouseDownHandler(domlet, event);
      break;
    case "mouseover" :
      ;
      if(this.showOverAction) this.showOverAction.invoke();
      break;
    case "mouseout" :
      ;
      if(this.showOutAction) this.showOutAction.invoke();
      break;
  }
}
SliderWidget.prototype.mouseDownHandler = function(domlet, event)
{
  ;
  this.mouseDownX = event.clientX;
  this.mouseDownY = this.getPos().y
  this.inMouseMove = false;
  Browser.setToplevel(this.oSlider);
  Browser.eventStopPropagation(event);
  Browser.eventPreventDefault(event);
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEMOVE, this.mouseMoveHandler);
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEOUT, this.mouseOutHandler);
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEUP, this.mouseUpHandler);
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEDOWN, this.mouseUpHandler);
  return false;
}
SliderWidget.prototype.moveTo = function(pPoint)
{
  ;
  Browser.moveTo(this.oSlider, pPoint);
}
SliderWidget.prototype.getPos = function()
{
  ;
  var point = new Point(0,0);
  Browser.getAbsPos(this.oSlider, point);
  return(point);
}
SliderWidget.prototype.beginDrag = function(event)
{
  ;
  var point = this.getPos();
  this.deltaX = event.clientX - point.x;
}
SliderWidget.prototype.getValueFromView = function()
{
  ;
  var deltaX = this.getPos().x - this.pSliderContainerAbsPos.x;
  this.nValue = this.nMin + (( deltaX / this.nMaxWidth) * ( this.nMax - this.nMin ));
  for ( var i = 0; i < this.aValueChangeActions.length; i++)
  {
    this.aValueChangeActions[i].invoke(this.nValue);
  }
}
SliderWidget.prototype.refreshView = function()
{
  ;
  var deltaValue = this.nValue - this.nMin;
  var deltaX = (deltaValue / ( this.nMax - this.nMin ) ) * this.nMaxWidth;
  this.moveTo(new Point(this.pSliderContainerAbsPos.x + deltaX, this.mouseDownY));
}
SliderWidget.prototype.getMax = function()
{
  //;
  return this.nMax;
}
SliderWidget.prototype.getMin = function()
{
  //;
  return this.nMin;
}
SliderWidget.prototype.getValue = function()
{
  //;
  return this.nValue;
}
SliderWidget.prototype.getSetMaxAction = function(nMax)
{
    return new ObjectMethodAction(this, "setMax", nMax);
}
SliderWidget.prototype.getSetMinAction = function(nMin)
{
    return new ObjectMethodAction(this, "setMin", nMin);
}
SliderWidget.prototype.getSetMinAndMaxAction = function(nMin, nMax)
{
    return new ObjectMethodAction(this, "setMinAndMax", nMin, nMax);
}
SliderWidget.prototype.getSetValueAction = function(nValue)
{
    return new ObjectMethodAction(this, "setValue", nValue);
}
