/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ScrollArea</DEPENDS>
</DEPENDENCIES>
*/
SlidingSidebar.prototype             = new ScrollArea();
SlidingSidebar.prototype.constructor = SlidingSidebar;
SlidingSidebar.superclass            = ScrollArea.prototype;
function SlidingSidebar(sId, sWidgetDomId, sContentDomId, nSlideOffset, bState)
{
  if (sId) { this.init(sId, sWidgetDomId, sContentDomId, nSlideOffset, bState); }
}
SlidingSidebar.prototype.init = function(sId, sWidgetDomId, sContentDomId, nSlideOffset, bState)
{
  ;
  SlidingSidebar.superclass.init.call(this, sId, sContentDomId);
  this.sId = sId;
  this.barElem = Browser.getElementById(sWidgetDomId);
  this.contentElem = Browser.getElementById(sContentDomId);
  var outerDivElement = Browser.getElementById("scolaouterdiv");
  if(outerDivElement)
  {
      Browser.removeNodeFromParent(this.barElem);
      outerDivElement.appendChild(this.barElem);
  }
  this.beginOpenAction = null;
  this.endOpenAction = null;
  this.beginCloseAction = null;
  this.endCloseAction = null;
  this.slideOffset = nSlideOffset;
  this.origPos = this.absLeft(this.barElem);
  this.slideTo = this.origPos+this.slideOffset;
  this.state = true;
  this.slideTimer = null;
  this.addDomlet(new Domlet(
    sWidgetDomId,  
    this.sId,      
    this,          
    new Array())   
  )
  this.barElem.style.position = 'absolute';
  Browser.changePixelStyle(this.barElem, 'left', this.origPos);
  if(!bState) 
  { 
    Browser.changePixelStyle(this.barElem, 'left', this.slideTo);
    this.state = false;
  }
  this.barElem.style.visibility = 'visible';
  this.contentElem.scrollTop = 0; 
}
SlidingSidebar.prototype.start = function()
{
  ;
}
SlidingSidebar.prototype.slideStep = function()
{
  //;
  var offset = this.slideTo - this.barElem.offsetLeft;
  var delta = 2 * parseInt(offset / 5);
  if (delta != 0)
  {
    Browser.changePixelStyle(this.barElem, 'left', this.barElem.offsetLeft + delta);
  } 
  else
  {
    Browser.changePixelStyle(this.barElem, 'left', this.slideTo);
    if (this.slideTimer != null) window.clearInterval(this.slideTimer);
    if (this.slideTo == this.origPos)
    {
      if ( this.endOpenAction )
      {
        this.endOpenAction.invoke();
      }
    }
    else
    {
      if ( this.endCloseAction )
      {
        this.endCloseAction.invoke();
      }
    }
  }
}
SlidingSidebar.prototype.slide = function()
{
  //;
  if (this.state)
  {
    this.slideTo = this.origPos + this.slideOffset;
    if ( this.beginOpenAction )
    {
      this.beginOpenAction.invoke();
    }
  }
  else
  {
    this.slideTo = this.origPos;
    if ( this.beginCloseAction )
    {
      this.beginCloseAction.invoke();
    }
  }
  if (this.slideTimer != null) window.clearInterval(this.slideTimer);
  this.state = ! this.state;
  var sidebar = this;
  var callback = function()
  {
    sidebar.slideStep();
  };
  this.slideTimer = window.setInterval(callback, 10);
}
SlidingSidebar.prototype.state = function()
{
  //;
  return this.state;
}
SlidingSidebar.prototype.setOpen = function(bOpen)
{
  ;
  if ( (bOpen && ! this.state) || (! bOpen && this.state) )
  {
    this.slide();
  }
}
SlidingSidebar.prototype.setBeginCloseAction = function(beginCloseAction)
{
  ;
  this.beginCloseAction = beginCloseAction;
}
SlidingSidebar.prototype.setBeginOpenAction = function(beginOpenAction)
{
  ;
  this.beginOpenAction = beginOpenAction;
}
SlidingSidebar.prototype.setEndCloseAction = function(endCloseAction)
{
  ;
  this.endCloseAction = endCloseAction;
}
SlidingSidebar.prototype.setEndOpenAction = function(endOpenAction)
{
  ;
  this.endOpenAction = endOpenAction;
}
SlidingSidebar.prototype.getSlideAction = function()
{
    return new ObjectMethodAction(this, "slide");
}
SlidingSidebar.prototype.getSetOpenAction = function()
{
    return new ObjectMethodAction(this, "setOpen", true);
}
SlidingSidebar.prototype.getSetCloseAction = function()
{
    return new ObjectMethodAction(this, "setOpen", false);
}
