/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
</DEPENDENCIES>
*/
StateBroker.prototype             = new Broker();
StateBroker.prototype.constructor = StateBroker;
StateBroker.superclass            = Broker.prototype;
function StateBroker(sId, conjunction, affirmation)
{
  if (!sId) sId = "StateBroker";
  this.init(sId, conjunction, affirmation);
}
StateBroker.prototype.init = function(sId, conjunction, affirmation)
{
  ;
  this.sId = sId;
  this.globalState = false;
  this.subStates = new Array();
  if(affirmation != undefined)
    this.affirmation = affirmation;
  else
    this.affirmation = false;
  if(conjunction != undefined)
    this.conjunction = conjunction;
  else
    this.conjunction = false;
  StateBroker.superclass.init.call(this, sId);
}
StateBroker.prototype.initSet = function(setState)
{
    this.globalState = setState;
}
StateBroker.prototype.setSubstate = function(name)
{
  this.subStates[name] = true;
  this.doSetSubstate(name);
  this.checkGlobalState();
}
StateBroker.prototype.resetSubstate = function(name)
{
  this.subStates[name] = false;
  this.doResetSubstate(name);
  this.checkGlobalState();
}
StateBroker.prototype.initSubstate = function(name)
{
  ;
  var bFound = false;
  for(var key in this.subStates)
  {
     if(key == name)
     {
        bFound = true;
        break;
     }
  }
  if(!bFound)
  {
    this.subStates[name] = false;
    ;
  }
}
StateBroker.prototype.checkGlobalState = function()
{
  var localState = false;
  if(this.conjunction)
  {
      localState = true;
      for (i in this.subStates)
      {
        localState = this.subStates[i] && localState;
        ;
      }
      ;
  }
  else
  {
      localState = false;
      for (i in this.subStates)
      {
        localState = this.subStates[i] || localState;
        ;
      }
      ;
  }
  if (localState)
  {
    if (!this.globalState || this.affirmation)
    {
        this.setGlobalState();
    }
  }
  else
  {
    if (this.globalState  || this.affirmation)
    {
        this.resetGlobalState();
    }
  }
}
StateBroker.prototype.setGlobalState = function()
{
  this.globalState = true;
  this.doSetState();
}
StateBroker.prototype.resetGlobalState = function()
{
  this.globalState = false;
  this.doResetState();
}
StateBroker.prototype.doSetSubstate = function(name)
{
  this.getMessage('setSubstate', [name]);
}
StateBroker.prototype.addSetSubstateHandle = function(action)
{
  this.registerAction('setSubstate', action);
}
StateBroker.prototype.getSetSubstateAction = function(name)
{
  this.initSubstate(name);
  return new ObjectMethodAction(this, 'setSubstate', name);
}
StateBroker.prototype.doResetSubstate = function(name)
{
  this.getMessage('resetSubstate', [name]);
}
StateBroker.prototype.addResetSubstateHandle = function(action)
{
  this.registerAction('resetSubstate', action);
}
StateBroker.prototype.getResetSubstateAction = function(name)
{
  this.initSubstate(name);
  return new ObjectMethodAction(this, 'resetSubstate', name);
}
StateBroker.prototype.doSetState = function()
{
  this.getMessage('setState');
}
StateBroker.prototype.addSetStateHandle = function(action)
{
  this.registerAction('setState', action);
}
StateBroker.prototype.getSetStateAction = function()
{
  return new ObjectMethodAction(this, 'setGlobalState');
}
StateBroker.prototype.doResetState = function()
{
  this.getMessage('resetState');
}
StateBroker.prototype.addResetStateHandle = function(action)
{
  this.registerAction('resetState', action);
}
StateBroker.prototype.getResetStateAction = function()
{
  return new ObjectMethodAction(this, 'resetGlobalState');
}
