/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>DataLoader</DEPENDS>
    <DEPENDS>Mode</DEPENDS>
</DEPENDENCIES>
*/
HoverMode.prototype = new Mode();
HoverMode.prototype.constructor = HoverMode;
HoverMode.superclass = Mode.prototype;
function HoverMode(sId, modeId)
{
	this.init(sId, modeId);
}
HoverMode.prototype.init = function(sId, modeId)
{
	HoverMode.superclass.init.call(this, sId, modeId);
	
	this.elements = new Array();
	
	this.infoPaneDomId = null;
	this.infoPane = null;
	
	this.values = new Array();
	this.defaultValues = new Array();
	this.maxZIndex = 2000;
}
HoverMode.prototype.setInfoPane = function(domId)
{
	this.infoPaneDomId = domId;
}
HoverMode.prototype.getInfoPane = function()
{
	if (this.infoPane == null)
		this.infoPane = Browser.getElementById(this.infoPaneDomId);
	return this.infoPane;
}
HoverMode.prototype.dataChanged = function(aData)
{
	HoverMode.superclass.dataChanged.call(this);
	var pageDocument = this.getPageDocument();
	
	for (var i = 0; i < aData.length; i++)
	{
		var element = aData[i];
		element.resolve(pageDocument);
		if (element.exists())
		{
			var pos = element.getPosition();
			var modePane = this.getModePane();
			var markerDIV = document.createElement("div");
			var zindex = "2000" + element.getLevel();
			if (zindex > this.maxZIndex )
				this.maxZIndex = zindex + 1;
			markerDIV.setAttribute("id", element.getId());
			markerDIV.style["position"] = "absolute";
			markerDIV.style["left"] = pos.x + "px";
			markerDIV.style["top"] = pos.y + "px";
			markerDIV.style["width"] = element.getWidth() + "px";
			markerDIV.style["height"] = element.getHeight() + "px";
			markerDIV.style["borderStyle"] = "dashed";
			markerDIV.style["borderColor"] = "#FE3632";
			markerDIV.style["zIndex"] = zindex;
			modePane.appendChild(markerDIV);
			element.register(this, markerDIV);
			this.elements.push(element);
		}
	}
}
HoverMode.prototype.showElementInfo = function(element, event)
{
	var info = this.getInfoPane();
	for (var property in this.values)
	{
		var action = this.values[property];
		var value = element.getValue(property);
		if (value == null || value == undefined)
			value = this.defaultValues[property];
		var params = new Array();
		params[0] = value;
		action.invoke(params);
	}
	var elemPos = element.getPosition();
	var left = 0;
	var top = 0;
	if ((this.manager.getViewWidth() - (elemPos.x + element.getWidth() + info.scrollWidth)) < 0)
	{
		left = elemPos.x - info.scrollWidth;
	}
	else
	{
		left = elemPos.x + element.getWidth();
	}
	if ((this.manager.getViewHeight() - (elemPos.y + element.getHeight() + info.scrollHeight)) < 0)
	{
		top = elemPos.y - info.scrollHeight;
	}
	else
	{
		top = elemPos.y + element.getHeight();
	}
	info.style["left"] = left + 'px';
	info.style["top"] = top + 'px';
	info.style["visibility"] = "visible";
	info.style["zIndex"] = this.maxZIndex;
}
HoverMode.prototype.hideElementInfo = function(element)
{
	var info = this.getInfoPane();
	info.style["visibility"] = "hidden";
}
HoverMode.prototype.registerTextValue = function(property, action, defaultValue)
{
	if (defaultValue == undefined || defaultValue == null)
		this.defaultValues[property] = "-";
	else
		this.defaultValues[property] = defaultValue;
	this.values[property] = action;
}
HoverMode.prototype.registerImageValue = function(property, action, defaultImage)
{
	if (defaultImage == undefined || defaultImage == null)
		this.defaultValues[property] = "error.gif";
	else
		this.defaultValues[property] = defaultImage;
	this.values[property] = action;
}
HoverMode.prototype.cleanModePane = function()
{
	var modePane = this.getModePane();
	while (this.elements.length > 0)
	{
		var element = this.elements.pop();
		element.unregister(modePane);
	}
}
