/*
<DEPENDENCIES>
  <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function ApplicationState()
{
	this.init();
}
ApplicationState.prototype.init = function()
{
	this.doEmptyAction = null;
	this.doBaseDoneAction = null;
	this.doElementDoneAction = null;
	this.setEmpty();
}
ApplicationState.prototype.isEmpty = function()
{
	return this.empty;
}
ApplicationState.prototype.setEmpty = function()
{
	this.empty = true;
	this.base = false;
	this.element = false;
}
ApplicationState.prototype.registerDoEmptyAction = function( action )
{
	this.doEmptyAction = action;
}
ApplicationState.prototype.doEmpty = function( param1, param2, param3 )
{
	if( this.doEmptyAction )
	{
		var result = this.doEmptyAction.invoke(param1, param2, param3);
		if( result )
			this.setEmpty();
	}
	else
	{
		this.setEmpty();
	}
}
ApplicationState.prototype.isBaseDone = function()
{
	return this.base;
}
ApplicationState.prototype.setBaseDone = function()
{
	this.empty = false;
	this.base = true;
	this.element = false;
}
ApplicationState.prototype.registerDoBaseDoneAction = function( action )
{
	this.doBaseDoneAction = action;
}
ApplicationState.prototype.doBaseDone = function( param1, param2, param3 )
{
	if( this.doBaseDoneAction )
	{
		var result = this.doBaseDoneAction.invoke(param1, param2, param3);
		if( result )
			this.setBaseDone();
	}
	else
	{
		this.setBaseDone();
	}
}
ApplicationState.prototype.isElementDone = function()
{
	return this.element;
}
ApplicationState.prototype.setElementDone = function()
{
	this.empty = false;
	this.base = false;
	this.element = true;
}
ApplicationState.prototype.registerDoElementDoneAction = function( action )
{
	this.doElementDoneAction = action;
}
ApplicationState.prototype.doElementDone = function( param1, param2, param3 )
{
	if( this.doElementDoneAction )
	{
		var result = this.doElementDoneAction.invoke(param1, param2, param3);
		if( result )
			this.setElementDone();
	}
	else
	{
		this.setElementDone();
	}
}
function Communicator( servletName, viewName, frameWidth, frameHeight )
{
	this.servletName = servletName;
	this.viewName = viewName;
	this.setSizeParams(frameWidth, frameHeight);
}
Communicator.prototype.createClearUrl = function()
{
	return this.servletName + "?cmd=clear";
}
Communicator.prototype.createSetBaseUrl = function( sBaseType )
{
	return this.servletName + "?cmd=setbase&basetype=" + sBaseType;
}
Communicator.prototype.createAddElementUrl = function( sElementType, x, y )
{
	return this.servletName + "?cmd=addelement&elementtype=" + sElementType + "&x=" + x + "&y=" + y + this.sizeParams;
}
Communicator.prototype.createRemoveElementUrl = function( sElementId )
{
	return this.servletName + "?cmd=removeelement&elementid=" + sElementId;
}
Communicator.prototype.createSelectUrl = function( x, y )
{
	return this.servletName + "?cmd=select&x=" + x + "&y=" + y + this.sizeParams;
}
Communicator.prototype.createUpdateMeasuresUrl = function( sElementId, isRootType, measurementBean )
{
	return this.servletName + "?cmd=updatemeasures&elementid=" + sElementId
					+ "&roottype=" + isRootType
					+ "&" + measurementBean.toKeyValueString("&") + this.sizeParams;
}
Communicator.prototype.createGetImageUrl = function( name )
{
	return this.servletName + "?cmd=getimage&name=" + name + "&view=" + this.viewName + this.sizeParams;
}
Communicator.prototype.setSizeParams = function( frameWidth, frameHeight )
{
	this.sizeParams = "&width=" + frameWidth + "&height=" + frameHeight;
}
Communicator.prototype.sendRequest = function( url, callback )
{
	var internalCallback = new CommunicatorCallback(callback.getId(), url, callback);
	Browser.loadXMLDocument(url, internalCallback.getLoadedAction(), internalCallback.getErrorAction());
}
function CommunicatorCallback( target, url, resultHandler )
{
	this.target = target;
	this.url = url;
	this.resultHandler = resultHandler;
}
CommunicatorCallback.prototype.getLoadedAction = function()
{
	return new ObjectMethodAction(this, "loaded");
}
CommunicatorCallback.prototype.loaded = function( xmldoc )
{
	var result = new ServerResult('_result', xmldoc);
	this.handleResult(result.getValues());
}
CommunicatorCallback.prototype.handleResult = function( resultMap )
{
	if( this.resultHandler )
		return this.resultHandler.invoke(resultMap);
}
CommunicatorCallback.prototype.getErrorAction = function()
{
	return new ObjectMethodAction(this, "errorOccured");
}
CommunicatorCallback.prototype.errorOccured = function()
{
	alert('Internal error - Request \'' + this.url + '\' failed for target \'' + this.target + '!');
	;
}
function RequestCallback( sId, action )
{
	if( sId )
	{
		this.init(sId, action);
	}
}
RequestCallback.prototype.init = function( sId, action )
{
	this.sId = sId;
	this.action = action;
}
RequestCallback.prototype.getId = function()
{
	return this.sId;
}
RequestCallback.prototype.invoke = function( resultMap )
{
	
	return this.action.invoke(resultMap);
}
RequestCallback.PARAM_RESULT = "result";
RequestCallback.PARAM_MESSAGE = "message";
RequestCallback.PARAM_IMAGE_NAME = "imagename";
RequestCallback.PARAM_ELEMENT_ID = "elementid";
RequestCallback.PARAM_ELEMENT_TYPE = "elementtype";
RequestCallback.RESULT_OK = "ok";
RequestCallback.RESULT_ERROR = "error";
RequestCallback.RESULT_VOID = "void";
RequestCallback.hasResult = function( resultMap )
{
	return resultMap && resultMap[RequestCallback.PARAM_RESULT] != null;
}
RequestCallback.isResultOk = function( resultMap )
{
	return RequestCallback.hasResult(resultMap) && resultMap[RequestCallback.PARAM_RESULT] == RequestCallback.RESULT_OK;
}
RequestCallback.isResultError = function( resultMap )
{
	return RequestCallback.hasResult(resultMap) && resultMap[RequestCallback.PARAM_RESULT]
					== RequestCallback.RESULT_ERROR;
}
RequestCallback.isResultVoid = function( resultMap )
{
	return RequestCallback.hasResult(resultMap) && resultMap[RequestCallback.PARAM_RESULT] == RequestCallback.RESULT_VOID;
}
RequestCallback.hasMessage = function( resultMap )
{
	return resultMap && resultMap[RequestCallback.PARAM_MESSAGE] != null;
}
RequestCallback.getMessage = function( resultMap )
{
	return resultMap[RequestCallback.PARAM_MESSAGE];
}
RequestCallback.hasImageName = function( resultMap )
{
	return resultMap && resultMap[RequestCallback.PARAM_IMAGE_NAME] != null;
}
RequestCallback.getImageName = function( resultMap )
{
	return resultMap[RequestCallback.PARAM_IMAGE_NAME];
}
RequestCallback.hasElementId = function( resultMap )
{
	return resultMap && resultMap[RequestCallback.PARAM_ELEMENT_ID] != null;
}
RequestCallback.getElementId = function( resultMap )
{
	return resultMap[RequestCallback.PARAM_ELEMENT_ID];
}
RequestCallback.hasElementType = function( resultMap )
{
	return resultMap && resultMap[RequestCallback.PARAM_ELEMENT_TYPE] != null;
}
RequestCallback.getElementType = function( resultMap )
{
	return resultMap[RequestCallback.PARAM_ELEMENT_TYPE];
}
RequestSetBaseCallback.prototype = new RequestCallback();
RequestSetBaseCallback.prototype.constructor = RequestSetBaseCallback;
RequestSetBaseCallback.superclass = RequestCallback.prototype;
function RequestSetBaseCallback( sId, action )
{
	if( sId )
	{
		RequestSetBaseCallback.superclass.init.call(this, sId, action);
	}
}
RequestSetBaseCallback.prototype.invoke = function( resultMap )
{
	if( RequestCallback.hasElementId(resultMap)
					&& RequestCallback.hasElementType(resultMap)
					&& RequestCallback.hasImageName(resultMap) )
	{
		return this.action.invoke(
						RequestCallback.getElementId(resultMap),
						RequestCallback.getElementType(resultMap),
						RequestCallback.getImageName(resultMap),
						resultMap);
	}
	else
	{
		if( RequestCallback.isResultError() )
		{
			var message = RequestCallback.getMessage(resultMap);
			if( message == null )
				message = "Sorry: An internal error occurred - but no details are given.";
			alert(message);
		}
		else
		{
			alert('Internal error - SetBase: Invalid response - required arguments missing! \n'
							+ RequestCallback.PARAM_ELEMENT_ID + '=' + RequestCallback.getElementId(resultMap) + '\n'
							+ RequestCallback.PARAM_ELEMENT_TYPE + '=' + RequestCallback.getElementType(resultMap) + '\n'
							+ RequestCallback.PARAM_IMAGE_NAME + '=' + RequestCallback.getImageName(resultMap) + '\n');
		}
	}
}
RequestAddElementCallback.prototype = new RequestCallback();
RequestAddElementCallback.prototype.constructor = RequestAddElementCallback;
RequestAddElementCallback.superclass = RequestCallback.prototype;
function RequestAddElementCallback( sId, action )
{
	if( sId )
	{
		RequestAddElementCallback.superclass.init.call(this, sId, action);
	}
}
RequestAddElementCallback.prototype.invoke = function( resultMap )
{
	if( RequestCallback.hasElementId(resultMap)
					&& RequestCallback.hasElementType(resultMap)
					&& RequestCallback.hasImageName(resultMap) )
	{
		return this.action.invoke(
						RequestCallback.getElementId(resultMap),
						RequestCallback.getElementType(resultMap),
						RequestCallback.getImageName(resultMap),
						resultMap);
	}
	else
	{
		if( RequestCallback.isResultError() )
		{
			var message = RequestCallback.getMessage(resultMap);
			if( message == null )
				message = "Sorry: An internal error occurred - but no details are given.";
			alert(message);
		}
		else
		{
			alert('Internal error - AddElement: Invalid response - required arguments missing! \n'
							+ RequestCallback.PARAM_ELEMENT_ID + '=' + RequestCallback.getElementId(resultMap) + '\n'
							+ RequestCallback.PARAM_ELEMENT_TYPE + '=' + RequestCallback.getElementType(resultMap) + '\n'
							+ RequestCallback.PARAM_IMAGE_NAME + '=' + RequestCallback.getImageName(resultMap) + '\n');
		}
	}
}
RequestRemoveElementCallback.prototype = new RequestCallback();
RequestRemoveElementCallback.prototype.constructor = RequestRemoveElementCallback;
RequestRemoveElementCallback.superclass = RequestCallback.prototype;
function RequestRemoveElementCallback( sId, action )
{
	if( sId )
	{
		RequestRemoveElementCallback.superclass.init.call(this, sId, action);
	}
}
RequestRemoveElementCallback.prototype.invoke = function( resultMap )
{
	if( RequestCallback.hasElementId(resultMap) && RequestCallback.hasImageName(resultMap) )
	{
		return this.action.invoke(
						RequestCallback.getElementId(resultMap),
						RequestCallback.getImageName(resultMap),
						resultMap);
	}
	else
	{
		if( RequestCallback.isResultError() )
		{
			var message = RequestCallback.getMessage(resultMap);
			if( message == null )
				message = "Sorry: An internal error occurred - but no details are given.";
			alert(message);
		}
		else
		{
			alert('Internal error - RemoveElement: Invalid response - required arguments missing! \n'
							+ RequestCallback.PARAM_ELEMENT_ID + '=' + RequestCallback.getElementId(resultMap) + '\n'
							+ RequestCallback.PARAM_IMAGE_NAME + '=' + RequestCallback.getImageName(resultMap) + '\n');
		}
	}
}
RequestSelectCallback.prototype = new RequestCallback();
RequestSelectCallback.prototype.constructor = RequestSelectCallback;
RequestSelectCallback.superclass = RequestCallback.prototype;
function RequestSelectCallback( sId, action )
{
	if( sId )
	{
		RequestSelectCallback.superclass.init.call(this, sId, action);
	}
}
RequestSelectCallback.prototype.invoke = function( resultMap )
{
	if( RequestCallback.hasImageName(resultMap) )
	{
		return this.action.invoke(
						RequestCallback.getElementId(resultMap),
						RequestCallback.getImageName(resultMap),
						resultMap);
	}
	else
	{
		if( RequestCallback.isResultError() )
		{
			var message = RequestCallback.getMessage(resultMap);
			if( message == null )
				message = "Sorry: An internal error occurred - but no details are given.";
			alert(message);
		}
		else
		{
			alert('Internal error - Select: Invalid response - required arguments missing! \n'
							+ RequestCallback.PARAM_IMAGE_NAME + '=' + RequestCallback.getImageName(resultMap) + '\n');
		}
	}
}
RequestUpdateMeasuresCallback.prototype = new RequestCallback();
RequestUpdateMeasuresCallback.prototype.constructor = RequestUpdateMeasuresCallback;
RequestUpdateMeasuresCallback.superclass = RequestCallback.prototype;
function RequestUpdateMeasuresCallback( sId, action )
{
	if( sId )
	{
		RequestUpdateMeasuresCallback.superclass.init.call(this, sId, action);
	}
}
RequestUpdateMeasuresCallback.prototype.invoke = function( resultMap )
{
	return this.action.invoke(
					RequestCallback.getElementId(resultMap),
					RequestCallback.getImageName(resultMap),
					resultMap);
}
RequestClearCallback.prototype = new RequestCallback();
RequestClearCallback.prototype.constructor = RequestClearCallback;
RequestClearCallback.superclass = RequestCallback.prototype;
function RequestClearCallback( sId, action )
{
	if( sId )
	{
		RequestClearCallback.superclass.init.call(this, sId, action);
	}
}
RequestClearCallback.prototype.invoke = function( resultMap )
{
	if( RequestCallback.hasImageName(resultMap) )
	{
		return this.action.invoke(RequestCallback.getImageName(resultMap), resultMap);
	}
	else
	{
		if( RequestCallback.isResultError() )
		{
			var message = RequestCallback.getMessage(resultMap);
			if( message == null )
				message = "Sorry: An internal error occurred - but no details are given.";
			alert(message);
		}
		else
		{
			alert('Internal error - Clear: Invalid response - required arguments missing! \n'
							+ RequestCallback.PARAM_IMAGE_NAME + '=' + RequestCallback.getImageName(resultMap) + '\n');
		}
	}
}
function ConstructionManager( sId, servletName, viewName, frameWidth, frameHeight )
{
	if( sId )
	{
		this.init(sId, servletName, viewName, frameWidth, frameHeight);
	}
}
ConstructionManager.prototype.init = function( sId, servletName, viewName, frameWidth, frameHeight )
{
	this.sId = sId;
	this.state = new ApplicationState();
	this.communicator = new Communicator(servletName, viewName, frameWidth, frameHeight);
	this.basesToolbar = null;
	this.elementsToolbar = null;
	this.createElementAction = null;
	this.setBaseAction = null;
	this.addElementAction = null;
	this.removeElementAction = null;
	this.clearAction = null;
	this.setImageSrcAction = null;
	this.findElementAction = null;
	this.openMessageDialogAction = null;
	this.openAysResetDialogAction = null;
	this.openAysClearDialogAction = null;
	this.openAysRemoveDialogAction = null;
	this.clearImageName = null;
	this.serial = 0;
	this.activeElement = null;
}
ConstructionManager.prototype.getId = function()
{
	return this.sId;
}
ConstructionManager.prototype.start = function()
{
	this.setupStateActions();
	this.state.doEmpty();
}
ConstructionManager.prototype.restartWithBase = function()
{
	this.setupStateActions();
	if( this.setImageSrcAction )
		this.setImageSrcAction.invoke(this.communicator.createGetImageUrl("restartWithBase"));
	this.state.doBaseDone();
}
ConstructionManager.prototype.restartWithElements = function()
{
	this.setupStateActions();
	if( this.setImageSrcAction )
		this.setImageSrcAction.invoke(this.communicator.createGetImageUrl("restartWithElements"));
	this.state.doElementDone();
}
ConstructionManager.prototype.setupStateActions = function()
{
	if( this.basesToolbar && this.elementsToolbar )
	{
		this.state.registerDoEmptyAction(new ObjectMethodAction(this, "setToolbarFocusBases"));
		this.state.registerDoBaseDoneAction(new ObjectMethodAction(this, "setToolbarFocusElements"));
		this.state.registerDoElementDoneAction(new ObjectMethodAction(this, "setToolbarFocusElements"));
	}
}
ConstructionManager.prototype.registerBasesToolbar = function( toolbar )
{
	this.basesToolbar = toolbar;
}
ConstructionManager.prototype.registerElementsToolbar = function( toolbar )
{
	this.elementsToolbar = toolbar;
}
ConstructionManager.prototype.registerCreateElementAction = function( action )
{
	this.createElementAction = action;
}
ConstructionManager.prototype.registerSetBaseAction = function( action )
{
	this.setBaseAction = action;
}
ConstructionManager.prototype.registerAddElementAction = function( action )
{
	this.addElementAction = action;
}
ConstructionManager.prototype.registerRemoveElementAction = function( action )
{
	this.removeElementAction = action;
}
ConstructionManager.prototype.registerClearAction = function( action )
{
	this.clearAction = action;
}
ConstructionManager.prototype.registerSetImageSrcAction = function( action )
{
	this.setImageSrcAction = action;
}
ConstructionManager.prototype.registerFindElementAction = function( action )
{
	this.findElementAction = action;
}
ConstructionManager.prototype.registerOpenMessageDialogAction = function( action )
{
	this.openMessageDialogAction = action;
}
ConstructionManager.prototype.registerOpenAysResetDialogAction = function( action )
{
	this.openAysResetDialogAction = action;
}
ConstructionManager.prototype.registerOpenAysClearDialogAction = function( action )
{
	this.openAysClearDialogAction = action;
}
ConstructionManager.prototype.registerOpenAysRemoveDialogAction = function( action )
{
	this.openAysRemoveDialogAction = action;
}
ConstructionManager.prototype.registerDragable = function( dragable )
{
	this.dragable = dragable;
	this.dragable.setMainManager(this);
}
ConstructionManager.prototype.startDragAndDrop = function( modelItem, position, event )
{
	
	
	if( modelItem && modelItem.isRootType && this.shouldDoStartDragAndDrop(this.basesToolbar) )
		this.doStartDragAndDrop(modelItem, position, event);
	else if( modelItem && !modelItem.isRootType && this.shouldDoStartDragAndDrop(this.elementsToolbar) )
		this.doStartDragAndDrop(modelItem, position, event);
}
ConstructionManager.prototype.shouldDoStartDragAndDrop = function( toolbar )
{
	if( !toolbar )
		return true;
	else
		return !toolbar.isDisabled();
}
ConstructionManager.prototype.doStartDragAndDrop = function( modelItem, position, event )
{
	this.dragable.setModelItem(modelItem);
	this.dragable.moveToSnapPosition(position);
	this.dragable.setVisible(true);
	this.dragable.beginDragFromOutside(event);
}
ConstructionManager.prototype.abortDragAndDrop = function( modelItem )
{
	
}
ConstructionManager.prototype.createCallbackId = function()
{
	return "request_" + this.serial++;
}
ConstructionManager.prototype.doErrorMessage = function( message )
{
	var text = (message ? message : "Sorry: An error occurred - but no details are given.");
	if( this.openMessageDialogAction )
		this.openMessageDialogAction.invoke(text);
	else
		alert(text);
}
ConstructionManager.prototype.requestAddItem = function( itemType, isRootType, x, y )
{
	if( isRootType )
	{
		if( !this.state.isEmpty() && this.openAysResetDialogAction )
		{
			this.requestedBaseType = itemType;
			this.openAysResetDialogAction.invoke();
		}
		else
		{
			this.requestSetBase(itemType);
		}
	}
	else
	{
		this.requestAddElement(itemType, x, y)
	}
}
ConstructionManager.prototype.getRequestAddItemAction = function()
{
	return new ObjectMethodAction(this, "requestAddItem");
}
ConstructionManager.prototype.requestSetBase = function( baseType )
{
	if( baseType == null && this.requestedBaseType == null )
		return;
	this.communicator.sendRequest(
					this.communicator.createSetBaseUrl((baseType != null ? baseType : this.requestedBaseType)),
					new RequestSetBaseCallback(this.createCallbackId(), new ObjectMethodAction(this, "doSetBase")));
}
ConstructionManager.prototype.getRequestSetBaseAction = function()
{
	return new ObjectMethodAction(this, "requestSetBase");
}
ConstructionManager.prototype.doSetBase = function( elementId, elementType, imageName, resultMap )
{
	if( RequestCallback.isResultOk(resultMap) )
	{
		var element = this.createElementAction.invoke(elementId, elementType);
		if( element != null && element.isRootType() )
		{
			if( !this.state.isEmpty() )
				this.clearAction.invoke();
			element.updateMeasurementData(resultMap);
			this.setBaseAction.invoke(element);
			this.setImageSrcAction.invoke(this.communicator.createGetImageUrl(imageName));
			this.activeElement = element;
			element.openMeasurementDialog();
			this.state.doBaseDone();
		}
	}
	else if( RequestCallback.isResultVoid(resultMap) )
	{
		
	}
	else
	{
		this.doErrorMessage(RequestCallback.getMessage(resultMap));
	}
}
ConstructionManager.prototype.requestAddElement = function( elementType, x, y )
{
	this.communicator.sendRequest(
					this.communicator.createAddElementUrl(elementType, x, y),
					new RequestAddElementCallback(this.createCallbackId(), new ObjectMethodAction(this, "doAddElement")));
}
ConstructionManager.prototype.getRequestAddElementAction = function()
{
	return new ObjectMethodAction(this, "requestAddElement");
}
ConstructionManager.prototype.doAddElement = function( elementId, elementType, imageName, resultMap )
{
	if( RequestCallback.isResultOk(resultMap) )
	{
		if( !this.state.isEmpty() )
		{
			var element = this.createElementAction.invoke(elementId, elementType);
			if( element != null && !element.isRootType() )
			{
				element.updateMeasurementData(resultMap);
				this.addElementAction.invoke(element);
				this.setImageSrcAction.invoke(this.communicator.createGetImageUrl(imageName));
				this.activeElement = element;
				element.openMeasurementDialog();
				this.state.doElementDone();
			}
		}
		else
		{
			alert('Internal error - Add Element called without setting a base element first!');
		}
	}
	else if( RequestCallback.isResultVoid(resultMap) )
	{
		
	}
	else
	{
		this.doErrorMessage(RequestCallback.getMessage(resultMap));
	}
}
ConstructionManager.prototype.requestRemoveElement = function( elementId )
{
	this.communicator.sendRequest(
					this.communicator.createRemoveElementUrl(elementId),
					new RequestRemoveElementCallback(this.createCallbackId(), new ObjectMethodAction(this, "doRemoveElement")));
}
ConstructionManager.prototype.getRequestRemoveElementAction = function()
{
	return new ObjectMethodAction(this, "requestRemoveElement");
}
ConstructionManager.prototype.doRemoveElement = function( elementId, imageName, resultMap )
{
	if( RequestCallback.isResultOk(resultMap) )
	{
		if( !this.state.isEmpty() )
		{
			this.removeElementAction.invoke(elementId);
			this.setImageSrcAction.invoke(this.communicator.createGetImageUrl(imageName));
			this.state.doElementDone();
		}
		else
		{
			alert('Internal error - Remove Element called without setting a base element first!');
		}
	}
	else if( RequestCallback.isResultVoid(resultMap) )
	{
		
	}
	else
	{
		this.doErrorMessage(RequestCallback.getMessage(resultMap));
	}
}
ConstructionManager.prototype.requestSelect = function( x, y )
{
	this.communicator.sendRequest(
					this.communicator.createSelectUrl(x, y),
					new RequestSelectCallback(this.createCallbackId(), new ObjectMethodAction(this, "doSelect")));
}
ConstructionManager.prototype.getRequestSelectAction = function()
{
	return new ObjectMethodAction(this, "requestSelect");
}
ConstructionManager.prototype.doSelect = function( elementId, imageName, resultMap )
{
	if( RequestCallback.isResultOk(resultMap) )
	{
		if( elementId )
		{
			var element = this.findElementAction.invoke(elementId);
			if( element )
			{
				element.updateMeasurementData(resultMap);
				this.setImageSrcAction.invoke(this.communicator.createGetImageUrl(imageName));
				this.activeElement = element;
				element.openMeasurementDialog();
				this.state.doElementDone();
			}
		}
		else
		{
			this.setImageSrcAction.invoke(this.communicator.createGetImageUrl(imageName));
		}
	}
	else if( RequestCallback.isResultVoid(resultMap) )
	{
		
		this.activeElement = null;
	}
	else
	{
		this.doErrorMessage(RequestCallback.getMessage(resultMap));
	}
}
ConstructionManager.prototype.requestUpdateMeasures = function( elementId, isRootType, measurementBean )
{
	this.communicator.sendRequest(
					this.communicator.createUpdateMeasuresUrl(elementId, isRootType, measurementBean),
					new RequestUpdateMeasuresCallback(this.createCallbackId(), new ObjectMethodAction(this, "doUpdateMeasures")));
}
ConstructionManager.prototype.getRequestUpdateMeasuresAction = function()
{
	return new ObjectMethodAction(this, "requestUpdateMeasures");
}
ConstructionManager.prototype.doUpdateMeasures = function( elementId, imageName, resultMap )
{
	if( !RequestCallback.isResultOk(resultMap) )
	{
		if( !this.state.isEmpty() )
		{
			var element = this.findElementAction.invoke(elementId);
			if( element )
			{
				element.updateMeasurementData(resultMap);
				this.setImageSrcAction.invoke(this.communicator.createGetImageUrl(imageName));
				this.activeElement = element;
				element.openMeasurementDialog();
				this.state.doElementDone();
			}
		}
		else
		{
			alert('Internal error - Update Measures called without setting a base element first!');
		}
	}
	else
	{
		this.setImageSrcAction.invoke(this.communicator.createGetImageUrl(imageName));
	}
}
ConstructionManager.prototype.requestClear = function()
{
	this.communicator.sendRequest(
					this.communicator.createClearUrl(),
					new RequestClearCallback(this.createCallbackId(), new ObjectMethodAction(this, "doClear")));
}
ConstructionManager.prototype.getRequestClearAction = function()
{
	return new ObjectMethodAction(this, "requestClear");
}
ConstructionManager.prototype.doClear = function( imageName, resultMap )
{
	if( RequestCallback.isResultOk(resultMap) )
	{
		this.clearAction.invoke();
		this.setImageSrcAction.invoke(this.communicator.createGetImageUrl(imageName));
		this.state.doEmpty();
	}
	else if( RequestCallback.isResultVoid(resultMap) )
	{
		
	}
	else
	{
		this.doErrorMessage(RequestCallback.getMessage(resultMap));
	}
}
ConstructionManager.prototype.commitClear = function()
{
	if( !this.state.isEmpty() && this.openAysClearDialogAction )
	{
		this.openAysClearDialogAction.invoke();
	}
	else
	{
		this.requestClear();
	}
}
ConstructionManager.prototype.getClearCommittedAction = function()
{
	return new ObjectMethodAction(this, "commitClear");
}
ConstructionManager.prototype.clear = function()
{
	this.requestClear();
}
ConstructionManager.prototype.getClearAction = function()
{
	return new ObjectMethodAction(this, "clear");
}
ConstructionManager.prototype.commitRemove = function()
{
	if( !this.state.isEmpty() && this.activeElement != null && !this.activeElement.isRootType() )
	{
		if( this.openAysRemoveDialogAction )
		{
			this.openAysRemoveDialogAction.invoke();
		}
		else
		{
			this.removeElement();
		}
	}
}
ConstructionManager.prototype.getRemoveCommittedAction = function()
{
	return new ObjectMethodAction(this, "commitRemove");
}
ConstructionManager.prototype.removeElement = function()
{
	if( this.activeElement != null && !this.activeElement.isRootType() )
	{
		this.requestRemoveElement(this.activeElement.getElementId());
		this.activeElement = null;
	}
}
ConstructionManager.prototype.getRemoveElementAction = function()
{
	return new ObjectMethodAction(this, "removeElement");
}
ConstructionManager.prototype.resetBase = function()
{
	if( this.requestedBaseType != null )
	{
		this.requestSetBase(this.requestedBaseType);
		this.requestedBaseType = null;
	}
}
ConstructionManager.prototype.getResetBaseAction = function()
{
	return new ObjectMethodAction(this, "resetBase");
}
ConstructionManager.prototype.commitMeasurement = function()
{
	if( this.activeElement != null )
	{
		this.requestUpdateMeasures(
						this.activeElement.getElementId(),
						this.activeElement.isRootType(),
						this.activeElement.getMeasurementBean());
		this.activeElement = null;
	}
}
ConstructionManager.prototype.getCommitMeasurementAction = function()
{
	return new ObjectMethodAction(this, "commitMeasurement");
}
ConstructionManager.prototype.setToolbarFocusBases = function()
{
	this.basesToolbar.highlight();
	this.elementsToolbar.disable();
	return true;
}
ConstructionManager.prototype.setToolbarFocusElements = function()
{
	this.basesToolbar.enable();
	this.elementsToolbar.highlight();
	return true;
}
ConstructionManager.prototype.setToolbarFocusNone = function()
{
	this.basesToolbar.enable();
	this.elementsToolbar.enable();
	return true;
}
ConstructionManager.prototype.setToolbarOff = function()
{
	this.basesToolbar.disable();
	this.elementsToolbar.disable();
	return true;
}
