/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Controller</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
</DEPENDENCIES>
*/
CharacterWidget.prototype             = new DomletCtr();
CharacterWidget.prototype.constructor = CharacterWidget;
CharacterWidget.superclass            = DomletCtr.prototype;
function CharacterWidget(sId, sCharacterWidgetDomId, sInputWidgetDomId, nX, nY)
{
  if (sId) { this.init(sId, sCharacterWidgetDomId, sInputWidgetDomId, nX, nY); }
}
CharacterWidget.prototype.init = function(sId, sCharacterWidgetDomId, sInputWidgetDomId, nX, nY)
{
  //;   
  this.sId = sId;
  this.nX = nX;
  this.nY = nY;
  this.nWidgetWidth = null;
  this.nWidgetHeight = null;
  this.modelItem = null;
  this.oCharacterWidgetManager = null;
  this.sFgEvaluatedColor = null;
  this.sBgEvaluatedColor = null;
  this.bActive = true;
  this.aAssociatedAnswers = new Array();
  CharacterWidget.superclass.init.call(this, this.sCharacterWidgetDomId, this.sId, this);
  this.inputWidget = document.getElementById(sInputWidgetDomId);
  this.sInputWidgetDomId = sInputWidgetDomId;
  if (this.inputWidget == null)
  {
      ;
  }
  else
  {
    this.addDomlet(new Domlet(
      this.sInputWidgetDomId,      
      this.sInputWidgetDomId,      
      this,                        
    new Array('keypress' )))     
  }
  this.characterWidget = document.getElementById(sCharacterWidgetDomId);
  this.sCharacterWidgetDomId = sCharacterWidgetDomId;
  if(this.inputWidget)
  {
    this.inputWidget.style.backgroundColor = this.characterWidget.style.backgroundColor;
    this.inputWidget.style.color = this.characterWidget.style.color;
  }
  this.nWidgetWidth = this.getWidthByDomID(sCharacterWidgetDomId);
  this.nWidgetHeight = this.getHeightByDomID(sCharacterWidgetDomId);
  if (this.characterWidget == null)
  {
    ;
  }
  this.addDomlet(new Domlet(
      this.sCharacterWidgetDomId, 
      this.sCharacterWidgetDomId, 
      this,                       
    new Array('mousedown', 'mouseover')))          
}
CharacterWidget.prototype.getWidthByDomID = function(sDomId)
{
  var actualwdith = 0;
  var node = Browser.getElementById(sDomId);
  if (! actualwdith)
  {
    actualwdith = parseInt(Browser.getComputedStyleById(sDomId, 'width'));
  }
  if (! actualwdith)
  {
    if(node.width)
    {
      actualwdith =  parseInt(node.width);  
    }
  }
  if (! actualwdith)
  {
    if(node.style.width)
    {
      actualwdith =  parseInt(node.style.width);  
    }
  }
  return actualwdith;
}
CharacterWidget.prototype.getHeightByDomID = function(sDomId)
{
  var actualheight = 0;
  var node = Browser.getElementById(sDomId);
  if (! actualheight)
  {
    actualheight = parseInt(Browser.getComputedStyleById(sDomId, 'height'));
  }
  if (! actualheight)
  {
    if(node.height)
    {
      actualheight =  parseInt(node.height);  
    }
  }
  if (! actualheight)
  {
    if(node.style.height)
    {
      actualheight =  parseInt(node.style.height);  
    }
  }
  return actualheight;
}
CharacterWidget.prototype.getId = function()
{
  ////;
  return this.sId;
}
CharacterWidget.prototype.getXPos = function()
{
  ////;
  return this.nX;
}
CharacterWidget.prototype.getYPos = function()
{
  ////;
  return this.nY;
}
CharacterWidget.prototype.getDomId = function()
{
  ////;
  return this.sCharacterWidgetDomId;
}
CharacterWidget.prototype.setModelItem = function(modelItem)
{
  ////;
  this.modelItem = modelItem;
}
CharacterWidget.prototype.getModelItem = function()
{
  ////;
  return this.modelItem;
}
CharacterWidget.prototype.setBroker = function(broker)
{
  ////;
  this.broker = broker;
}
CharacterWidget.prototype.setFocus = function()
{  
  ////;     
  if(this.inputWidget)
  {
    this.inputWidget.focus();
  }
}
CharacterWidget.prototype.setManager = function(oCharacterWidgetManager)
{
  ////;     
  if(oCharacterWidgetManager)
  {
    this.oCharacterWidgetManager = oCharacterWidgetManager;
  }
}
CharacterWidget.prototype.setActiveColor = function()
{
  ////;     
  if ( this.oCharacterWidgetManager.sBgColorActive )
  {
    this.characterWidget.style.background = this.oCharacterWidgetManager.sBgColorActive;
    if(this.inputWidget)
    {
      this.inputWidget.style.background = this.oCharacterWidgetManager.sBgColorActive;
    }
  }
  if (this.oCharacterWidgetManager.sFgColorActive )
  {
    this.characterWidget.style.color = this.oCharacterWidgetManager.sFgColorActive;
    if(this.inputWidget)
    {
      this.inputWidget.style.color = this.oCharacterWidgetManager.sFgColorActive;
    }
  }
}
CharacterWidget.prototype.setInactiveColor = function()
{
  ////;     
  if ( this.oCharacterWidgetManager.sBgColorInactive )
  {
    this.characterWidget.style.background = this.oCharacterWidgetManager.sBgColorInactive;
    if(this.inputWidget)
    {
      this.inputWidget.style.background = this.oCharacterWidgetManager.sBgColorInactive;
    }
  }
  if ( this.oCharacterWidgetManager.sFgColorInactive )
  {
    this.characterWidget.style.color = this.oCharacterWidgetManager.sFgColorInactive;
    if(this.inputWidget)
    {
      this.inputWidget.style.color = this.oCharacterWidgetManager.sFgColorInactive;
    }
  }
}
CharacterWidget.prototype.setEvaluatedColor = function()
{
  ////;     
  if ( this.sBgEvaluatedColor )
  {
    this.characterWidget.style.background = this.sBgEvaluatedColor;
    if(this.inputWidget)
    {
      this.inputWidget.style.background = this.sBgEvaluatedColor;
    }
  }
  if ( this.sFgEvaluatedColor )
  {
    this.characterWidget.style.color = this.sFgEvaluatedColor;
    if(this.inputWidget)
    {
      this.inputWidget.style.color = this.sFgEvaluatedColor;
    }
  }
}
CharacterWidget.prototype.setCorrectColor = function()
{
  ////;     
  if ( this.oCharacterWidgetManager.sBgColorCorrect )
  {
    this.characterWidget.style.background = this.oCharacterWidgetManager.sBgColorCorrect;
    if(this.inputWidget)
    {
      this.inputWidget.style.background = this.oCharacterWidgetManager.sBgColorCorrect;
    }
  }
  if ( this.oCharacterWidgetManager.sFgColorCorrect )
  {
    this.characterWidget.style.color = this.oCharacterWidgetManager.sFgColorCorrect;
    if(this.inputWidget)
    {
      this.inputWidget.style.color = this.oCharacterWidgetManager.sFgColorCorrect;
    }
  }
}
CharacterWidget.prototype.setWrongColor = function()
{
  ////;     
  if ( this.oCharacterWidgetManager.sBgColorWrong )
  {
    this.characterWidget.style.background = this.oCharacterWidgetManager.sBgColorWrong;
    if(this.inputWidget)
    {
      this.inputWidget.style.background = this.oCharacterWidgetManager.sBgColorWrong;
    }
  }
  if ( this.oCharacterWidgetManager.sFgColorWrong )
  {
    this.characterWidget.style.color = this.oCharacterWidgetManager.sFgColorWrong;
    if(this.inputWidget)
    {
      this.inputWidget.style.color = this.oCharacterWidgetManager.sFgColorWrong;
    }
  }
}
CharacterWidget.prototype.setTipColor = function()
{
  ////;     
  if ( this.oCharacterWidgetManager.sBgColorTip )
  {
    this.characterWidget.style.background = this.oCharacterWidgetManager.sBgColorTip;
    if(this.inputWidget)
    {
      this.inputWidget.style.background = this.oCharacterWidgetManager.sBgColorTip;
    }
  }
  if ( this.oCharacterWidgetManager.sFgColorTip )
  {
    this.characterWidget.style.color = this.oCharacterWidgetManager.sFgColorTip;
    if(this.inputWidget)
    {
      this.inputWidget.style.color = this.oCharacterWidgetManager.sFgColorTip;
    }
  }
}
CharacterWidget.prototype.changedAnswer = function(model)
{
  if(model.isEvaluated())
  {
    if(model.getEvaluation().isActive())
    {
      if (model.getEvaluation().isCorrect() == true)
      {
        this.setCorrectColor();
        if (this.broker) { this.broker.showCorrect(); }
      }
      else if (model.getEvaluation().isCorrect() == false)
      {
        this.setWrongColor();
        if (this.broker) { this.broker.showWrong(); }
      }
    }
  }
  else
  {
        var question = model.getEvaluation().getQuestion();
        //;
        var nCount = 0;
        if (model.getEvaluation().isActive())
        {
          nCount++;
        }
        if (this.modelItem.workItem.getEvaluation(question, this.modelItem).isActive())
        {
          nCount++;
        }
        if (nCount == 0)
        {
          //;
          if(this.inputWidget)
          {
            this.inputWidget.value = '';
          }
          if(this.sFgEvaluatedColor || this.sBgEvaluatedColor)
          {
            this.setEvaluatedColor();
          }
          else
          {
            this.setInactiveColor();
          }
          if (this.broker) { this.broker.showUnassigned(); }
        }
        else
        {
          switch (model.getEvaluation().getOrigin())
          {
            case 'user':
              if(! ( this.sFgEvaluatedColor || this.sBgEvaluatedColor ))
              {
                this.setActiveColor();
              }
              else
              {
                if(model.getEvaluation().isActive())
                {
                  if(question == this.modelItem )
                  {
                    this.setCorrectColor();
                  }
                  else
                  {
                    this.setWrongColor();
                  }
                }
              }
              if (question == this.modelItem )
              {
                //;
              }
              else
              {
                //;
              }
              if (this.broker) { this.broker.showAssigned(); }
              break;
            case 'system_set':
              this.setTipColor();
              if (this.broker) { this.broker.showTipAssigned(); }
              break;
            case 'system_solution':
              this.setTipColor();
              if (this.broker) { this.broker.showSolution(); }
              break;
            case 'system_approve':
              this.setCorrectColor();
              if (this.broker) { this.broker.showTipApproveCorrect(); }
              break;
            case 'system_brand':
              break;
          }
          if(model.getEvaluation().isActive())
          {
            if(this.inputWidget)
            {
              this.inputWidget.value = model.getText().toUpperCase();
            }
          }
        }
     }
}
CharacterWidget.prototype.changed = function(model)
{  
  ;
  if(model.isEvaluated())
  {
    var bActiveAnswer = false;
    for(var i in this.aAssociatedAnswers)
    {
      if(this.aAssociatedAnswers[i].getEvaluation().isActive())
      {
        bActiveAnswer = true;
        break;
      }
    }
    if(!bActiveAnswer)
    {
      this.setWrongColor();
      if (this.broker) { this.broker.showWrong(); }
    }
  }
  else
  {
    if(model.getEvaluation())
    {
      var oAnswer = model.getEvaluation().getAnswer();
      var nx = oAnswer.getXPos();
      var ny =  oAnswer.getYPos();
      if (nx == this.nX && ny == this.nY )
      {
        if(!this.aAssociatedAnswers[oAnswer.getId()])
        {
          this.aAssociatedAnswers[oAnswer.getId()] = oAnswer;
          var answerWidget = new CharacterWidgetAnswer('char_widget_' + oAnswer.getId(), this);
          oAnswer.registerStatusChangeListener(answerWidget);
        }
      }
    }
  }
}
CharacterWidget.prototype.eventFromChild = function(childName, eventType, event)
{
  ////;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "keypress" :
      //;
      this.keypressHandler(domlet, event);
      break;
    case "mousedown" :
      //;      
      this.clickHandler(domlet, event);
      break;
    case "mouseover" :
      //;      
      this.mouseoverHandler(domlet, event);
      break;
  }
}
CharacterWidget.prototype.keypressHandler = function(domlet, event)
{
  ;
  ;
  if(!this.bActive)
  {
    Browser.eventPreventDefault(event);
    return;
  }
  this.sFgEvaluatedColor = null;
  this.sBgEvaluatedColor = null;
  if (event.keyCode == 13)
  {
    this.oCharacterWidgetManager.colorizeDisplay();
  }
  else if (event.keyCode == 37 || event.keyCode == 38 || event.keyCode == 39 || event.keyCode == 40)
  {
     this.oCharacterWidgetManager.setFocusByArrowKey( event.keyCode, this);
  }
  else
  {
    var sChar = '';
    sChar = String.fromCharCode(Browser.getKeyCodeFromEvent(event));
    var isLetter = -1;
    if(sChar)
    {
      sChar = sChar.toLowerCase();
      isLetter = true;
    }
    if(sChar && isLetter != -1)
    {
      this.assignText(sChar);
    }
  }
  Browser.eventPreventDefault(event);  
}
CharacterWidget.prototype.clickHandler = function(domlet, event)
{
  ////;
  this.oCharacterWidgetManager.clickCharacterWidget(this);  
}
CharacterWidget.prototype.mouseoverHandler = function(domlet, event)
{
  ////;
}
CharacterWidget.prototype.colorizeDisplay = function(oQuestion)
{
  ////;
  if ( this.modelItem)
  {
    var oEvaluation = this.modelItem.workItem.getEvaluation(oQuestion, this.modelItem);
    if(oEvaluation && oEvaluation.isActive() && oEvaluation.isCorrect() )
    {
      this.setCorrectColor();
      this.sFgEvaluatedColor = this.oCharacterWidgetManager.sFgColorCorrect;
      this.sBgEvaluatedColor = this.oCharacterWidgetManager.sBgColorCorrect;
    }
    else
    {
      this.setWrongColor();
      this.sFgEvaluatedColor = this.oCharacterWidgetManager.sFgColorWrong;
      this.sBgEvaluatedColor = this.oCharacterWidgetManager.sBgColorWrong;
    }
  }
}
CharacterWidget.prototype.assignText = function(sChar)
{
  ;
  if(sChar)
  {
    this.oCharacterWidgetManager.assignText( this, sChar);
  }
}
CharacterWidget.prototype.enableInput = function()
{
  if(!this.bActive)
  {
    this.bActive = true;
  }
}
CharacterWidget.prototype.disableInput = function()
{
  if(this.bActive)
  {
    this.bActive = false;
  }
}
function CharacterWidgetAnswer(sId, characterWidget)
{
  this.sId = sId;
  this.characterWidget = characterWidget;
  this.modelItem = null;
}
CharacterWidgetAnswer.prototype.changed = function(model)
{
  this.characterWidget.changedAnswer(model);
}
CharacterWidgetAnswer.prototype.setModelItem = function(modelItem)
{
  this.modelItem = modelItem;
}
CharacterWidgetAnswer.prototype.getId = function()
{
  return this.sId;
}
QuestionButtonWidget.prototype             = new DomletCtr();
QuestionButtonWidget.prototype.constructor = QuestionButtonWidget;
QuestionButtonWidget.superclass            = DomletCtr.prototype;
function QuestionButtonWidget(sId, sQuestionButtonWidgetDomId, nX, nY)
{
  if (sId) { this.init(sId, sQuestionButtonWidgetDomId, nX, nY); }
}
QuestionButtonWidget.prototype.init = function(sId, sQuestionButtonWidgetDomId, nX, nY)
{
  //;       
  this.sId = sId;      
  this.modelItem = null;
  this.broker = null;
  QuestionButtonWidget.superclass.init.call(this, sQuestionButtonWidgetDomId, sId, this);  
  this.questionButtonWidget = document.getElementById(sQuestionButtonWidgetDomId);
  this.sQuestionButtonWidgetDomId = sQuestionButtonWidgetDomId;
  if (this.questionButtonWidget == null)
  {
    ;
  }
  this.addDomlet(new Domlet(
    this.sQuestionButtonWidgetDomId,      
    this.sQuestionButtonWidgetDomId,      
    this,                                 
    new Array('click'))                   
  )      
  this.nX = nX;   
  this.nY = nY;   
}
QuestionButtonWidget.prototype.getId = function()
{
  //;
  return this.sId;
}
QuestionButtonWidget.prototype.getQuestionButtonWidgetDomId = function()
{
  //;
  return this.sQuestionButtonWidgetDomId;
}
QuestionButtonWidget.prototype.getXPos = function()
{
  //;
  return this.nX;
}
QuestionButtonWidget.prototype.getYPos = function()
{
  //;
  return this.nY;
}
QuestionButtonWidget.prototype.setManager = function(oQuestionButtonWidgetManager)
{
  //;
  if(oQuestionButtonWidgetManager)
  {
    this.oQuestionButtonWidgetManager = oQuestionButtonWidgetManager;
  }
}
QuestionButtonWidget.prototype.setModelItem = function(modelItem)
{
  //;
  this.modelItem = modelItem;
}
QuestionButtonWidget.prototype.setBroker = function(broker)
{
  //;
  this.broker = broker;
}
QuestionButtonWidget.prototype.getModelItem = function()
{
  //;
  return this.modelItem;
}
QuestionButtonWidget.prototype.changed = function(model)
{  
  ;
  if (model.isEvaluated())
  {      
    if (this.modelItem.isSolved() == true)
    {                                          
      if (this.broker) { this.broker.showCorrect(); }
    }
    else if (this.modelItem.isSolved() == false)
    {      
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
  }
}
QuestionButtonWidget.prototype.eventFromChild = function(childName, eventType, event)
{
  //;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "mousedown" :
      ;      
      break;
    case "mouseup" :
      ;
      break;
    case "mouseover" :
      ;
      break;
    case "mouseout" :
      ;
      break;
    case "mousemove" :
      ;
      break;
    case "click" :
      ;
      this.clickHandler(domlet, event);      
      break;
  }
} 
QuestionButtonWidget.prototype.clickHandler = function(domlet, event)
{
  //;
  this.oQuestionButtonWidgetManager.clickQuestionButtonWidget(this);  
}
