/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Point</DEPENDS>
</DEPENDENCIES>
*/
Dragable.prototype = new DomletCtr();
Dragable.prototype.constructor = Dragable;
Dragable.superclass = DomletCtr.prototype;
function Dragable( sId, sWidgetDomId, nHotSpotX, nHotSpotY, sWidgetLug )
{
  if( sId )
  {
    this.init(sId, sWidgetDomId, nHotSpotX, nHotSpotY, sWidgetLug);
  }
}
Dragable.prototype.init = function( sId, sWidgetDomId, nHotSpotX, nHotSpotY, sWidgetLug )
{
  ;
  var me = this;
  this.sId = sId;
  this.dragWidget = Browser.getElementById(sWidgetDomId);
  this.oLug = Browser.getElementById(sWidgetLug);
  this.dragnDropManager = null;
  this.nHotSpotX = nHotSpotX;
  this.nHotSpotY = nHotSpotY;
  this.nOriginalHotSpotX = nHotSpotX;
  this.nOriginalHotSpotY = nHotSpotY;
  this.homePos = null;
  this.dropTarget = null;
  this.snapToken = null;
  this.dropPos = null;
  this.sStylePosition = '';
  if( this.dragWidget == null )
  {
    ;
  }
  if( this.oLug == null )
  {
    this.oLug = this.dragWidget;
  }
  if( sWidgetLug ) 
  {
    Dragable.superclass.init.call(this, sWidgetLug, sId, null);
  }
  else
  {
    Dragable.superclass.init.call(this, sWidgetDomId, sId, null);
  }
  this.addDomlet(new Domlet(
          this.oLug.id, 
          this.name, 
          this.parent, 
          new Array('mousedown')) 
          )
  this.beginDragAction = null;
  this.endDragAction = null;
  this.showOverAction = null;
  this.showOutAction = null;
  this.mouseUpHandler = function( e )
  {
    ;
    if( e )
    {
      var event = e;
    }
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEMOVE, me.mouseMoveHandler);
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEUP, me.mouseUpHandler);
    Browser.removeEventListenerFromDocument(Browser.eventNames.MOUSEOUT, me.mouseOutHandler);
    if( me.inMouseMove )
    {
      me.dropPos = new Point(event.clientX, event.clientY);
      me.inMouseMove = false;
      me.endDrag();
    }
    return false;
  }
  this.mouseMoveHandler = function( e )
  {
    ;
    if( e )
    {
      var event = e;
    }
    //;
    if( !me.inMouseMove )
    {
      if( Math.abs(event.clientX - me.mouseDownX) > 2 || Math.abs(event.clientY - me.mouseDownY) > 2 )
      {
        me.inMouseMove = true;
        me.beginDrag(event);
        me.lostDeltaX = event.clientX - me.mouseDownX;
        me.lostDeltaY = event.clientY - me.mouseDownY;
      }
    }
    if( me.inMouseMove )
    {
      var nX = event.clientX - me.deltaX + me.lostDeltaX;
      var nY = event.clientY - me.deltaY + me.lostDeltaY;
      Browser.moveTo(me.dragWidget, new Point(nX, nY));
      Browser.eventStopPropagation(event);
      Browser.eventPreventDefault(event);
      me.dragnDropManager.drag(me, nX + me.nHotSpotX, nY + me.nHotSpotY);
    }
    ;
    return false;
  }
  this.mouseOutHandler = function( event )
  {
    ;
    if( Browser.getId() == 'moz' )
    {
      if( event.explicitOriginalTarget.nodeName == 'HTML' )
      {
        me.mouseUpHandler(event);
      }
    }
    else
    {
      if( event.srcElement.tagName == 'BODY' )
      {
        me.mouseUpHandler(event);
      }
    }
  }
}
Dragable.prototype.getId = function()
{
  return this.sId;
}
Dragable.prototype.isDropped = function()
{
  return (this.dropTarget != null);
}
Dragable.prototype.getDropTarget = function()
{
  return this.dropTarget;
}
Dragable.prototype.start = function()
{
  ;
}
Dragable.prototype.getPos = function()
{
  //;
  var point = new Point(0, 0);
  Browser.getAbsPos(this.dragWidget, point);
  return point;
}
Dragable.prototype.setManager = function( dragnDropManager )
{
  ;
  this.dragnDropManager = dragnDropManager;
}
Dragable.prototype.enter = function( oDropTarget )
{
  ;
  if( this.showOverAction )
  {
    this.showOverAction.invoke();
  }
}
Dragable.prototype.leave = function( oDropTarget )
{
  ;
  if( this.showOutAction )
  {
    this.showOutAction.invoke();
  }
}
Dragable.prototype.drop = function( oDropTarget, bDropped )
{
  ;
  if( bDropped )
  {
  }
  else
  {
    this.moveToHomePosition();
    this.dropTarget = null;
  }
}
Dragable.prototype.lift = function( oDropTarget )
{
  ;
  this.dropTarget = null;
}
Dragable.prototype.setBeginDragAction = function( action )
{
  ;
  this.beginDragAction = action;
}
Dragable.prototype.setEndDragAction = function( action )
{
  ;
  this.endDragAction = action;
}
Dragable.prototype.setShowOverAction = function( action )
{
  ;
  this.showOverAction = action;
}
Dragable.prototype.setShowOutAction = function( action )
{
  ;
  this.showOutAction = action;
}
Dragable.prototype.moveToSnapPosition = function( snapPoint )
{
  if( ! this.homePos )
  {
    this.homePos = this.getPos();
    this.sStylePosition = this.dragWidget.style.position;
  }
  var nX = snapPoint.x - this.nOriginalHotSpotX;
  var nY = snapPoint.y - this.nOriginalHotSpotY;
  Browser.moveTo(this.dragWidget, new Point(nX, nY));
}
Dragable.prototype.moveToHomePosition = function()
{
  if( this.homePos )
  {
    Browser.moveTo(this.dragWidget, this.homePos);
    this.dragWidget.style.position = this.sStylePosition;
  }
}
Dragable.prototype.eventFromChild = function( childName, eventType, event )
{
  //;
  var domlet = this.domlets[childName];
  switch( eventType )
          {
    case "mousedown" :
      ;
      this.mouseDownHandler(domlet, event);
      break;
    case "mouseup" :
      ;
      break;
    case "mouseover" :
      ;
      break;
    case "mouseout" :
      ;
      break;
    case "mousemove" :
    //;
      break;
    case "click" :
      ;
      break;
  }
}
Dragable.prototype.mouseDownHandler = function( domlet, event )
{
  ;
  if( ! this.homePos )
  {
    this.dropPos = null;
    this.homePos = this.getPos();
    this.sStylePosition = this.dragWidget.style.position;
  }
  if( this.inMouseMove )
  {
    this.mouseUpHandler(event);
  }
  else
  {
    Browser.setToplevel(this.dragWidget);
    Browser.eventStopPropagation(event);
    Browser.eventPreventDefault(event);
    this.mouseDownX = event.clientX;
    this.mouseDownY = event.clientY;
    this.inMouseMove = false;
    if( this.hotSpotToMousePositionOnClick )
    {
      var point = this.getPos();
      this.nHotSpotX = event.clientX - point.x + Browser.getBodyScrollLeft();
      this.nHotSpotY = event.clientY - point.y + Browser.getBodyScrollTop();
    }
    if( this.mouseCoords )
    {
      Browser.moveTo(this.dragWidget, new Point(event.clientX - this.mouseCoords.x, event.clientY - this.mouseCoords.y));
    }
    Browser.addEventListenerToDocument(Browser.eventNames.MOUSEMOVE, this.mouseMoveHandler);
    Browser.addEventListenerToDocument(Browser.eventNames.MOUSEUP, this.mouseUpHandler);
    Browser.addEventListenerToDocument(Browser.eventNames.MOUSEOUT, this.mouseOutHandler);
    return false;
  }
}
Dragable.prototype.beginDrag = function( event )
{
  var point = this.getPos();
  this.deltaX = event.clientX - point.x;
  this.deltaY = event.clientY - point.y;
  if( this.beginDragAction ) this.beginDragAction.invoke();
  this.dragnDropManager.beginDrag(this);
}
Dragable.prototype.endDrag = function( domlet, event )
{
  if( this.endDragAction )
    this.endDragAction.invoke();
  this.dragnDropManager.endDrag(this);
  if( !this.isDropped() )
  {
    this.moveToHomePosition();
  }
}
Dragable.prototype.setHotSpotToMousePositionOnClick = function( hotSpotToMousePositionOnClick )
{
  this.hotSpotToMousePositionOnClick = (hotSpotToMousePositionOnClick == undefined ? true
          : hotSpotToMousePositionOnClick);
}
Dragable.prototype.setRepositionRelativeToMousePointer = function( x, y )
{
  if( x != undefined && y != undefined )
    this.mouseCoords = new Point(x, y);
}
