/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>DragnDropManager</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Point</DEPENDS>
</DEPENDENCIES>
*/
function OrderedDropTarget(sId, manager, model, position)
{
  this.init(sId, manager, model, position);
}
OrderedDropTarget.prototype.init = function(sId, manager, model, position)
{
  this.sId = sId;
  this.oModel = model;
  this.oManager = manager;
  this.nPosition = position;
}
OrderedDropTarget.prototype.getId = function()
{
  return this.sId;
}
OrderedDropTarget.prototype.setModelItem = function(oModel)
{
  this.oModel = oModel;
}
OrderedDropTarget.prototype.getModelItem = function()
{
  return this.oModel;
}
OrderedDropTarget.prototype.getPosition = function()
{
  return parseInt(this.nPosition);
}
function OrderedDragable(sId, manager, model)
{
  this.init(sId, manager, model);
}
OrderedDragable.prototype.init = function(sId, manager, model)
{
  this.sId = sId;
  this.oManager = manager;
  this.oModel = model;
  this.oModel.registerStatusChangeListener(this);
}
OrderedDragable.prototype.getId = function()
{
  return this.sId;
}
OrderedDragable.prototype.setModelItem = function(oModel)
{
  this.oModel = oModel;
}
OrderedDragable.prototype.getModelItem = function()
{
  return this.oModel;
}
OrderedDragable.prototype.changed = function(model)
{
  ;
  if (!model.isEvaluated())
  {
    if(model.getEvaluation().isActive())
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':
          this.oManager.dropped(this);
          break;
        case 'system_set':
          this.oManager.updateAllFromModel();
          break;
        case 'system_approve':
          this.oManager.dropped(this);
          break;
        case 'system_off':
          break;
      }
    }
    else
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':
          this.oManager.dropped(this);
          break;
        case 'system_set':
          break;
        case 'system_off':
          break;
      }
    }
  }
}
DragnDropOrderManager.prototype             = new DragnDropManager();
DragnDropOrderManager.prototype.constructor = DragnDropOrderManager;
DragnDropOrderManager.superclass            = DragnDropManager.prototype;
function DragnDropOrderManager(sId)
{
  if (sId) { this.init(sId); }
}
DragnDropOrderManager.prototype.init = function(sId)
{
  ;
  DragnDropOrderManager.superclass.init.call(this, sId);
  this.aOrderedDropTargets = new Array();
  this.aOrderedDragables = new Array();
  this.aDragableModels = new Array();   
  this.aDropTargetModels = new Array();   
  this.emptyMatcherDropTarget = null;
  this.bAssigning = false;
}
DragnDropOrderManager.prototype.start = function()
{
  ;
  DragnDropOrderManager.superclass.start.call(this);
  this.initOrder();
}
DragnDropOrderManager.prototype.initOrder = function()
{
  ;
  this.aOrderedDropTargets = new Array();
  this.aOrderedDragables = new Array();
  this.aDragableModels = new Array();   
  this.aDropTargetModels = new Array();   
  for(var i in this.aDragables)
  {
    var dragable = new OrderedDragable(this.aDragables[i].getId() + "_ordered", this, this.aDragables[i].getModelItem());
    this.aOrderedDragables.push(dragable);
    this.aDragableModels[dragable.getModelItem().getId()] = dragable;
  }
  for(var i in this.aDropTargets)
  {
    var dropTarget = new OrderedDropTarget(this.aDropTargets[i].getId() + "_ordered", this, this.aDropTargets[i].getModelItem(), this.aOrderedDropTargets.length);
    this.aOrderedDropTargets.push(dropTarget);
    this.aDropTargetModels[dropTarget.getModelItem().getId()] = dropTarget;
  }
  if(this.aOrderedDragables.length > this.aOrderedDropTargets.length)
  {
    ;
  }
  this.assignAll('system_off');
}
DragnDropOrderManager.prototype.resetOrder = function()
{
  ;
  this.aOrderedDropTargets = new Array();
  this.aOrderedDragables = new Array();
  for(var i in this.aDragables)
  {
    this.aOrderedDragables.push(this.aDragableModels[this.aDragables[i].getModelItem().getId()]);
  }
  for(var i in this.aDropTargets)
  {
    this.aOrderedDropTargets.push(this.aDropTargetModels[this.aDropTargets[i].getModelItem().getId()]);
  }
  if(this.aOrderedDragables.length > this.aOrderedDropTargets.length)
  {
    ;
  }
  this.assignAll('system_off');
}
DragnDropOrderManager.prototype.updateAllFromModel = function()
{
  var aNewOrderedDragables = new Array();
  var bFullyAssigned = true;
  for(var id in this.aOrderedDropTargets)
  {
    var dropTarget = this.aOrderedDropTargets[id];
    var answer = dropTarget.getModelItem().getActiveAnswer();
    if(answer)
    {
      var dragable = this.aDragableModels[dropTarget.getModelItem().getActiveAnswer().getId()];
      aNewOrderedDragables.push(dragable);
    }
    else
    {
      bFullyAssigned = false;
      break;
    }
  }
  if(bFullyAssigned)
  {
    this.aOrderedDragables = aNewOrderedDragables;
  }
}
DragnDropOrderManager.prototype.assignAll = function(sOrigin)
{
  ;
  this.bAssigning = true;
  for(var i in this.aOrderedDragables)
  {
    var dropTarget = this.aOrderedDropTargets[i];
    var dragable = this.aOrderedDragables[i];
    if(dropTarget)
    {
      var question = dropTarget.getModelItem();
      var answer = dragable.getModelItem();
      var evaluation = question.workItem.getOrCreateEvaluation(question, answer);
      evaluation.setActive(true, sOrigin);
    }
    else
    {
      ;
    }
  }
  this.bAssigning = false;
}
DragnDropOrderManager.prototype.dropped = function(oDragable)
{
    ;
    if(!this.bAssigning)
    {
      var answer = oDragable.getModelItem();
      if(answer.countActiveEvaluations() > 0)
      {
        var evaluation = answer.getActiveEvaluations()[0];
        var oDropTarget = this.aDropTargetModels[evaluation.getQuestion().getId()];
        this.queueDragableAtDropTraget(oDragable, oDropTarget);
        this.assignAll(evaluation.getOrigin());
      }
      else
      {
        if(answer.lastEvaluation)
        {
          ;
        }
      }
    }
    else
    {
      ;
    }
}
DragnDropOrderManager.prototype.queueDragableAtDropTraget = function(oDragable, oDropTarget)
{
  ;
  var currentDropTarget = this.getCurrentlyAssignedDropTarget(oDragable)
  if(currentDropTarget.getId() == oDropTarget.getId())
  {
    ;
    return;
  }
  var fromPos = currentDropTarget.getPosition();
  var toPos = oDropTarget.getPosition();
  ;
  if(toPos > fromPos)
  {
    for(var i = fromPos; i < toPos; i++)
    {
      this.aOrderedDragables[i] = this.aOrderedDragables[i + 1];
      ;
    }
    this.aOrderedDragables[toPos] = oDragable;
  }
  else if(toPos < fromPos)
  {
    for(var i = fromPos; i > toPos; i--)
    {
      this.aOrderedDragables[i] = this.aOrderedDragables[i - 1];
      ;
    }
    this.aOrderedDragables[toPos] = oDragable;
  }
}
DragnDropOrderManager.prototype.getCurrentlyAssignedDropTarget = function(oDragable)
{
  for(var i in this.aOrderedDropTargets)
  {
    if(this.aOrderedDragables[i].getId() == oDragable.getId())
    {
      if(this.aOrderedDropTargets[i])
      {
        return this.aOrderedDropTargets[i];
      }
      else
      {
        ;
      }
    }
  }
  ;
}
DragnDropOrderManager.prototype.beginDrag = function(oDragable)
{
  ;
  if (oDragable.isDropped())
  {
    this.emptyMatcherDropTarget = oDragable.getDropTarget();
    DragnDropOrderManager.superclass.beginDrag.call(this, oDragable);
  }
}
DragnDropOrderManager.prototype.endDrag = function(oDragable)
{
  ;
  if (oDragable.endDragAction) oDragable.endDragAction.invoke();
  var dropTarget = this.dragableHit;
  if (!dropTarget)
  {
    dropTarget = this.emptyMatcherDropTarget;
    this.emptyMatcherDropTarget = null;
  }
  dropTarget.leave(oDragable);
  this.dragableHit = null;
  dropTarget.drop(oDragable);
}
DragnDropOrderManager.prototype.reset = function()
{
  ;
  var resetAction = new SyncObjectMethodAction(this, 'resetOrder');
  resetAction.invoke();
}
