/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Dragable</DEPENDS>
</DEPENDENCIES>
*/
DnDMatcherDragable.prototype             = new Dragable();
DnDMatcherDragable.prototype.constructor = DnDMatcherDragable;
DnDMatcherDragable.superclass            = Dragable.prototype;
function DnDMatcherDragable(sId, sWidgetDomId, nHotSpotX, nHotSpotY, sWidgetLug)
{
  if (sId) { this.init(sId, sWidgetDomId, nHotSpotX, nHotSpotY, sWidgetLug); }
}
DnDMatcherDragable.prototype.init = function(sId, sWidgetDomId, nHotSpotX, nHotSpotY, sWidgetLug)
{
  ;
  DnDMatcherDragable.superclass.init.call(this, sId, sWidgetDomId, nHotSpotX, nHotSpotY, sWidgetLug);
  this.modelItem = null;
  this.broker = null;
}
DnDMatcherDragable.prototype.setModelItem = function(modelItem)
{
  ;
  this.modelItem = modelItem;
}
DnDMatcherDragable.prototype.getModelItem = function()
{
  return this.modelItem;
}
DnDMatcherDragable.prototype.setBroker = function(broker)
{
  ;
  this.broker = broker;
}
DnDMatcherDragable.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if (model.isSolved() == true)
    {
      if (this.broker) { this.broker.showCorrect(); }
    }
    else if (model.isSolved() == false)
    {
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
  }
  else
  {
    if (model.getEvaluation().hasOffItem())
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':
          if (this.broker) { this.broker.showAssigned(); }
          break;
        case 'system_set':
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_solution':
          if (this.broker) { this.broker.showSolution(); }
          break;
        case 'system_approve':
          if (this.broker) { this.broker.showTipApproveCorrect(); }
          break;
        case 'system_brand':
          if (this.broker) { this.broker.showTipBrandWrong(); }
          break;
        case 'system_off':
          if (this.broker) { this.broker.showUnassigned(); }
          break;
      }
    }
    else
    {
      var nCount = model.countActiveEvaluations();
      if (nCount == 0)
      {
        if (this.broker) { this.broker.showUnassigned(); }
        if(model.getEvaluation().getOrigin() == 'system_solution')
        {
          if (this.broker) { this.broker.showSolution(); }
        }
        if(!this.inMouseMove)
        {
          this.moveToHomePosition();
          if (this.broker) { this.broker.homePosition(); }
        }
        this.dropTarget = null;
      }
      else if (nCount == 1)
      {
        switch (model.getEvaluation().getOrigin())
        {
          case 'user':
            if (this.broker) { this.broker.showAssigned(); }
            break;
          case 'system_solution':
            if (this.broker) { this.broker.showSolution(); }
            break;
          case 'system_set':
            if (this.broker) { this.broker.showTipAssigned(); }
            break;
          case 'system_approve':
            if (this.broker) { this.broker.showTipApproveCorrect(); }
            break;
          case 'system_brand':
            if (this.broker) { this.broker.showTipBrandWrong(); }
            break;
        }
        var questionItem = model.getActiveQuestion();
        if (questionItem == null)
        {
          ;
        }
        else
        {
          this.dropTarget = this.dragnDropManager.getDropTargetByModel(questionItem);
          if (this.dropTarget)
          {
            this.dropTarget.snap(this);
          }
        }
      }
      else
      {
        ;
      }
    }
  }
}
DnDMatcherDragable.prototype.endDrag = function(domlet, event)
{
  ;
  DnDMatcherDragable.superclass.endDrag.call(this, domlet, event);
  if (!this.isDropped())
  {
    if (this.broker) { this.broker.homePosition(); }
  }
}
DnDMatcherDragable.prototype.setShowAssignedAction = function(action)
{
  ;
  this.showAssignedAction = action;
}
DnDMatcherDragable.prototype.setShowUnassignedAction = function(action)
{
  ;
  this.showUnassignedAction = action;
}
DnDMatcherDragable.prototype.setShowTipAssignedAction = function(action)
{
  ;
  this.showTipAssignedAction = action;
}
DnDMatcherDragable.prototype.setShowTipApproveCorrectAction = function(action)
{
  ;
  this.showTipApproveCorrectAction = action;
}
DnDMatcherDragable.prototype.setShowTipBrandWrongAction = function(action)
{
  ;
  this.showTipBrandWrongAction = action;
}
DnDMatcherDragable.prototype.setShowCorrectAction = function(action)
{
  ;
  this.showCorrectAction = action;
}
DnDMatcherDragable.prototype.setShowWrongAction = function(action)
{
  ;
  this.showWrongAction = action;
}
