/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
function MoviePlayer(playerregistry, movieurl, handleName, skipmillis)
{
    ;
    this.init(playerregistry, movieurl, handleName, skipmillis);
}
MoviePlayer.prototype.init = function(playerregistry, movieurl, handleName, skipmillis) {
  ;
  this.movieurl    = movieurl;
  this.isStarted   = false;
  this.isStopped   = false;
  this.isPaused    = false;
  this.isReset     = true;  
  this.actPosition = 0;     
  ;
  this.playerregistry = playerregistry;
  if (skipmillis == undefined)
    this.skipmillis = 2000;
  else
    this.skipmillis = skipmillis;
  this.moviehandle = null;
  try
  {
      ;
      this.moviehandle = playerregistry.register(this, handleName);
  }
  catch (e)
  {
      ;
  }
}
MoviePlayer.prototype.setMovieBroker = function(broker)
{
  this.movieBroker = broker;
  broker.addRequestMovieStartHandle(this.getMovieStartAction());
  broker.addRequestMovieStopHandle(this.getMovieStopAction());
  broker.addRequestMoviePauseHandle(this.getMoviePauseAction());
  broker.addSetTimePositionAbsoluteHandle(this.getSetTimePositionAbsoluteAction());
  broker.addRequestMovieForwardHandle(this.getMovieForwardAction());
  broker.addRequestMovieRewindHandle(this.getMovieRewindAction());
}
MoviePlayer.prototype.stopped = function() {
  return this.isStopped;
}
MoviePlayer.prototype.paused = function() {
  return this.isPaused;
}
MoviePlayer.prototype.position = function() {
  return this.actPosition;
}
MoviePlayer.prototype.setStatus = function(newstatus) {
  if (newstatus == "started") {
    this.isStarted   = true;
    this.isStopped   = false;
    this.isPaused    = false;
    this.isReset     = false;
    this.actPosition = 0;
  }
  else if (newstatus == "stopped") {
    this.isStarted   = false;
    this.isStopped   = true;
    this.isPaused    = false;
    this.isReset     = false;
    this.actPosition = 0;
  }
  else if (newstatus == "paused") {
    this.isStarted   = false;
    this.isStopped   = false;
    this.isPaused    = true;
    this.isReset     = false;
    this.actPosition = 0;
  }
  else if (newstatus == "reset") {
    this.isStarted   = false;
    this.isStopped   = false;
    this.isPaused    = false;
    this.isReset     = true;
    this.actPosition = 0;
  }
  else if (newstatus.indexOf("position") >= 0) {
    this.actPosition = parseInt(newstatus.substring(8));
  }
}
MoviePlayer.prototype.getMovieStartAction = function() {
    return new ObjectMethodAction(this, 'play');
}
MoviePlayer.prototype.getMovieStopAction = function() {
    return new ObjectMethodAction(this, 'stop');
}
MoviePlayer.prototype.getMoviePauseAction = function() {
    return new ObjectMethodAction(this, 'pause');
}
MoviePlayer.prototype.getMovieRewindAction = function() {
    return new ObjectMethodAction(this, 'rewind', this.skipmillis);
}
MoviePlayer.prototype.getMovieForwardAction = function() {
    return new ObjectMethodAction(this, 'forward', this.skipmillis);
}
MoviePlayer.prototype.getSetTimePositionAbsoluteAction = function(millis) {
    return new ObjectMethodAction(this, 'setTimePositionAbsolute', millis);
}
MoviePlayer.prototype.play = function() {
  ;
  this.moviehandle.play();
}
MoviePlayer.prototype.stop = function() {
  this.moviehandle.stop();
}
MoviePlayer.prototype.pause = function() {
    this.moviehandle.pause();
}
MoviePlayer.prototype.rewind = function(amount) {
  this.moviehandle.rewind(amount);
}
MoviePlayer.prototype.forward = function(amount) {
  this.moviehandle.forward(amount);
}
MoviePlayer.prototype.getLength = function() {
  return this.moviehandle.getlength();
}
MoviePlayer.prototype.setTimePositionAbsolute = function(time) {
  this.moviehandle.setTimePositionAbsolute(time);
}
