/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Product</DEPENDS>
    <DEPENDS>ProductComparison</DEPENDS>
</DEPENDENCIES>
*/
function ProductComparisonSlot(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
ProductComparisonSlot.prototype.init = function(sId)
{
	;
	this.sId = sId;
	this.bUserFocus = false;
	
	this.product = null;
	this.values = new Array();
	this.defaultValues = new Array();
	this.loadCounter = 0;
}
ProductComparisonSlot.prototype.getId = function()
{
	return this.sId;
}
ProductComparisonSlot.prototype.setManager = function(manager)
{
	;
	this.manager = manager;
}
ProductComparisonSlot.prototype.setDropTarget = function(dropTarget)
{
	this.dropTarget = dropTarget;
	dropTarget.setModelItem(this);
}
ProductComparisonSlot.prototype.addViewItem = function(viewItem)
{
	this.viewItem = viewItem;
	this.viewItem.setManager(this);
}
ProductComparisonSlot.prototype.registerTextValue = function(property, action, defaultValue)
{
	if (defaultValue == undefined || defaultValue == null)
		this.defaultValues[property] = "-";
	else
		this.defaultValues[property] = defaultValue;
	this.values[property] = action;
}
ProductComparisonSlot.prototype.registerImageValue = function(property, action, defaultImage)
{
	if (defaultImage == undefined || defaultImage == null)
	{
		;
		this.defaultValues[property] = "error.gif";
	}
	else
		this.defaultValues[property] = defaultImage;
	this.values[property] = action;
}
ProductComparisonSlot.prototype.setInfoVisible = function(visible)
{
	this.visible = visible;
	this.setVisible(visible);
}
ProductComparisonSlot.prototype.startDragAndDrop = function(product, position, event)
{
	this.manager.mainManager.startDragAndDrop(product, position, event);
}
ProductComparisonSlot.prototype.setProduct = function(product)
{
	;
	this.product = product;
	if (this.product)
	{
		if (!product.hasData())
		{
			;
			
			DynamicDataLoader.instance.loadProductData(new LoadDataMethodCall(
					this.sId + "_loaddata_" + this.loadCounter, this, product.getProductId()
					), product.getProductId());
			this.loadCounter++;
		}
	}
}
ProductComparisonSlot.prototype.getProduct = function()
{
	return this.product;
}
ProductComparisonSlot.prototype.hasProduct = function()
{
	return (this.product != null);
}
ProductComparisonSlot.prototype.start = function()
{
}
ProductComparisonSlot.prototype.notify = function()
{
	this.viewItem.changed(this.product);
	var data = null;
	if (this.product != null)
		data = this.product.getData();
	for (property in this.values)
	{
		var action = this.values[property];
		var value = null;
		if (data)
			value = data[property];
		if (value == null || value == undefined)
			value = this.defaultValues[property];
		var params = new Array();
		params[0] = value;
		action.invoke(params);
	}
}
ProductComparisonSlot.prototype.hasUserFocus = function()
{
	return this.bUserFocus;
}
ProductComparisonSlot.prototype.isEmpty = function()
{
	return (this.product == null);
}
ProductComparisonSlot.prototype.isInScope = function(product)
{
	
	return true;
}
ProductComparisonSlot.prototype.assign = function(product)
{
	if (product != null && this.product != null && this.product != product)
	{
		;
		this.manager.pushProduct(this, product);
	}
	else
	{
		;
		this.setProduct(product);
		this.notify();
	}
}
function LoadDataMethodCall(id, manager, productId)
{
	this.id = id;
	this.manager = manager;
	this.productId = productId;
	this.data = new Array();
}
LoadDataMethodCall.prototype.getId = function()
{
	return this.id;
}
LoadDataMethodCall.prototype.dataLoaded = function(data)
{
	;
	if (data)
	{
		for (var i in data)
		{
			this.data[i] = data[i];
		}
	}
}
LoadDataMethodCall.prototype.commit = function()
{
	;
	var product = this.manager.getProduct();
	if (product && (product.getProductId() == this.productId))
	{
		
		product.setData(this.data);
		this.manager.notify();
	}
	this.data = null;
}
