/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>HandleMap</DEPENDS>
    <DEPENDS>SpeechRecognitionHandle</DEPENDS>
    <DEPENDS>SpeechRecognizer</DEPENDS>
    <DEPENDS>SpeechRecognitionData</DEPENDS>
</DEPENDENCIES>
*/
function SpeechRecognitionRegistryManager(id, coreRecognizerHandle)
{
  ;
  this.coreRecognizerHandle  = coreRecognizerHandle;
  this.recognizerArray = new Array();
  this.recognizerHandleCount = 0;
  HandleMap.instance.registerHandle(id, this);
}
SpeechRecognitionRegistryManager.prototype.register = function(recognizer, recognitionHandle)
{
  ;
  var recohandle;
  var alreadyRegistered;
  if(recognitionHandle)
  {
    alreadyRegistered = true;
    recohandle = recognitionHandle;
    ;
  }
  else
  {
    alreadyRegistered = false;
    recohandle = 'js_speechrecognizer_handle_' + this.recognizerHandleCount++;
    ;
  }
  if(this.recognizerArray[recohandle])
  {
     ;
  }
  else
  {
    this.recognizerArray[recohandle] = recognizer;
    try
    {
      if(this.coreRecognizerHandle != undefined)
      {
        if(!alreadyRegistered)
        {
          HandleMap.instance.sendMessage(
            this.coreRecognizerHandle, 'registerRecognition',
            [recohandle, recognizer.modelURL, recognizer.applicationURL,
            recognizer.garbagelevel, recognizer.keepsamples,
            recognizer.stopafterrecognition]);
        }
        return new SpeechRecognitionHandle(recognizer, this.coreRecognizerHandle, recohandle);
      }
      else
      {
        return new SpeechRecognitionHandle(recognizer, undefined, recohandle);
      }
    }
    catch (e)
    {
         ;
    }
  }
  return new SpeechRecognitionHandle(recognizer, undefined, recohandle);
}
SpeechRecognitionRegistryManager.prototype.getRecognizer = function(recognitionHandle)
{
  return this.recognizerArray[recognitionHandle];
}
SpeechRecognitionRegistryManager.prototype.startPlayback = function(recognitionHandle) {
  ;
  recognizer = this.recognizerArray[recognitionHandle];
  recognizer.startPlayback();
}
SpeechRecognitionRegistryManager.prototype.stopPlayback = function(recognitionHandle) {
  ;
  recognizer = this.recognizerArray[recognitionHandle];
  recognizer.stopPlayback();
}
SpeechRecognitionRegistryManager.prototype.notifyPlaybackStarted = function(recognitionHandle) {
  ;
  recognizer = this.recognizerArray[recognitionHandle];
  ;
  if (recognizer)
  {
    controlBroker = recognizer.getControlBroker();
  	if (controlBroker)
  	{
  	  controlBroker.doSoundStarted();
  	}
  }
}
SpeechRecognitionRegistryManager.prototype.notifyPlaybackStopped = function(recognitionHandle) {
  ;
  recognizer = this.recognizerArray[recognitionHandle];
  ;
  if (recognizer)
  {
  		controlBroker = recognizer.getControlBroker();
  		if (controlBroker)
  		{
  			controlBroker.doSoundStopped();
  	    }
  }
}
SpeechRecognitionRegistryManager.prototype.startRecognition = function(recognitionHandle) {
  ;
  recognizer = this.recognizerArray[recognitionHandle];
  if (recognizer)
  {
  	recognizer.startRecognition();
  }
}
SpeechRecognitionRegistryManager.prototype.stopRecognition = function(recognitionHandle) {
  ;
  recognizer = this.recognizerArray[recognitionHandle];
  if (recognizer)
  {
  	recognizer.stopRecognition();
  }
}
SpeechRecognitionRegistryManager.prototype.notifyRecognitionStarted = function(recognitionHandle) {
  ;
  recognizer = this.recognizerArray[recognitionHandle];
  ;
  if (recognizer)
  {
  	controlBroker = recognizer.getControlBroker();
  	if (controlBroker)
  	{
  		controlBroker.doRecognitionStarted();
  	}
  }
}
SpeechRecognitionRegistryManager.prototype.notifyRecognitionStopped = function(recognitionHandle) {
  ;
  recognizer = this.recognizerArray[recognitionHandle];
  ;
  if (recognizer)
  {
  	controlBroker = recognizer.getControlBroker();
  	if (controlBroker)
  	{
  		controlBroker.doRecognitionStopped();
  	}
  }
}
SpeechRecognitionRegistryManager.prototype.earDataRecognized = function(recognitionHandle,
																		numberOfElements,
																		elementNumber,
																		wordNumber,
																		wordIdentifier,
																		framestart,
																		framestop,
																		confidencelevel)
{
  ;
  var earData = new SpeechRecognitionData(
  	numberOfElements,
  	elementNumber,
  	wordIdentifier,
  	wordNumber,
  	framestart,
  	framestop,
  	confidencelevel);
  if (elementNumber == 1)
  {
 	recognizer = this.recognizerArray[recognitionHandle];
    ;
  	if (recognizer)
  	{
		recognitionBroker = recognizer.getRecognitionBroker();
        ;
		if (recognitionBroker)
		{
    		recognitionBroker.doEarDataRecognized(earData);
    	}
  	}
  }
}
SpeechRecognitionRegistryManager.prototype.getResetAllAction = function() {
    return new ObjectMethodAction(this, 'resetAll');
}
SpeechRecognitionRegistryManager.prototype.resetAll = function() {
  	;
	HandleMap.instance.sendMessage(this.coreRecognizerHandle, 'reset', []);
}
