/*
<DEPENDENCIES>
    <DEPENDS>CrossWordsManager</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>WordGridCharacterWidget</DEPENDS>
    <DEPENDS>WordGridWord</DEPENDS>
    <DEPENDS>Question</DEPENDS>
</DEPENDENCIES>
*/
WordGridManager.prototype             = new CrossWordsManager();
WordGridManager.prototype.constructor = WordGridManager;
WordGridManager.superclass            = CrossWordsManager.prototype;
function WordGridManager(sId, sWordGridCharacterWidgetTemplate, nX, nY, aRandomArray, sShowCorrectURL, nShowCorrectWidth, nShowCorrectHeight )
{
  if (sId) { this.init(sId, sWordGridCharacterWidgetTemplate, nX, nY, aRandomArray, sShowCorrectURL, nShowCorrectWidth, nShowCorrectHeight); }
}
function WordGridPosContainer()
{
  this.cChar = null;
  this.aCrossWordsWords = new Array();
  this.aWordGridWords = this.aCrossWordsWords;
  this.oCharacterWidget = null;
  this.oTextGridAnswer = null;
}
WordGridManager.prototype.init = function(sId, sWordGridCharacterWidgetTemplate , nX, nY, aRandomArray , sShowCorrectURL, nShowCorrectWidth, nShowCorrectHeight )
{
  ;
  this.oOffWordGridWord = null;
  this.aRandomArray = aRandomArray;
  this.sShowCorrectURL = sShowCorrectURL;
  this.nShowCorrectWidth = nShowCorrectWidth;
  this.nShowCorrectHeight = nShowCorrectHeight;
  this.wordGridCharacterWidgetTemplate = this.characterWidgetTemplate;
  this.aFillCharacters = null;
  this.sId = sId;
  this.workItem = null; 
  this.bEvaluating = false;
  this.nXOffset = null;
  this.nYOffset = null;
  this.sFgColorTip = null;
  this.sFgColorWrong = null;
  this.sFgColorCorrect = null;
  this.sBgColorTip = null;
  this.sBgColorWrong = null;
  this.sBgColorCorrect = null;
  this.sFgColorInactive = null;
  this.sBgColorInactive = null;
  this.sFgColorActive = null;
  this.sBgColorActive = null;
  this.bMousedown = null;
  this.aWordGridWords = new Array();
  this.oActiveCrossWordsWord = null; 
  this.characterWidgetTemplate = document.getElementById(sWordGridCharacterWidgetTemplate);
  this.wordGridCharacterWidgetTemplate = this.characterWidgetTemplate;
  this.sCharacterWidgetTemplate = sWordGridCharacterWidgetTemplate;
  this.sWordGridCharacterWidgetTemplate = this.sCharacterWidgetTemplate;
  this.sBgColorInactive = this.characterWidgetTemplate.style.background;  
  this.sFgColorInactive = this.characterWidgetTemplate.style.color;  
  if (this.characterWidgetTemplate == null)
  {
    ;
  }
  this.aCrossWordsField = new Array();
  for( var x = 0; x < nX; x++)
  {
    this.aCrossWordsField[x] = new Array();
    for( var y = 0; y < nY; y++)
    {
      this.aCrossWordsField[x][y] = new WordGridPosContainer();
    }
  }
  this.aWordGridField = this.aCrossWordsField;
  this.nYOffset -= Math.ceil((( this.aWordGridField[0].length ) * ( parseInt(this.characterWidgetTemplate.style.height) + parseInt(this.characterWidgetTemplate.style.borderTopWidth) ) ) /2);
  this.nXOffset -= Math.ceil((( this.aWordGridField.length ) * ( parseInt(this.characterWidgetTemplate.style.width) + parseInt(this.characterWidgetTemplate.style.borderLeftWidth) ) ) /2);
  this.nYOffset += Math.ceil(parseInt(this.characterWidgetTemplate.parentNode.offsetHeight)  /2);
  this.nXOffset += Math.ceil(parseInt(this.characterWidgetTemplate.parentNode.offsetWidth)  /2);
  if ( ! this.nYOffset )
  {
    this.nYOffset = 0;
  }
  if ( ! this.nXOffset )
  {
    this.nXOffset = 0;
  }
}
WordGridManager.prototype.start = function()
{
  var oWrongQuestion = new Question(this.sId + '_WordGrid_OffQuestion', 1000);
  this.workItem.registerQuestion(oWrongQuestion);
  this.oOffWordGridWord = new WordGridWord(this.sId + '_OffWordGridWord_1_1', oWrongQuestion, '', 0, 0, 'n');
  this.oOffWordGridWord.setManager(this);
  this.addKeyPressHandler();
  var nLow = 0;
  var nHigh = this.aRandomArray.length - 1;
  for( var nX = 0; nX < this.aWordGridField.length; nX++)
  {
    for( var nY = 0; nY < this.aWordGridField[nX].length; nY++)
    {
      var sNewDomId = this.sId + '_row_' + nY + '_col_' + nX;
      this.createCopyOfTemplateNode(sNewDomId);
      if ( ! this.aWordGridField[nX][nY].cChar)
      {
        var cChar = null;
        var nFillCharIndex = (this.aWordGridField.length * nY) + nX;
        if ( this.aFillCharacters && this.aFillCharacters[nFillCharIndex])
        {
          cChar = this.aFillCharacters[nFillCharIndex];
        }
        else
        {
          nRandomIndex = Math.round( (nLow - 0.5) +( ( (nHigh+0.49999) - (nLow-0.5) ) * Math.random() ) );
          cChar = this.aRandomArray[nRandomIndex];
        }
        this.aWordGridField[nX][nY].aWordGridWords.push(this.oOffWordGridWord);
        this.aWordGridField[nX][nY].cChar = cChar;
        this.createWordGridCharacterWidget( sNewDomId, nX, nY);
      }
      else
      {
        this.createWordGridCharacterWidget( sNewDomId, nX, nY);
        this.addStatusChangeListener(nX, nY);
      }
      this.moveDomObjToGridPos(sNewDomId, nX, nY);
    }
  }
  Browser.removeNodeFromParent(this.characterWidgetTemplate);
  var me = this;
  eventMousedown = function(event)
  {
    if ( ! event )
    {
      var event = window.event;
    }
    me.mousedownHandler(event);
  }
  eventMouseup = function(event)
  {
    if ( ! event )
    {
      var event = window.event;
    }
    me.mouseupHandler(event);
  }
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEDOWN, eventMousedown);
  Browser.addEventListenerToDocument(Browser.eventNames.MOUSEUP, eventMouseup);
}
WordGridManager.prototype.setFillCharacterArray = function(aFillCharacters)
{
  ;
  this.aFillCharacters = aFillCharacters;
}
WordGridManager.prototype.registerWordGridWord = function(oWordGridWord)
{
  ;
  var nX = oWordGridWord.nX;
  var nY = oWordGridWord.nY;
  this.aWordGridWords.push(oWordGridWord);
  var x = 0;
  var y = 0;
  var length = 0;
  while ( length < oWordGridWord.sAnswer.length)
  {
    if(!this.aWordGridField[nX+x][nY+y])
    {
      ;
    }
    else
    {
      if(this.aWordGridField[nX+x][nY+y].cChar && this.aWordGridField[nX+x][nY+y].cChar != oWordGridWord.sAnswer.charAt(length))
      {
        ;
      }
      this.aWordGridField[nX+x][nY+y].cChar = oWordGridWord.sAnswer.charAt(length);
      this.aWordGridField[nX+x][nY+y].aWordGridWords.push( oWordGridWord);
      if ( this.aWordGridField[nX+x][nY+y].aWordGridWords.length == 1)
      {
        this.createTextGridAnswer(nX+x, nY+y);
      }
      this.createEvaluation(oWordGridWord.getQuestion(), nX+x, nY+y);
      if (oWordGridWord.getOrientationRight())
      {
        x++;
      }
      if (oWordGridWord.getOrientationLeft())
      {
        x--;
      }
      if (oWordGridWord.getOrientationUp())
      {
        y--;
      }
      if (oWordGridWord.getOrientationDown())
      {
        y++;
      }
      if(Math.abs(x))
      {
        length = Math.abs(x);
      }
      else
      {
        length = Math.abs(y);
      }
    }
  }
  oWordGridWord.setManager(this);
}
WordGridManager.prototype.createCopyOfTemplateNode = function(sNewDomId)
{
  ;
  var tmpNode = this.wordGridCharacterWidgetTemplate.cloneNode(true);
  tmpNode.id = sNewDomId;        
  this.wordGridCharacterWidgetTemplate.parentNode.appendChild(tmpNode);
}  
WordGridManager.prototype.createWordGridCharacterWidget = function( sWidgetDomId, nX, nY)
{
  this.aCrossWordsField[nX][nY].oCharacterWidget = new WordGridCharacterWidget(this.sId + '_row_' + nY + '_col_' + nX, sWidgetDomId, nX, nY, this.activeColor, this.inactiveColor, this.correctColor, this.wrongColor, this.tipColor);
  this.aCrossWordsField[nX][nY].oCharacterWidget.setManager(this);             
  this.aCrossWordsField[nX][nY].oCharacterWidget.setCharacter(this.aCrossWordsField[nX][nY].cChar);
}
WordGridManager.prototype.addStatusChangeListener = function(nX, nY)
{
  //;
  this.aCrossWordsField[nX][nY].oTextGridAnswer.registerStatusChangeListener(this.aCrossWordsField[nX][nY].oCharacterWidget);
}
WordGridManager.prototype.clickCharacterWidget = function(oWordGridCharacterWidget)
{
  ;
  var nX = oWordGridCharacterWidget.getXPos();
  var nY = oWordGridCharacterWidget.getYPos();
  if (this.aCrossWordsField[nX][nY].oTextGridAnswer)
  {
    for ( i in this.aCrossWordsField[nX][nY].aCrossWordsWords)
    {
      var oQuestion = this.aCrossWordsField[nX][nY].aCrossWordsWords[i].getQuestion();
      var oAnswer = this.aCrossWordsField[nX][nY].oTextGridAnswer;
      var oEvaluation = this.workItem.getEvaluation(oQuestion, oAnswer);
      if( oEvaluation.isActive() )
      {
        oEvaluation.setActive(false);
      }
      else
      {
        oEvaluation.setActive(true);
      }
    }
  }
  else
  {
    this.createTextGridAnswer(nX, nY);
    this.createEvaluation(this.oOffWordGridWord.getQuestion(), nX, nY, ! this.aCrossWordsField[nX][nY].isCorrect);
    this.addStatusChangeListener(nX, nY);
    var oQuestion = this.aCrossWordsField[nX][nY].aCrossWordsWords[0].getQuestion();
    var oAnswer = this.aCrossWordsField[nX][nY].oTextGridAnswer;
    var oEvaluation = this.workItem.getEvaluation(oQuestion, oAnswer);
    oEvaluation.setActive(true);
  }
}
WordGridManager.prototype.addKeyPressHandler = function()
{
  ;
  var me = this;
  keyPressHandlerCallback = function(event)
  {
    ;
    me.keyPressHandler(event);
  }
  Browser.addEventListenerToDocument(Browser.eventNames.KEYPRESS, keyPressHandlerCallback);
}
WordGridManager.prototype.keyPressHandler = function( event)
{
  ;
  if (event.keyCode == 13)
  {
    this.colorizeDisplay();
    ;
  }
}
WordGridManager.prototype.mousedownHandler = function( event)
{
  ;
  this.bMousedown = true;
}
WordGridManager.prototype.mouseupHandler = function( event)
{
  ;
  this.bMousedown = false;
}
WordGridManager.prototype.getCopyOfImageNode = function( sOrientation)
{
  sPictureUrl = new String();
  var index = this.sShowCorrectURL.search(/\*/);
  sPictureUrl = this.sShowCorrectURL.substring(0, index) + sOrientation + this.sShowCorrectURL.substring(index + 1);
  var oNewNode = document.createElement('img');
  oNewNode.src = sPictureUrl;
  oNewNode.width = this.nShowCorrectWidth;
  oNewNode.height = this.nShowCorrectHeight;
  return oNewNode;
}
WordGridManager.prototype.colorizeDisplay = function()
{
  ;
  for( var nX = 0; nX < this.aWordGridField.length; nX++)
  {
    for( var nY = 0; nY < this.aWordGridField[nX].length; nY++)
    {
      this.aCrossWordsField[nX][nY].oCharacterWidget.colorizeDisplay(this.aCrossWordsField[nX][nY].aWordGridWords[0].getQuestion());
    }
  }
  for ( i in this.aWordGridWords )
  {
    var bCorrect = true;
    var oWordGridWord = this.aWordGridWords[i];
    var oQuestion = oWordGridWord.getQuestion();
    var nActiveCorrect = oQuestion.countActiveCorrectEvaluations();
    if (! (nActiveCorrect == oQuestion.countCorrectEvaluations() && nActiveCorrect == oWordGridWord.sAnswer.length))
    {
      var oWordGridWord = this.aWordGridWords[i];
      var nX = oWordGridWord.nX;
      var nY = oWordGridWord.nY;
      var x = 0;
      var y = 0;
      var length = 0;
      while ( length < oWordGridWord.sAnswer.length)
      {
        var oAnswer = this.aWordGridField[nX+x][nY+y].oTextGridAnswer;
        var oQuestion = this.aWordGridField[nX+x][nY+y].aWordGridWords[0].getQuestion();
        var oEvaluation = this.workItem.getEvaluation(oQuestion,oAnswer);
        if ( ! oEvaluation.isActive())
        {
          bCorrect = false;
          break;
        }
        if (oWordGridWord.getOrientationRight())
        {
          x++;
        }
        if (oWordGridWord.getOrientationLeft())
        {
          x--;
        }
        if (oWordGridWord.getOrientationUp())
        {
          y--;
        }
        if (oWordGridWord.getOrientationDown())
        {
          y++;
        }
        if(Math.abs(x))
        {
          length = Math.abs(x);
        }
        else
        {
          length = Math.abs(y);
        }
      }
    }
    if ( bCorrect )
    {
      //;
      var nX = oWordGridWord.getXPos();
      var nY = oWordGridWord.getYPos();
      var pEndPoint = oWordGridWord.getEndPoint();
      this.aCrossWordsField[nX][nY].oCharacterWidget.approveCorrect(oWordGridWord)
      this.aCrossWordsField[pEndPoint.x][pEndPoint.y].oCharacterWidget.approveCorrect(oWordGridWord)
      oWordGridWord.getQuestionBroker().showCorrect();
    }
    else
    {
      //;
      var nX = oWordGridWord.getXPos();
      var nY = oWordGridWord.getYPos();
      var pEndPoint = oWordGridWord.getEndPoint();
      this.aCrossWordsField[nX][nY].oCharacterWidget.hideApproveCorrect(oWordGridWord)
      this.aCrossWordsField[pEndPoint.x][pEndPoint.y].oCharacterWidget.hideApproveCorrect(oWordGridWord)
      oWordGridWord.getQuestionBroker().showWrong();
    }
  }
}
