/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ScoreStatistics</DEPENDS>
    <DEPENDS>AchievementStatistic</DEPENDS>
</DEPENDENCIES>
*/
function ServerResultAction(scoreStatisticsAction)
{
	this.scoreStatisticsAction = scoreStatisticsAction;
}
ServerResultAction.prototype.invoke = function(resultMap)
{
	if (resultMap && this.scoreStatisticsAction)
		this.scoreStatisticsAction.invoke(
				new ScoreStatistics(
				resultMap['fractionCorrect'],
				resultMap['fractionCorrectWithHelp'],
				resultMap['fractionWrong'],
				resultMap['fractionDone'],
				resultMap['fractionUndone']));
}
function CommitedAction(broker, otherAction)
{
	;
	this.broker = broker;
	this.otherAction = otherAction;
}
CommitedAction.prototype.invoke = function()
{
	;
	if (this.otherAction)
	{
		this.otherAction.invoke();
	}
	if (this.broker)
	{
		this.broker.commited();
	}
}
AchievementManager.prototype = new Broker();
AchievementManager.prototype.constructor = AchievementManager;
AchievementManager.superclass = Broker.prototype;
function AchievementManager()
{
	this.init('AchievementManager');
}
AchievementManager.prototype.init = function(name)
{
	this.conditionHandles = new ConditionHandleMap();
	AchievementManager.superclass.init.call(this, name);
}
AchievementManager.prototype.start = function()
{
	var initialHandles = this.conditionHandles.getInitialHandleCallbacks();
	for (var i in initialHandles)
	{
		var callback = initialHandles[i];
		this.getScoreStatisticsTrace(callback, 'lrn', callback.getContentIdentifier());
	}
}
AchievementManager.prototype.getStartTestAction = function(cid)
{
	return new ObjectMethodAction(this, 'startTest', cid);
}
AchievementManager.prototype.startTest = function(cid)
{
	
}
AchievementManager.prototype.getFinishTestAction = function(cid, callback)
{
	return new ObjectMethodAction(this, 'finishTest', cid, callback);
}
AchievementManager.prototype.finishTest = function(cid, callback)
{
	
}
AchievementManager.prototype.addCommitedHandle = function(action)
{
	this.registerAction("commited", action);
}
AchievementManager.prototype.commited = function()
{
	this.getMessage("commited");
}
AchievementManager.prototype.addTestStartedHandle = function(action)
{
	this.registerAction("teststarted", action);
}
AchievementManager.prototype.addTestFinishedHandle = function(action)
{
	this.registerAction("testfinished", action);
}
AchievementManager.prototype.addContionHandle = function(action, cid, condition, initial, permanent)
{
	this.conditionHandles.addConditionHandle(new ConditionHandle(action, cid, condition, initial, permanent));
}
AchievementManagerDynamicEnvironment.prototype = new AchievementManager();
AchievementManagerDynamicEnvironment.prototype.constructor = AchievementManagerDynamicEnvironment;
AchievementManagerDynamicEnvironment.superclass = AchievementManager.prototype;
function AchievementManagerDynamicEnvironment()
{
	this.init();
}
AchievementManagerDynamicEnvironment.prototype.init = function()
{
	AchievementManagerDynamicEnvironment.superclass.init.call(this, 'AchievementManagerDynamicEnvironment');
}
AchievementManagerDynamicEnvironment.prototype.sendTrackResultData = function(callback, identifier,
																			  nTouched, nTotal, nCorrect, nWrong, nCorrectStatus,
																			  nWrongStatus, nCorrectSystem, nWrongSystem)
{
	;
	var URL = '../addachievement?IDENTIFIER=' + encodeURIComponent(identifier);
	URL += '&TOUCHED=' + nTouched;
	URL += '&TOTAL=' + nTotal;
	URL += '&CORRECT=' + nCorrect;
	URL += '&WRONG=' + nWrong;
	URL += '&CORRECTSTATUS=' + nCorrectStatus;
	URL += '&WRONGSTATUS=' + nWrongStatus;
	URL += '&CORRECTSYSTEM=' + nCorrectSystem;
	URL += '&WRONGSYSTEM=' + nWrongSystem;
	URL += '&EVALMODE=TRACK';
	var commitedAction = new CommitedAction(this, callback);
	Browser.loadDocument(URL, commitedAction, commitedAction);
}
AchievementManagerDynamicEnvironment.prototype.sendTraceResultData = function(callback, identifier,
																			  nTouched, nTotal, nCorrect, nWrong, nCorrectStatus,
																			  nWrongStatus, nCorrectSystem, nWrongSystem)
{
	;
	var URL = '../addachievement?IDENTIFIER=' + encodeURIComponent(identifier);
	URL += '&TOUCHED=' + nTouched;
	URL += '&TOTAL=' + nTotal;
	URL += '&CORRECT=' + nCorrect;
	URL += '&WRONG=' + nWrong;
	URL += '&CORRECTSTATUS=' + nCorrectStatus;
	URL += '&WRONGSTATUS=' + nWrongStatus;
	URL += '&CORRECTSYSTEM=' + nCorrectSystem;
	URL += '&WRONGSYSTEM=' + nWrongSystem;
	URL += '&EVALMODE=TRACE';
	var commitedAction = new CommitedAction(this, callback);
	Browser.loadDocument(URL, commitedAction, commitedAction);
}
AchievementManagerDynamicEnvironment.prototype.getScoreStatisticsTrace
		= function(callback, structureName, contentidentifier)
{
	;
	var URL = '../getachievement?IDENTIFIER=' + encodeURIComponent(contentidentifier);
	URL += '&STRUCTURE=lrn';
	URL += '&EVALMODE=TRACE';
	var serverResultAction = new ServerResultAction(callback);
	Browser.callServer(URL, serverResultAction, serverResultAction);
}
AchievementManagerDynamicEnvironment.prototype.getScoreStatisticsTrack
		= function(callback, structureName, contentidentifier)
{
	;
	var URL = '../getachievement?IDENTIFIER=' + encodeURIComponent(contentidentifier);
	URL += '&STRUCTURE=lrn';
	URL += '&EVALMODE=TRACK';
	var serverResultAction = new ServerResultAction(callback);
	Browser.callServer(URL, serverResultAction, serverResultAction);
}
AchievementManagerDynamicEnvironment.prototype.startTest = function(cid)
{
	this.getMessage("teststarted");
}
AchievementManagerDynamicEnvironment.prototype.finishTest = function(callback)
{
	this.getMessage("testfinished");
}
AchievementManagerStaticEnvironment.prototype = new AchievementManager();
AchievementManagerStaticEnvironment.prototype.constructor = AchievementManagerStaticEnvironment;
AchievementManagerStaticEnvironment.superclass = AchievementManager.prototype;
function AchievementManagerStaticEnvironment()
{
	this.init();
}
AchievementManagerStaticEnvironment.prototype.init = function()
{
	this.achievementservice = null;
	AchievementManagerStaticEnvironment.superclass.init.call(this, 'AchievementManagerStaticEnvironment');
}
AchievementManagerStaticEnvironment.prototype.start = function()
{
	if (this.asname)
	{
		var serviceregistry = ServiceRegistryAccess.getServiceRegistry();
		if (serviceregistry)
			this.achievementservice = serviceregistry.getService("achievementservice");
	}
	AchievementManagerStaticEnvironment.superclass.start.call(this);
}
AchievementManagerStaticEnvironment.prototype.setAchievementServiceName = function(asname)
{
	this.asname = asname;
}
AchievementManagerStaticEnvironment.prototype.sendTrackResultData = function(callback, identifier,
																			 nTouched, nTotal, nCorrect, nWrong, nCorrectStatus,
																			 nWrongStatus, nCorrectSystem, nWrongSystem)
{
	if (this.achievementservice)
		this.achievementservice.setTrackData(identifier, nTouched, nTotal, nCorrect,
				nWrong, nCorrectStatus, nWrongStatus, nCorrectSystem, nWrongSystem);
	var commitedAction = new CommitedAction(this, callback);
	commitedAction.invoke();
}
AchievementManagerStaticEnvironment.prototype.sendTraceResultData = function(callback, identifier,
																			 nTouched, nTotal, nCorrect, nWrong, nCorrectStatus,
																			 nWrongStatus, nCorrectSystem, nWrongSystem)
{
	if (this.achievementservice)
		this.achievementservice.setTraceData(identifier, nTouched, nTotal, nCorrect,
				nWrong, nCorrectStatus, nWrongStatus, nCorrectSystem, nWrongSystem);
	var commitedAction = new CommitedAction(this, callback);
	commitedAction.invoke();
}
AchievementManagerStaticEnvironment.prototype.getScoreStatisticsTrace
		= function(callback, structureName, contentidentifier)
{
	var scorestatistics = null;
	if (this.achievementservice)
	{
		scorestatistics = this.achievementservice.getScoreStatisticsTrace(structureName, contentidentifier);
	}
	if (callback)
		callback.invoke(scorestatistics);
}
AchievementManagerStaticEnvironment.prototype.getScoreStatisticsTrack
		= function(callback, structureName, contentidentifier)
{
	;
	var scorestatistics = null;
	if (this.achievementservice)
	{
		scorestatistics = this.achievementservice.getScoreStatisticsTrack(structureName, contentidentifier);
	}
	if (callback)
		callback.invoke(scorestatistics);
}
AchievementManagerStaticEnvironment.prototype.startTest = function(cid)
{
	if (this.achievementservice)
		this.achievementservice.startTest(cid);
	this.getMessage('teststarted');
}
AchievementManagerStaticEnvironment.prototype.finishTest = function(callback)
{
	if (this.achievementservice)
		this.achievementservice.finishTest();
	this.getMessage('testfinished');
	if (callback)
		callback.invoke();
}
function ConditionHandleMap()
{
	this.initialCallbacks = new Array();
	this.permanentCallbacks = new Array();
}
ConditionHandleMap.prototype.addConditionHandle = function(handle)
{
	if (handle.isInitial())
	{
		var initialCallback = this.initialCallbacks[handle.getContentIdentifier()];
		;
		if (initialCallback == null || initialCallback == undefined)
		{
			initialCallback = new ConditionHandleMapCallback(handle.getContentIdentifier());
			this.initialCallbacks[handle.getContentIdentifier()] = initialCallback;
		}
		initialCallback.addHandle(handle);
	}
	else if (handle.isPermanent())
	{
		var permanentCallback = this.permanentCallbacks[handle.getContentIdentifier()];
		if (permanentCallback == null || permanentCallback == undefined)
		{
			permanentCallback = new ConditionHandleMapCallback(handle.getContentIdentifier());
			this.permanentCallbacks[handle.getContentIdentifier()] = permanentCallback;
		}
		permanentCallback.addHandle(handle);
	}
}
ConditionHandleMap.prototype.getInitialHandleCallbacks = function()
{
	return this.initialCallbacks;
}
ConditionHandleMap.prototype.getPermanentHandleCallbacks = function()
{
	return this.permanentCallbacks;
}
function ConditionHandleMapCallback(cid)
{
	;
	this.cid = cid;
	this.handles = new Array();
}
ConditionHandleMapCallback.prototype.addHandle = function(handle)
{
	;
	this.handles.push(handle);
}
ConditionHandleMapCallback.prototype.getContentIdentifier = function()
{
	return this.cid;
}
ConditionHandleMapCallback.prototype.invoke = function(scorestatistics)
{
	;
	for (var i = 0; i < this.handles.length; i++)
	{
		var statistic = new AchievementStatistic(null, null, null, scorestatistics);
		var handle = this.handles[i];
		;
		if (eval(statistic.parseFormula(handle.getCondition())))
		{
			;
			handle.getAction().invoke();
		}
	}
}
function ConditionHandle(action, cid, condition, initial, permanent)
{
	this.action = action;
	this.cid = cid;
	this.condition = condition;
	this.initial = initial;
	this.permanent = permanent;
}
ConditionHandle.prototype.getAction = function()
{
	return this.action;
}
ConditionHandle.prototype.getContentIdentifier = function()
{
	return this.cid;
}
ConditionHandle.prototype.getCondition = function()
{
	return this.condition;
}
ConditionHandle.prototype.isInitial = function()
{
	return this.initial;
}
ConditionHandle.prototype.isPermanent = function()
{
	return this.permanent;
}
