/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function FilterController(sId, autoCommit, required)
{
	if (sId)
	{
		this.init(sId, autoCommit, required);
	}
}
FilterController.prototype.init = function(sId, autoCommit, required)
{
	;
	this.sId = sId;
	this.filters = new Array();
	this.sorter = new Array();
	this.actualMethodCallId = null;
	this.methodCallCounter = 0;
	this.reseting = false;
	this.autoCommit = autoCommit;
	this.required = required;
	this.showWarnHandles = new Array();
	this.hideWarnHandles = new Array();
}
FilterController.prototype.getId = function()
{
	return this.sId;
}
FilterController.prototype.start = function()
{
	;
}
FilterController.prototype.setManager = function(manager)
{
	;
	this.manager = manager;
}
FilterController.prototype.registerFilter = function(filter)
{
	;
	this.filters[filter.getId()] = filter;
	filter.setManager(this);
}
FilterController.prototype.registerShowWarnHandle = function(action)
{
	this.showWarnHandles.push(action);
}
FilterController.prototype.registerHideWarnHandle = function(action)
{
	this.hideWarnHandles.push(action);
}
FilterController.prototype.fireHideWarn = function()
{
	for (var i = 0; i < this.hideWarnHandles.length; i++)
		this.hideWarnHandles[i].invoke();
}
FilterController.prototype.fireShowWarn = function()
{
	for (var i = 0; i < this.showWarnHandles.length; i++)
		this.showWarnHandles[i].invoke();
}
FilterController.prototype.isAutoCommit = function()
{
	return this.autoCommit;
}
FilterController.prototype.process = function()
{
	if (this.reseting == false)
	{
		var command = this.getFilterCommand();
		this.manager.processFilterCommand(command);
	}
}
FilterController.prototype.getFilterCommand = function()
{
	var command = '';
	var valuesBySubmitParameter = new Array();
	var first = true;
	for (var id in this.filters)
	{
		var filter = this.filters[id];
		if (filter instanceof FilterController)
		{
			var fc = filter.getFilterCommand(first);
			if (fc != '' )
			{
				var submitParam = '';
				if (first == true)
					first = false;
				else
					submitParam += "&";
				submitParam += fc;
				command += submitParam;
			}
		}
		else
		{
			var filtervalues = filter.getCommandValues();
			
			if (filter.isActive() && filtervalues.length > 0)
			{
				var submitParam = '';
				if (first == true)
					first = false;
				else
					submitParam += "&";
				submitParam += filter.getSubmitParam() + "=";
				for (var i = 0; i < filtervalues.length; i++)
					command += submitParam + encodeURIComponent(filtervalues[i].getValueId());
			}
		}
	}
	return command;
}
FilterController.prototype.validate = function()
{
	var valid = true;
	for (var id in this.filters)
	{
		var filter = this.filters[id];
		var fvalid = filter.validate();
		if (valid)
			valid = fvalid;
	}
	if (this.required == true && valid == true)
	{
		valid = false;
		for (var id in this.filters)
		{
			var filter = this.filters[id];
			var hasvalues = filter.hasSelectedValue();
			if (hasvalues == true)
			{
				valid = true;
				break;
			}
		}
	}
	if (valid == true)
		this.fireHideWarn();
	else
		this.fireShowWarn();
	return valid;
}
FilterController.prototype.getFilter = function()
{
	return this.filters;
}
FilterController.prototype.getResetFilterAction = function()
{
	return new ObjectMethodAction(this, "reset");
}
FilterController.prototype.reset = function()
{
	;
	this.reseting = true;
	for (var id in this.filters)
	{
		var filter = this.filters[id];
		filter.reset();
	}
	for (var id in this.sorter)
	{
		var sor = this.sorter[id];
		sor.reset();
	}
	this.reseting = false;
	this.process();
}
