/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Point</DEPENDS>
    <DEPENDS>Evaluation</DEPENDS>
</DEPENDENCIES>
*/
Gap.prototype             = new DomletCtr();
Gap.prototype.constructor = Gap;
Gap.superclass            = DomletCtr.prototype;
function Gap(sId, sWidgetInputDomId, sWidgetDisplayDomId,sWidgetDecollatorId, sFgColorTip, sFgColorWrong, sFgColorCorrect)
{
  if (sId) { this.init(sId, sWidgetInputDomId, sWidgetDisplayDomId, sWidgetDecollatorId, sFgColorTip, sFgColorWrong, sFgColorCorrect); }
}
Gap.prototype.init = function(sId, sWidgetInputDomId, sWidgetDisplayDomId, sWidgetDecollatorId,sFgColorTip, sFgColorWrong, sFgColorCorrect)
{
  ;
  this.bAlreadyStarted = false;
  this.sId = sId;
  this.modelItem = null;
  this.broker = null;
  this.aAnswers = new Array();
  this.bActive = true;
  this.bHasFocus = false;
  this.aSysContribs = new Array();
  this.sFgColorTip = null;
  this.sFgColorWrong = null;
  this.sFgColorCorrect = null;
  this.assignTimerTime = 400;
  this.assignTimer = null;
  if(sFgColorTip)
  {
    this.sFgColorTip = sFgColorTip;
  }
  if(sFgColorWrong)
  {
      this.sFgColorWrong = sFgColorWrong;
  }
  if(sFgColorCorrect)
  {
      this.sFgColorCorrect = sFgColorCorrect;
  }
  Gap.superclass.init.call(this, sWidgetInputDomId, sId, this);
  this.widgetInput = document.getElementById(sWidgetInputDomId);
  this.sWidgetInputDomId = sWidgetInputDomId;
  if (this.widgetInput == null)
  {
    ;
  }
  this.widgetDisplay = document.getElementById(sWidgetDisplayDomId);
  this.sWidgetDisplayDomId = sWidgetDisplayDomId;
  if (this.widgetDisplay == null)
  {
    ;
  }
  this.widgetDecollator = document.getElementById(sWidgetDecollatorId);
  this.sWidgetDecollatorId = sWidgetDecollatorId;
  if (this.widgetDecollator == null)
  {
     ;
  }
  this.addDomlet(new Domlet(
    this.sWidgetInputDomId,      
    this.sWidgetInputDomId,      
    this,                   
    new Array('blur', 'focus', 'keydown', 'change')) 
  )
  this.addDomlet(new Domlet(
    this.sWidgetDisplayDomId,     
    this.sWidgetDisplayDomId,     
    this,                    
    new Array('click')) 
  )
  this.resetInput();
  var me = this;
  function assignTimerCallback()
  {
    me.assignTimer = null;
    me.assignText();
  }
  this.assignTimerCallback = assignTimerCallback;
  Browser.addUnloadHandle(new ObjectMethodAction(this, "unloadHandler"));
}
Gap.prototype.getId = function()
{
  return this.sId;
}
Gap.prototype.start = function()
{
  this.domlets[this.sWidgetInputDomId].setVisible(true);
  this.domlets[this.sWidgetDisplayDomId].setVisible(false);
  var point = this.moveDisplayWidgetToPoint();
  var displayDomId = this.sWidgetDisplayDomId;
  var inputDomId = this.sWidgetInputDomId;
  var borderright = parseInt(Browser.getComputedStyleById(displayDomId,'borderLeftWidth'));
  var borderleft  = parseInt(Browser.getComputedStyleById(displayDomId,'borderRightWidth'));
  var bordertop  = parseInt(Browser.getComputedStyleById(displayDomId,'borderTopWidth'));
  var borderbottom  = parseInt(Browser.getComputedStyleById(displayDomId,'borderBottomWidth'));
  var paddingLeft = parseInt(Browser.getComputedStyleById(displayDomId,'paddingLeft'));
  if(!borderleft) borderleft = 0;
  if(!borderright) borderright = 0;
  if(!bordertop) bordertop = 0;
  if(!borderbottom) borderbottom = 0;
  if(!paddingLeft) paddingLeft = 0;
  var displayHeight = this.widgetInput.offsetHeight - bordertop - borderbottom;
  var displayWidth =  this.widgetInput.offsetWidth - borderleft - borderright - paddingLeft;
  Browser.changePixelStyle(this.widgetDecollator, 'height',  displayHeight);
  Browser.changePixelStyle(this.widgetDisplay, 'height',  displayHeight);
  Browser.moveTo(this.widgetDecollator, new Point(point.x+  this.widgetInput.offsetWidth-borderleft,point.y));
  Browser.changePixelStyle(this.widgetDisplay, 'width', displayWidth);
  if(!this.bAlreadyStarted)
  {
   var answer = null;
    for (var id in this.aAnswers)
    {
      if (this.aAnswers[id].getText() == this.widgetInput.value)
      {
        answer = this.aAnswers[id];
        break;
      }
    }
    if(answer == null)
    {
      answer = this.modelItem.workItem.getOrCreateAnswerByText(this.widgetInput.value);
    }
    var evaluation = this.modelItem.workItem.getOrCreateEvaluation(this.modelItem, answer);
    evaluation.bIsInitialActive = true;
    evaluation.setSilentlyActive(true, 'system_off');
    this.bAlreadyStarted = true;
  }
}
Gap.prototype.moveDisplayWidgetToPoint = function()
{
    var point = new Point(0,0);
    var borderleft  = parseInt(Browser.getComputedStyleById(this.sWidgetDisplayDomId,'borderRightWidth'));
    if(!borderleft) borderleft = 0;
    Browser.getAbsPos(this.widgetInput, point);
    Browser.moveTo(this.widgetDisplay, point);
    Browser.moveTo(this.widgetDecollator, new Point(point.x+  this.widgetInput.offsetWidth-borderleft,point.y));
    return point;
}
Gap.prototype.setModelItem = function(modelItem)
{
  ;
  this.modelItem = modelItem;
}
Gap.prototype.setEnabled = function(bActive)
{
  ;
  if( ! bActive )
  {
    this.widgetInput.disabled = true;
    this.widgetInput.blur();
  }
  else
  {
    this.widgetInput.disabled = false;
  }
  this.bActive = bActive;
}
Gap.prototype.addAnswer = function(answer)
{
  ;
  this.aAnswers[answer.getId()] = answer;
}
Gap.prototype.getModelItem = function()
{
  return this.modelItem;
}
Gap.prototype.setBroker = function(broker)
{
  ;
  this.broker = broker;
}
Gap.prototype.assignTimeCall = function()
{
 ;
  this.assignTimer = null;
  this.assignText();
}
Gap.prototype.changed = function(model)
{
  //;
  if (model.getEvaluation())
  {
    switch(model.getEvaluation().getOrigin())
    {
        case 'system_approve':
        case 'system_brand':
        case 'system_solution':
          this.widgetInput.blur();
          this.bHasFocus = false;
          break;
    }
  }
  if (model.isEvaluated())
  {
    if (model.isSolved() == true)
    {
      var sText = this.widgetInput.value;
      this.colorizeDisplayText(sText, sText, this.sFgColorCorrect, false)
      if (this.broker) { this.broker.showCorrect(); }
    }
    else if (model.isSolved() == false)
    {
      if (model.getEvaluation())
      {
        var sInputText = this.widgetInput.value;
        var sCorrectText = '';
        if(model.getSolutionComplement())
        {
          sCorrectText = model.getSolutionComplement().getText();
        }
        this.colorizeDisplayText(sInputText, sCorrectText, this.sFgColorWrong, this.sFgColorCorrect)
      }
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
    this.showDisplay();
  }
  else
  {
    var nCount = model.countActiveEvaluations();
    if (nCount == 0)
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'system_solution':
          this.resetInput();
          break;
        case 'user':
          this.resetInput();
          break;
        default:
          this.resetInput();
          ;
          break;
      }
    }
    else if (nCount == 1)
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':
          if (model.getEvaluation().isActive())
          {
            var sText = this.getUserInput(model);
            this.widgetInput.value = sText;
            ;
            this.setSysContributionByString(sText, 'user');
            this.tippColorizeDisplay();
            if (this.broker) { this.broker.showAssigned(); }
          }
          break;
        case 'system_solution':
          if (model.getEvaluation().isActive())
          {
            var sInputText = this.widgetInput.value;
            var sText = model.getEvaluation().getAnswer().getText();
            this.widgetInput.value = '';
            this.colorizeDisplayText(sText, sInputText, this.sFgColorTip, false)
            if (this.broker) { this.broker.showSolution(); }
          }
          break;
        case 'system_set':
          var sInputText = this.widgetInput.value;
          var sText = model.getEvaluation().getAnswer().getText();
          this.widgetInput.value = sText;
          this.colorizeDisplayText(sText, sInputText, this.sFgColorTip, false)
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_setpartial':
          var sText = model.getEvaluation().getAnswer().getText();
          this.widgetInput.value = sText;
          this.setSysContributionByString(sText, 'system_setpartial');
          this.tippColorizeDisplay();
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_approve':
          var sText = model.getEvaluation().getAnswer().getText();
          this.colorizeDisplayText(sText, sText, this.sFgColorTip, false)
          if (this.broker) { this.broker.showTipApproveCorrect(); }
          break;
        case 'system_brand':
          var sInputText = this.widgetInput.value;
          this.colorizeDisplayText(sInputText, sInputText, this.sFgColorWrong, false)
          if (this.broker) { this.broker.showTipBrandWrong(); }
          break;
      }
      if(!this.bHasFocus)
      {
          this.showDisplay();
      }
    }
    else
    {
      ;
    }
  }
}
Gap.prototype.getUserInput = function(model)
{
  var sText = this.widgetInput.value;
  if(model && model.getEvaluation())
  {
    var answer = model.getEvaluation().getAnswer();
    if(answer)
    {
      if(sText != '')
      {
        ;
        if(answer.getText() == '')
        {
          ;
        }
        answer[this.sId + '_userinput'] = sText;
      }
      else
      {
        sText = answer[this.sId + '_userinput'];
        if(!sText)
        {
          sText = '';
        }
      }
    }
  }
  return sText;
}
Gap.prototype.showDisplay = function()
{
    this.moveDisplayWidgetToPoint();
    this.domlets[this.sWidgetDisplayDomId].setVisible(true);
}
Gap.prototype.resetInput = function()
{
      this.widgetInput.value = '';
      this.colorizeDisplayText('', null, null, false);
      if (this.broker) { this.broker.showUnassigned(); }
}
Gap.prototype.eventFromChild = function(childName, eventType, event)
{
  ;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "blur" :
      ;
      this.blurHandler(domlet, event);
      break;
    case "keydown" :
      ;
      this.keydownHandler(domlet, event);
      break;
    case "click" :
      ;
      this.clickHandler(domlet, event);
      break;
    case "focus" :
      ;
      this.clickHandler(domlet, event);
      break;
  }
}
Gap.prototype.keydownHandler = function(domlet, event)
{
  ;
  this.widgetDisplay.style.visibility = 'hidden';
  this.assignTimer = window.setTimeout(this.assignTimerCallback, this.assignTimerTime);
}
Gap.prototype.blurHandler = function(domlet, event)
{
  ;
  if(this.bHasFocus)
  {
    this.assignText();
    this.showDisplay();
    this.bHasFocus = false;
  }
}
Gap.prototype.clickHandler = function(domlet, event)
{
  ;
  this.bHasFocus = true;
  if ( this.bActive )
  {
  	
  	this.domlets[this.sWidgetDisplayDomId].setVisible(false);
  	this.widgetInput.focus(); 
  	if ( this.modelItem )
  	{
  	  this.modelItem.workItem.setUserFocus(this.modelItem);
  	}
  }
}
Gap.prototype.assignText = function()
{
  ;
  var answer = null;
  var sText = this.stripString(this.widgetInput.value);
  for (var id in this.aAnswers)
  {
    if (this.aAnswers[id].getText() == sText)
    {
      answer = this.aAnswers[id];
      break;
    }
  }
  if(this.modelItem)
  {
  if (answer)
  {
    this.modelItem.assign(this.modelItem, answer);
  }
  else
  {
    this.modelItem.assignByText(this.modelItem, sText);
  }
  }
}
Gap.prototype.quote = function(item)
{
  if(item)
  {
    var quoted = '';
    for(var i=0; i<item.length; i++)
    {
      switch(item.charAt(i))
      {
        case '&': quoted += '&amp;'; break;
        case '<': quoted += '&lt;'; break;
        case '>': quoted += '&gt;'; break;
        default:  quoted += item.charAt(i);
      }
    }
    return quoted;
  }
  else
  {
    return item;
  }
}
Gap.prototype.setSysContributionByString = function(sText, sOrigin)
{
  ;
  function ContribItem(cChar, bContrib)
  {
    this.cChar = cChar;
    this.bContrib = bContrib;
  }
  var bHasContrib = false;
  var i = 0;
  if ( sOrigin == 'system_setpartial')
  {
    bHasContrib = true;
  }
  for(i = 0; i <= sText.length && this.aSysContribs[i]; i++)
  {
    if (sText.charAt(i) != this.aSysContribs[i].cChar)
    {
      this.aSysContribs[i].cChar = sText.charAt(i);
      this.aSysContribs[i].bContrib = bHasContrib;
    }
  }
  if ( this.aSysContribs.length > i )
  {
    this.aSysContribs.splice(i, this.aSysContribs.length - i);
  }
  else
  {
    for( var j = 0; i + j <= sText.length; j++)
    {
      this.aSysContribs[i+j] = new ContribItem(sText.charAt(i+j), bHasContrib);
    }
  }
}
Gap.prototype.tippColorizeDisplay = function()
{
  ;
  var sText = new String();
  try {
  for ( var i = 0; i < this.aSysContribs.length; i++)
  {
    if(this.aSysContribs[i].bContrib)
    {
      sText += this.quote(this.aSysContribs[i].cChar).fontcolor(this.sFgColorTip);
    }
    else
    {
      sText += this.quote(this.aSysContribs[i].cChar);
    }
  }
  }
  catch(e)
  {
    ;
  };
  this.domlets[this.sWidgetDisplayDomId].setText(sText);
}
Gap.prototype.colorizeDisplayText = function(sInputString, sCorrectString, sColor, sDiffColor)
{
  ;
  var sText = '';
  var i = 0;
  if (sDiffColor)
  {
    while(i <= sInputString.length && i <= sCorrectString.length)
    {
      var quotedChar = this.quote(sInputString.charAt(i));
      if (sInputString.charAt(i) == sCorrectString.charAt(i))
      {
        if ( sDiffColor == -1 )
        {
          sText += quotedChar;
        }
        else
        {
          sText += quotedChar.fontcolor(sDiffColor);
        }
      }
      else
      {
        sText += quotedChar.fontcolor(sColor);
      }
      i++;
    }
    sText += this.quote(sInputString.substring(i)).fontcolor(sColor);
  }
  else
  {
     sText = this.quote(sInputString).fontcolor(sColor);
  }
  if(!sText)
    sText = "&nbsp;"
  this.domlets[this.sWidgetDisplayDomId].setText(sText);
}
Gap.prototype.stripString = function(sInputString)
{
  ;
  var sStripedString = '';
  if(sInputString)
  {
    for (var i=sInputString.length; i > 0; i--)
    {
      var c = sInputString.charAt(i-1);
      if (c != ' ')
      {
        sStripedString = sInputString.substring(0,i);
        break;
      }
    }
    for (var i=0; i < sStripedString.length; i++)
    {
      var c = sStripedString.charAt(i);
      if (c != ' ')
      {
        sStripedString = sStripedString.substring(i);
        break;
      }
    }
  }
  return sStripedString;
}
Gap.prototype.setAssignTimerTime = function(assignTimerTime)
{
  this.assignTimerTime = assignTimerTime;
}
Gap.prototype.setFgColorTip = function(sFgColorTip)
{
  this.sFgColorTip = sFgColorTip;
}
Gap.prototype.setFgColorWrong = function(sFgColorWrong)
{
  this.sFgColorWrong = sFgColorWrong;
}
Gap.prototype.setFgColorCorrect = function(sFgColorCorrect)
{
  this.sFgColorCorrect = sFgColorCorrect;
}
Gap.prototype.getSetEnableAction = function()
{
    return new ObjectMethodAction(this, "setEnabled", true);
}
Gap.prototype.getSetDisableAction = function()
{
    return new ObjectMethodAction(this, "setEnabled", false);
}
Gap.prototype.unloadHandler = function()
{
    this.resetInput();
}
