/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
function PagingManager(sId)
{
  if (sId) { this.init(sId); }
}
PagingManager.prototype.init = function(sId)
{
  ;
    this.sId = sId;
  this.aPage = new Array();
  this.aTurnedToActions = new Array();
  this.aTurnedAwayActions = new Array();
  this.aActions = new Array();
  this.nPage = 0;
  this.nCurrent = 0;
  this.startPage = null;
  this.pagingBroker = null;
}
PagingManager.prototype.getId = function()
{
    return this.sId;
}
PagingManager.prototype.registerPage = function(page)
{
  ;
  if (this.aPage[page.getId()] != null)
  {
    ;
  }
  else
  {
    page.setPagingManager(this);
    page.setPageIndex(this.nPage);
    this.aPage[this.nPage++] = page;
    ;
  }
  return null;
}
PagingManager.prototype.registerTurnedToPageAction = function(pageNumber, action)
{
  ;
  var aActions = this.aTurnedToActions[pageNumber];
  if(aActions)
  {
    aActions.push(action);
  }
  else
  {
    aActions = new Array();
    aActions.push(action);
    this.aTurnedToActions[pageNumber] = aActions;
  }
}
PagingManager.prototype.registerTurnedAwayPageAction = function(pageNumber, action)
{
  ;
  var aActions = this.aTurnedAwayActions[pageNumber];
  if(aActions)
  {
    aActions.push(action);
  }
  else
  {
    aActions = new Array();
    aActions.push(action);
    this.aTurnedAwayActions[pageNumber] = aActions;
  }
}
PagingManager.prototype.callTurnedToActions = function(pageNumber)
{
  ;
  if (this.pagingBroker) { this.pagingBroker.turnedTo(this.nCurrent); }
  var aActions = this.aTurnedToActions[pageNumber];
  if(aActions)
  {
    for(i in aActions)
    {
      if(aActions[i].invoke)
      {
        aActions[i].invoke();
      }
      else
      {
        ;
      }
    }
  }
}
PagingManager.prototype.callTurnedAwayActions = function(pageNumber)
{
  ;
  if (this.pagingBroker) { this.pagingBroker.turnedAway(this.nCurrent); }
  var aActions = this.aTurnedAwayActions[pageNumber];
  if(aActions)
  {
    for(i in aActions)
    {
      if(aActions[i].invoke)
      {
        aActions[i].invoke();
      }
      else
      {
        ;
      }
    }
  }
}
PagingManager.prototype.setPagingBroker = function(broker)
{
  ;
  this.pagingBroker = broker;
}
PagingManager.prototype.start = function()
{
  ;
  if (this.startPage != null)
    this.jumpTo(this.startPage);
}
PagingManager.prototype.next = function()
{
  ;
  this.jumpTo(this.nCurrent + 1);
}
PagingManager.prototype.previous = function()
{
  ;
  this.jumpTo(this.nCurrent - 1);
}
PagingManager.prototype.jumpToMe = function(page)
{
  ;
  if(this.pagingBroker)
  {
    this.pagingBroker.jumpTo(page.nPageIndex);
  }
}
PagingManager.prototype.jumpTo = function(nIndex)
{
  ;
  if (nIndex >= 0 && nIndex < this.nPage)
  {
    this.callTurnedAwayActions(this.nCurrent);
    this.nCurrent = nIndex;
    for (var i = 0; i < this.nPage; i++)
    {
      this.aPage[i].show( (i == nIndex) );
    }
    this.callTurnedToActions(this.nCurrent);
    if (this.nCurrent < this.nPage - 1)
    {
      if (this.pagingBroker) { this.pagingBroker.notLast(); }
    }
    else
    {
      if (this.pagingBroker) { this.pagingBroker.reachedLast(); }
    }
    if (this.nCurrent > 0)
    {
      if (this.pagingBroker) { this.pagingBroker.notFirst(); }
    }
    else
    {
      if (this.pagingBroker) { this.pagingBroker.reachedFirst(); }
    }
  }
  else
  {
    ;
  }
}
PagingManager.prototype.getNextAction = function()
{
  return new ObjectMethodAction(this, 'next');
}
PagingManager.prototype.getPreviousAction = function()
{
  return new ObjectMethodAction(this, 'previous');
}
PagingManager.prototype.getJumpToAction = function()
{
  return new ObjectMethodAction(this, 'jumpTo');
}
PagingManager.prototype.setStartPage = function(startPage)
{
  this.startPage = startPage;
}
