/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function AnswerValue(sId)
{
  if (sId) { this.init(sId); }
}
AnswerValue.prototype.init = function(sId)
{
  ;
  this.sId = sId;
}
AnswerValue.prototype.match = function(value)
{
  return false;
}
AnswerValue.prototype.getText = function()
{
  return 'X';
}
AnswerValue.prototype.getGapSampleText = function()
{
  return this.getText();
}
EmptyTextAnswerValue.prototype             = new AnswerValue();
EmptyTextAnswerValue.prototype.constructor = EmptyTextAnswerValue;
EmptyTextAnswerValue.superclass            = AnswerValue.prototype;
function EmptyTextAnswerValue(sId)
{
  if (sId) { this.init(sId); }
}
EmptyTextAnswerValue.prototype.init = function(sId)
{
  ;
  EmptyTextAnswerValue.superclass.init.call(this, sId);
}
EmptyTextAnswerValue.prototype.match = function(value)
{
  return ('' == value);
}
EmptyTextAnswerValue.prototype.getText = function()
{
  return '';
}
CasesensitiveTextAnswerValue.prototype             = new AnswerValue();
CasesensitiveTextAnswerValue.prototype.constructor = CasesensitiveTextAnswerValue;
CasesensitiveTextAnswerValue.superclass            = AnswerValue.prototype;
function CasesensitiveTextAnswerValue(sId, text)
{
  if (sId) { this.init(sId, text); }
}
CasesensitiveTextAnswerValue.prototype.init = function(sId, text)
{
  ;
  CasesensitiveTextAnswerValue.superclass.init.call(this, sId);
  this.text = text;
}
CasesensitiveTextAnswerValue.prototype.match = function(value)
{
  return (this.text == value);
}
CasesensitiveTextAnswerValue.prototype.getText = function()
{
  return this.text;
}
UpperBoundNumberAnswerValue.prototype             = new AnswerValue();
UpperBoundNumberAnswerValue.prototype.constructor = UpperBoundNumberAnswerValue;
UpperBoundNumberAnswerValue.superclass            = AnswerValue.prototype;
function UpperBoundNumberAnswerValue(sId, valueFloat)
{
  if (sId) { this.init(sId, valueFloat); }
}
UpperBoundNumberAnswerValue.prototype.init = function(sId, valueFloat)
{
  ;
  UpperBoundNumberAnswerValue.superclass.init.call(this, sId);
  this.valueFloat = parseFloat(valueFloat);
}
UpperBoundNumberAnswerValue.prototype.match = function(value)
{
  value = value.replace (",", ".");
  if(isNaN(value))
    return false;
  var inputValueFloat = parseFloat(value);
  return (value <= this.valueFloat);
}
UpperBoundNumberAnswerValue.prototype.getText = function()
{
  return this.valueFloat + '';
}
LowerBoundNumberAnswerValue.prototype             = new AnswerValue();
LowerBoundNumberAnswerValue.prototype.constructor = LowerBoundNumberAnswerValue;
LowerBoundNumberAnswerValue.superclass            = AnswerValue.prototype;
function LowerBoundNumberAnswerValue(sId, valueFloat)
{
  if (sId) { this.init(sId, valueFloat); }
}
LowerBoundNumberAnswerValue.prototype.init = function(sId, valueFloat)
{
  ;
  LowerBoundNumberAnswerValue.superclass.init.call(this, sId);
  this.valueFloat = parseFloat(valueFloat);
}
LowerBoundNumberAnswerValue.prototype.match = function(value)
{
  value = value.replace (",", ".");
  if(isNaN(value))
    return false;
  var inputValueFloat = parseFloat(value);
  return (value >= this.valueFloat);
}
LowerBoundNumberAnswerValue.prototype.getText = function()
{
  return this.valueFloat + '';
}
RangeNumberAnswerValue.prototype             = new AnswerValue();
RangeNumberAnswerValue.prototype.constructor = RangeNumberAnswerValue;
RangeNumberAnswerValue.superclass            = AnswerValue.prototype;
function RangeNumberAnswerValue(sId, lowerBoundFloat, upperBoundFloat)
{
  if (sId) { this.init(sId, lowerBoundFloat, upperBoundFloat); }
}
RangeNumberAnswerValue.prototype.init = function(sId, lowerBoundFloat, upperBoundFloat)
{
  ;
  RangeNumberAnswerValue.superclass.init.call(this, sId);
  this.lowerBoundFloat = parseFloat(lowerBoundFloat);
  this.upperBoundFloat = parseFloat(upperBoundFloat);
}
RangeNumberAnswerValue.prototype.match = function(value)
{
  value = value.replace (",", ".");
  if(isNaN(value))
    return false;
  var inputValueFloat = parseFloat(value);
  return ((this.lowerBoundFloat <= value) && (value <= this.upperBoundFloat));
}
RangeNumberAnswerValue.prototype.getText = function()
{
  return this.lowerBoundFloat.toString();
}
RangeNumberAnswerValue.prototype.getGapSampleText = function()
{
  ;
  var intPlaces = Math.max(
    getIntegerPlaces(this.lowerBoundFloat), getIntegerPlaces(this.upperBoundFloat) );
  var decPlaces = Math.max(
    getDecimalPlaces(this.lowerBoundFloat), getDecimalPlaces(this.upperBoundFloat) );
  ;
  var result = '';
  for ( var i = 0; i < intPlaces; i++ )
    result += '9';
  result += '.';
  for ( var i = 0; i < decPlaces; i++ )
    result += '9';
  ;
  return result;
}
function getDecimalPlaces( value )
{
  var pos = value.toString().indexOf('.');
  if( pos == -1 )
    return 0;
  else
    return value.toString().length - ( pos + 1 );
}
function getIntegerPlaces( value )
{
  var pos = value.toString().indexOf('.');
  if( pos == -1 )
    return value.toString().length;
  else
    return pos;
}
