/*
<DEPENDENCIES>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Point</DEPENDS>
</DEPENDENCIES>
*/
DropDownSelection.prototype = new DomletCtr();
DropDownSelection.prototype.constructor = DropDownSelection;
DropDownSelection.superclass = DomletCtr.prototype;
var staticProductDropDown = new Array;
ProductDropDown_getInstance = function(sId)
{
	var Instance = null;
	if (staticProductDropDown[sId])
	{
		Instance = staticProductDropDown[sId];
	}
	return Instance;
}
function DropDownSelection(sId, sWidgetDomId, sWidgetDropControllerDomId,
						 sWidgetDisplayTextDomId, sWidgetOptionContainerDomId, sWidgetOptionsDomId,
						 sMenuOpenedPictureSrc, sMenuClosedPictureSrc, iTextDisplayWidth, bIsSingleSelect)
{
	if (sId)
	{
		this.init(sId, sWidgetDomId, sWidgetDropControllerDomId, sWidgetDisplayTextDomId, sWidgetOptionContainerDomId,
				sWidgetOptionsDomId, sMenuOpenedPictureSrc, sMenuClosedPictureSrc, iTextDisplayWidth, bIsSingleSelect);
	}
}
DropDownSelection.prototype.init = function(sId, sWidgetDomId,
										  sWidgetDropControllerDomId, sWidgetDisplayTextDomId,
										  sWidgetOptionContainerDomId, sWidgetOptionsDomId,
										  sMenuOpenedPictureSrc, sMenuClosedPictureSrc,
										  iTextDisplayWidth, bIsSingleSelect)
{
	;
	this.sId = sId;
	this.sWidgetDomId = sWidgetDomId;
	this.nameRoot = 'root';
	this.sWidgetDisplayTextDomId = sWidgetDisplayTextDomId;
	this.nameTextField = 'text-field';
	this.sWidgetDropControllerDomId = sWidgetDropControllerDomId;
	this.nameDropController = 'drop-controller';
	this.sWidgetOptionContainerDomId = sWidgetOptionContainerDomId;
	this.nameOptionContainer = 'options-container';
	this.sWidgetOptionsDomId = sWidgetOptionsDomId;
	this.nameOptions = 'options';
	this.sMenuOpenedPictureSrc = sMenuOpenedPictureSrc;
	this.sMenuClosedPictureSrc = sMenuClosedPictureSrc;
	this.textDisplayWidth = iTextDisplayWidth;
	this.isSingleSelect = bIsSingleSelect;
	this.nTimeout = 500;
	this.timeoutId = null;
	this.model = null;
	staticProductDropDown[sId] = this;
	DropDownSelection.superclass.init.call(this, sWidgetDomId, sId, this);
	this.aSetAllHandles = new Array();
	this.aResetHandles = new Array();
	if (this.isSingleSelect) 
	{
		this.addDomlet(new Domlet(
				this.sWidgetDomId, 
				this.nameRoot, 
				this, 
				new Array('click', 'mouseover', 'mouseout')) 
				)
		this.addDomlet(new Domlet(
				this.sWidgetDropControllerDomId, 
				this.nameDropController, 
				this, 
				new Array()) 
				)
		this.addDomlet(new Domlet(
				this.sWidgetDisplayTextDomId, 
				this.nameTextField, 
				this, 
				new Array()) 
				)
		this.addDomlet(new Domlet(
				this.sWidgetOptionsDomId, 
				this.nameOptions, 
				this, 
				new Array('click')) 
				)
		this.addDomlet(new Domlet(
				this.sWidgetOptionContainerDomId, 
				this.nameOptionContainer, 
				this, 
				new Array('mouseover', 'mouseout')) 
				)
	}
	else
	{
		this.addDomlet(new Domlet(
				this.sWidgetDomId, 
				this.nameRoot, 
				this, 
				new Array()) 
				)
		this.addDomlet(new Domlet(
				this.sWidgetDropControllerDomId,
				this.nameDropController,
				this,
				new Array('click', 'mouseover', 'mouseout'))
				)
		this.addDomlet(new Domlet(
				this.sWidgetDisplayTextDomId,
				this.nameTextField,
				this,
				new Array('click', 'mouseover'))
				)
		this.addDomlet(new Domlet(
				this.sWidgetOptionContainerDomId,
				this.nameOptionContainer,
				this,
				new Array('mouseover', 'mouseout'))
				)
	}
	Browser.changePixelStyle(this.getTextDisplayNode(), "width", this.textDisplayWidth);
	this.domlets[this.nameOptionContainer].setVisible(false);
}
DropDownSelection.prototype.start = function()
{
	
	var point = new Point(0, 0);
	Browser.getAbsPos(this.getRootNode(), point);
	var pointContainer = new Point(0, 0);
	if ('ie' == Browser.getId())
		pointContainer.y += parseInt(this.getTextDisplayNode().offsetHeight) + 2 + point.y;
	else
		pointContainer.y += parseInt(this.getTextDisplayNode().offsetHeight) + point.y;
	pointContainer.x = point.x;
	Browser.moveTo(this.getOptionContainerNode(), pointContainer);
	this.selectionModelChanged(this.model);
}
DropDownSelection.prototype.getId = function()
{
	return this.sId;
}
DropDownSelection.prototype.setSelectionModel = function(model)
{
	this.model = model;
}
DropDownSelection.prototype.setBroker = function(broker)
{
	this.broker = broker;
}
DropDownSelection.prototype.reset = function()
{
	if (this.model && this.model.reset)
		this.model.reset();
	this.notifyListeners(this.aResetHandles);
}
DropDownSelection.prototype.getResetAction = function()
{
	return new ObjectMethodAction(this, "reset");
}
DropDownSelection.prototype.addResetHandle = function(action)
{
	if (action)
		this.aResetHandles.push(action);
}
DropDownSelection.prototype.setAll = function()
{
	if (this.model && this.model.setAll)
		this.model.setAll();
	this.notifyListeners(this.aSetAllHandles);
}
DropDownSelection.prototype.getSetAllAction = function()
{
	return new ObjectMethodAction(this, "setAll");
}
DropDownSelection.prototype.addSetAllHandle = function(action)
{
	if (action)
		this.aSetAllHandles.push(action);
}
DropDownSelection.prototype.setValue = function(value)
{
	if (!value)
		this.getTextDisplayNode().value = '';
	else
		this.getTextDisplayNode().value = value;
}
DropDownSelection.prototype.getSetValueAction = function(value)
{
	return new ObjectMethodAction(this, "setValue", value);
}
DropDownSelection.prototype.selectionModelChanged = function(model)
{
	var values;
	if (model)
		values = model.getActiveValues();
	else if (this.model)
		values = this.model.getActiveValues();
	else
		values = new Array();
	var text = null;
	for (var i = 0; i < values.length; i++)
	{
		if (!text)
			text = values[i].getValue();
		else
			text += ', ' + values[i].getValue();
	}
	if (!text)
		text = '';
	this.getTextDisplayNode().value = text;
}
DropDownSelection.prototype.eventFromChild = function(childName, eventType, event)
{
	var domlet = this.domlets[childName];
	switch (eventType)
			{
		case "click" :
			this.clickHandler(domlet, event);
			break;
		case "mouseover" :
			this.mouseoverHandler(domlet, event);
			break;
		case "mouseout" :
			this.mouseoutHandler(domlet, event);
			break;
	}
}
DropDownSelection.prototype.clickHandler = function(domlet, event)
{
	if (Browser.getId() == 'ie')
	{
		Browser.eventStopPropagation(event);
		Browser.eventPreventDefault(event);
	}
	this.showmenu();
}
DropDownSelection.prototype.mouseoverHandler = function(domlet, event)
{
	if (this.timeoutId)
	{
		clearTimeout(this.timeoutId);
		this.timeoutId = null;
	}
}
DropDownSelection.prototype.mouseoutHandler = function(domlet, event)
{
	if (this.timeoutId)
	{
		clearTimeout(this.timeoutId);
	}
	this.timeoutId = window.setTimeout('ProductDropDown_getInstance(\'' + this.sId
			+ '\').showmenu(true, false);', this.nTimeout);
}
DropDownSelection.prototype.showmenu = function(bNotSwapMenu, bsetMenuOpen)
{
	if (bNotSwapMenu)
	{
		if (bsetMenuOpen)
		{
			this.domlets[this.nameOptionContainer].setVisible(true);
			this.domlets[this.nameDropController].setImageSource(this.sMenuOpenedPictureSrc);
			this.bProductDropDownMenuOpen = true;
		}
		else
		{
			this.domlets[this.nameOptionContainer].setVisible(false);
			this.domlets[this.nameDropController].setImageSource(this.sMenuClosedPictureSrc);
			this.bProductDropDownMenuOpen = false;
		}
	}
	else
	{
		if (this.bProductDropDownMenuOpen)
		{
			this.domlets[this.nameOptionContainer].setVisible(false);
			this.domlets[this.nameDropController].setImageSource(this.sMenuClosedPictureSrc);
			this.bProductDropDownMenuOpen = false;
		}
		else
		{
			this.domlets[this.nameOptionContainer].setVisible(true);
			this.domlets[this.nameDropController].setImageSource(this.sMenuOpenedPictureSrc);
			this.bProductDropDownMenuOpen = true;
		}
	}
}
DropDownSelection.prototype.getRootNode = function()
{
	if (!this.rootNode)
		this.rootNode = document.getElementById(this.sWidgetDomId);
	if (!this.rootNode)
		;
	return this.rootNode;
}
DropDownSelection.prototype.getDropControllerNode = function()
{
	if (!this.dropControllerNode)
		this.dropControllerNode = document.getElementById(this.sWidgetDropControllerDomId);
	if (!this.dropControllerNode)
		;
	return this.dropControllerNode;
}
DropDownSelection.prototype.getTextDisplayNode = function()
{
	if (!this.textDisplayNode)
		this.textDisplayNode = document.getElementById(this.sWidgetDisplayTextDomId);
	if (!this.textDisplayNode)
		;
	return this.textDisplayNode;
}
DropDownSelection.prototype.getOptionContainerNode = function()
{
	if (!this.optionContainerNode)
		this.optionContainerNode = document.getElementById(this.sWidgetOptionContainerDomId);
	if (!this.optionContainerNode)
		;
	return this.optionContainerNode;
}
DropDownSelection.prototype.notifyListeners = function(handles)
{
	for (var i = 0; i < handles.length; i++)
	{
		handles[i].invoke();
	}
}
