/*
<DEPENDENCIES>
	<DEPENDS>Logger</DEPENDS>
	<DEPENDS>Actions</DEPENDS>
	<DEPENDS>LocationService</DEPENDS>
	<DEPENDS>SCORMAPIWrapper</DEPENDS>
	<DEPENDS>LMSSuspendDataSerializer</DEPENDS>
</DEPENDENCIES>
*/
function LMSConnectorManagerSCORM()
{
	;
    setTopWindow(parent.window);
	this.suspendDataSerializer = null;
	this.startDate = 0;
	this.structureName = null;
	this.achievementService = null;
	this.structureService = null;
	this.evaluationService = null;
	this.locationService = null;
	this.connected = false;
	this.score = new ScoreStatistics(0,0,0,0,1);
	this.sessiontime = '00:00:00.0';
	this.finished = false;  
	this.finishSend = false;
}
LMSConnectorManagerSCORM.LMS_SCORE = "cmi.core.score.raw";
LMSConnectorManagerSCORM.LMS_SCORE_MIN = "cmi.core.score.min";
LMSConnectorManagerSCORM.LMS_SCORE_MAX = "cmi.core.score.max";
LMSConnectorManagerSCORM.LMS_USER_ID = "cmi.core.student_id";
LMSConnectorManagerSCORM.LMS_USER_NAME = "cmi.core.student_name";
LMSConnectorManagerSCORM.LMS_ENTRY = "cmi.core.entry";
LMSConnectorManagerSCORM.LMS_CREDIT = "cmi.core.credit";
LMSConnectorManagerSCORM.LMS_STATUS = "cmi.core.lesson_status";
LMSConnectorManagerSCORM.LMS_SESSIONTIME = "cmi.core.session_time";
LMSConnectorManagerSCORM.LMS_TOTALTIME = "cmi.core.total_time";
LMSConnectorManagerSCORM.LMS_LOCATION = "cmi.core.lesson_location";
LMSConnectorManagerSCORM.LMS_SUSPEND_DATA = "cmi.suspend_data";
LMSConnectorManagerSCORM.LMS_EXIT ="cmi.core.exit";
LMSConnectorManagerSCORM.prototype.start= function() {
	
	serviceregistry.registerService('lmsconnector', this);
}
LMSConnectorManagerSCORM.prototype.initConnector= function() {
	;
	if (this.locationService.isInitialized()
		&& this.achievementService.isInitialized()
		&& this.propertyService.isInitialized()
		&& this.linkService.isInitialized()
	)
    {
    	var result = doLMSInitialize();
		if (result == "true")
		{
			this.connected = true;
			
			var suspenddata = doLMSGetValue(LMSConnectorManagerSCORM.LMS_SUSPEND_DATA);
			;
			;
			this.deserializeSuspendData(suspenddata);
			
			var credit = doLMSGetValue(LMSConnectorManagerSCORM.LMS_CREDIT);
			;
			
			this.sessionstatus = doLMSGetValue(LMSConnectorManagerSCORM.LMS_STATUS);
			;
			if (this.sessionstatus != "browsed")
			{
				this.sessionstatus = "incomplete";
				doLMSSetValue(LMSConnectorManagerSCORM.LMS_STATUS, this.sessionstatus);
			}
			var lastVisitedLocation = doLMSGetValue(LMSConnectorManagerSCORM.LMS_LOCATION);
			if (lastVisitedLocation)
			{
				lastVisitedLocation = decodeURIComponent(lastVisitedLocation);
				this.setInitialLastVisitedLocation(lastVisitedLocation);
			}
			;
			
			;
			;
			
			doLMSSetValue( LMSConnectorManagerSCORM.LMS_SCORE_MIN, "0" );
			;
			doLMSSetValue( LMSConnectorManagerSCORM.LMS_SCORE_MAX, "100" );
			;
			var result = doLMSCommit();
			;
			
			this.startDate = new Date().getTime();
			this.startWBT();
		}
    }
}
LMSConnectorManagerSCORM.prototype.initLastVistedLocation= function(location) {
	var lastloc = this.locationService.getLocationNameByIndex(location);
	if (!lastloc)
		lastloc = this.locationService.getLocationNameByIndex(0);
	parent.frames['mainframe'].location.replace(lastloc);
}
LMSConnectorManagerSCORM.prototype.startWBT = function()
{
	var startloc = this.locationService.getStartLocation();
    parent.frames['mainframe'].location.replace(startloc);
}
LMSConnectorManagerSCORM.prototype.setStructureName= function(structureName) {
	;
	this.structureName = structureName;
}
LMSConnectorManagerSCORM.prototype.setAchievementService= function(achievementService) {
	;
	this.achievementService = achievementService;
	
    this.achievementService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerSCORM.prototype.setStructureService= function(structureService) {
	;
	this.structureService = structureService;
}
LMSConnectorManagerSCORM.prototype.setEvaluationService= function(evaluationService) {
	;
	this.evaluationService = evaluationService;
}
LMSConnectorManagerSCORM.prototype.setLocationService= function(locationService) {
	;
	this.locationService = locationService;
	
	this.locationService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerSCORM.prototype.setPropertyService= function(propertyService) {
	;
	this.propertyService = propertyService;
	
	this.propertyService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerSCORM.prototype.setLinkService= function(linkService) {
	;
	this.linkService = linkService;
	
	this.linkService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerSCORM.prototype.sendFinish= function() {
	;
	this.finishSend = true;
	if (this.connected)
	{
    	if (this.finished)
    	{
    		doLMSSetValue(LMSConnectorManagerSCORM.LMS_EXIT, "" );
    	}
    	else
    	{
    		
    		doLMSSetValue(LMSConnectorManagerSCORM.LMS_EXIT, "suspend" );
    	}
    	var result = doLMSFinish();
	}
}
LMSConnectorManagerSCORM.prototype.finishConnection= function() {
	;
	if (this.connected)
	{
    	if (!this.finishSend)
    	{
    		this.sendData();
    		this.sendFinish();
    	}
	}
}
LMSConnectorManagerSCORM.prototype.notifyFinished= function(timeout) {
	;
	this.finished = true;
}
LMSConnectorManagerSCORM.prototype.retrieveAchievementData= function() {
	;
	var root = this.structureService.getRoot(this.structureName);
	if (root)
	{
		var myscore = this.achievementService.getScoreStatisticsTrace(this.structureName, root.getContentId());
		if (myscore)
			this.score = myscore;
	}
}
LMSConnectorManagerSCORM.prototype.setLastVisitedLocation= function(folderId, entryId) {
	if (entryId)
	{
		var folder =
		        this.structureService.getStructureEntry(this.structureName, folderId);
		var structureEntry =
				this.structureService.getStructureEntry(this.structureName, entryId);
		if (folder && structureEntry)
		{
			this.locationService.setLastVistedLocation(folder, structureEntry);
		}
		else if (structureEntry)
		{
			
			this.locationService.setInitialLastVisitedLocation(structureEntry.getURL());
		}
	}
}
LMSConnectorManagerSCORM.prototype.setInitialLastVisitedLocation= function(url) {
	if (url)
	{
		this.locationService.setInitialLastVisitedLocation(url);
	}
}
LMSConnectorManagerSCORM.prototype.sendData= function() {
	;
	if (this.connected)
	{
		
		var lastVisitedLocation = '';
		if (this.locationService.hasLastVistedLocation())
		{
			lastVisitedLocation = this.locationService.getLastVistedLocation();
			lastVisitedLocation = encodeURIComponent(lastVisitedLocation);
		}
		doLMSSetValue( LMSConnectorManagerSCORM.LMS_LOCATION, lastVisitedLocation);
        ;
		
		doLMSSetValue( LMSConnectorManagerSCORM.LMS_SESSIONTIME, this.getSessiontime());
		;
		
		doLMSSetValue( LMSConnectorManagerSCORM.LMS_SCORE, this.getScoreData());
		;
		
		doLMSSetValue( LMSConnectorManagerSCORM.LMS_SUSPEND_DATA, this.serializeSuspendData());
		;
		
        doLMSSetValue( LMSConnectorManagerSCORM.LMS_STATUS, this.getLessonStatus());
        ;
		
		var result = doLMSCommit();
        ;
        ;
		if (this.finished)
			this.sendFinish();
	}
}
LMSConnectorManagerSCORM.prototype.getSuspendDataSerializer = function()
{
	if (this.suspendDataSerializer == null)
		this.suspendDataSerializer =
				new LMSSuspendDataSerializer(this.evaluationService, this.locationService, this.structureName, this.structureService);
	return this.suspendDataSerializer;
}
LMSConnectorManagerSCORM.prototype.serializeSuspendData = function()
{
	return this.getSuspendDataSerializer().serializeSuspendData();
}
LMSConnectorManagerSCORM.prototype.deserializeSuspendData = function(serializeddata)
{
	this.getSuspendDataSerializer().deserializeSuspendData(serializeddata);
}
LMSConnectorManagerSCORM.prototype.getScoreData= function() {
	;
	var scoreraw = this.score.getFractionCorrect() * 100;
	scoreraw = Math.round(scoreraw);
	return scoreraw;
}
LMSConnectorManagerSCORM.prototype.getSessiontime= function() {
	var mytime = this.computeTime();
	;
	
	var mytimeparts = mytime.split('.');
	if (mytimeparts && mytimeparts.length==2)
		mytime = mytimeparts[0];
	;
	return mytime;
}
LMSConnectorManagerSCORM.prototype.getLessonStatus= function() {
	;
	return this.sessionstatus;
}
LMSConnectorManagerSCORM.prototype.computeTime = function()
{
   if ( this.startDate != 0 )
   {
      var currentDate = new Date().getTime();
      var elapsedSeconds = (currentDate - this.startDate) / 1000;
      var formattedTime = this.convertTotalSeconds( elapsedSeconds );
   }
   else
   {
      formattedTime = "00:00:00.0";
   }
   return formattedTime;
}
LMSConnectorManagerSCORM.prototype.convertTotalSeconds =  function (ts)
{
   var sec = (ts % 60);
   ts -= sec;
   var tmp = (ts % 3600);  
   ts -= tmp;              
   sec = Math.round(sec*100)/100;
   var strSec = new String(sec);
   var strWholeSec = strSec;
   var strFractionSec = "";
   if (strSec.indexOf(".") != -1)
   {
      strWholeSec =  strSec.substring(0, strSec.indexOf("."));
      strFractionSec = strSec.substring(strSec.indexOf(".")+1, strSec.length);
   }
   if (strWholeSec.length < 2)
   {
      strWholeSec = "0" + strWholeSec;
   }
   strSec = strWholeSec;
   if (strFractionSec.length)
   {
      strSec = strSec+ "." + strFractionSec;
   }
   if ((ts % 3600) != 0 )
      var hour = 0;
   else var hour = (ts / 3600);
   if ( (tmp % 60) != 0 )
      var min = 0;
   else var min = (tmp / 60);
   if ((new String(hour)).length < 2)
      hour = "0"+hour;
   if ((new String(min)).length < 2)
      min = "0"+min;
   var rtnVal = hour+":"+min+":"+strSec;
   return rtnVal;
}
LMSConnectorManagerSCORM.prototype.trim = function(inputString) {
   if (typeof inputString != "string") { return inputString; }
   var retValue = inputString;
   var ch = retValue.substring(0, 1);
   while (ch == " ") { 
      retValue = retValue.substring(1, retValue.length);
      ch = retValue.substring(0, 1);
   }
   ch = retValue.substring(retValue.length-1, retValue.length);
   while (ch == " ") { 
      retValue = retValue.substring(0, retValue.length-1);
      ch = retValue.substring(retValue.length-1, retValue.length);
   }
   while (retValue.indexOf("  ") != -1) { 
      retValue = retValue.substring(0, retValue.indexOf("  ")) + retValue.substring(retValue.indexOf("  ")+1, retValue.length); 
   }
   return retValue; 
}
